2011-12-01  Werner Koch  <wk@g10code.com>

	NB: ChangeLog files are no longer manually maintained.  Starting
	on December 1st, 2011 we put change information only in the GIT
	commit log, and generate a top-level ChangeLog file from logs at
	"make dist".  See doc/HACKING for details.

2011-11-30  Werner Koch  <wk@g10code.com>

        * keyserver.c (keyserver_import_cert): Adjust for changed
	get_dns_cert.

2011-11-28  Werner Koch  <wk@g10code.com>

	* keyserver.c (DEFAULT_MAX_CERT_SIZE): Increase from 16k to 64k.

2011-11-22  Werner Koch  <wk@g10code.com>

	* pubkey-enc.c (get_session_key): Don't print anonymous recipient
	messages in quiet mode.  This is bug#1378.

2011-11-06  Werner Koch  <wk@g10code.com>

	* card-util.c (generate_card_keys): Add arg CTRL.

	* call-agent.c (agent_readkey): New.
	* keygen.c (do_create_from_keygrip): New.
	(ask_algo): Add arg R_KEYGRIP and a prompt to enter it.
	(generate_subkeypair): Call do_create_from_keygrip if required.
	(generate_subkeypair): Add arg CTRL.  Change caller.
	(ask_algo): Add arg CTRL.
	(generate_keypair): Ditto.

2011-09-23  Werner Koch  <wk@g10code.com>

	* gpgv.c (disable_dotlock): Rename to dotlock_disable.
	(create_dotlock): Rename to dotlock_create.
	(destroy_dotlock): Rename to dotlock_destroy.
	(make_dotlock): Rename to dotlock_take.
	(release_dotlock): Rename to dotlock_release.
	(lockfiles_remove): Rename to dotlock_remove_lockfiles.

2011-09-20  Werner Koch  <wk@g10code.com>

	* free-packet.c (free_public_key): Allow a NULL argument.
	* keyedit.c (keyedit_passwd): No more need to check that PK is NULL.
	(menu_addrevoker): Ditto.
	* passphrase.c (passphrase_get, passphrase_to_dek_ext): Ditto.
	* skclist.c (release_sk_list): Ditto.
	* revoke.c (gen_desig_revoke): Ditto.
	* pubkey-enc.c (get_session_key): Ditto.
	* pkclist.c (build_pk_list): Ditto.

2011-09-20  Jim Meyering  <meyering@redhat.com>

	avoid use of freed pointer
	If we free pk2 at the top of the for-loop, set it to NULL
	so that we don't free it again just before returning.
	* revoke.c (gen_desig_revoke): Don't use pk2 after freeing it.

2011-09-20  Werner Koch  <wk@g10code.com>

	* sign.c (sign_file, clearsign_file, sign_symencrypt_file):
	s/gcry_md_start_debug/gcry_md_debug/ in preparation for Libgcrypt
	1.6.
	* mainproc.c (proc_plaintext, proc_tree): Ditto.
	* decrypt-data.c (decrypt_data): Ditto.
	* cipher.c (write_header): Ditto.

2011-08-10  Werner Koch  <wk@g10code.com>

	* export.c (transfer_format_to_openpgp): Don't parse unneeded CSUM.

	* import.c (import_secret_one): Use arg OPTIONS instead of global
	import options var.

	* sig-check.c (do_check): Remove unused var CTX.

	* build-packet.c (do_user_id): Return value.

2011-07-29  Werner Koch  <wk@g10code.com>

	* tdbio.c (open_db): Do not print read-only warning in quiet mode.

2011-07-18  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_key): Print the decoded iteration count.
	Fixes bug#1355.

2011-07-07  Werner Koch  <wk@g10code.com>

	* card-util.c (ask_card_keysize): Bump key size limit to 4096.
	* call-agent.c (scd_genkey_parm_s): New.
	(agent_scd_genkey): Use new struct.
	(scd_genkey_cb): Implement chunked mode for KEY-DATA.
	(scd_genkey_cb_append_savedbytes): New.

2011-06-16  Werner Koch  <wk@g10code.com>

	* card-util.c (ask_card_keysize): Bump key size limit to 4096.
	* call-agent.c (scd_genkey_parm_s): New.
	(agent_scd_genkey): Use new struct.
	(scd_genkey_cb): Implement chunked mode for KEY-DATA.
	(scd_genkey_cb_append_savedbytes): New.

2011-06-13  Werner Koch  <wk@g10code.com>

	* pkglue.c (mpi_from_sexp): Use GCRYMPI_FMT_USG to avoid problems
	with leading zeroed.  The latest Libgcrypt does this now
	correctly.  Given that the default of gcry_sexp_nth_mpi would use
	a signed MPI, which is not implemented, the assertion would fail.

2011-06-01  Marcus Brinkmann  <mb@g10code.com>

	* parse-packet.c (parse_pubkeyenc): Change type of N to size_t.
	(parse_key): Likewise.
	* seskey.c (encode_session_key): Convert nframe to int for
	debugging.
	* build-packet.c (gpg_mpi_write): Change type of N to unsigned int.
	* import.c (transfer_secret_keys): Likewise.

2011-04-29  Werner Koch  <wk@g10code.com>

	* keydb.c (keydb_get_keyblock, keydb_add_resource): Use gpg_error.
	(keydb_get_keyblock): Return VALUE_NOT_FOUND instead of -1.
	(keydb_update_keyblock, keydb_insert_keyblock)
	(keydb_delete_keyblock): Ditto.
	(keydb_locate_writable): Ditto.
	(keydb_search_reset): Ditto.
	(keydb_search2): Return GPG_ERR_NOT_FOUND instead of -1.  Change
	all callers.
	(keydb_search_first, keydb_search_next, keydb_search_kid)
	(keydb_search_fpr): Ditto.

2011-04-29  Marcus Brinkmann  <marcus@g10code.com>

	* import.c (import_secret_one): Leave all checks to import_one.
	Cancel secret key import if public key was skipped due to
	merge-only request.  Fix import status for non-new secret key
	import by checking stat counter.

2011-04-29  Marcus Brinkmann  <marcus@g10code.com>

	* delkey.c (do_delete_key): Access public keyblock even for secret
	key operations.  But deleting secret key is not supported yet, so
	give an error.  Limit secret-key-exists error case to public keys.

2011-04-28  Werner Koch  <wk@g10code.com>

	* ecdh.c (pk_ecdh_encrypt_with_shared_point): Remove memory leak
	of SECRET_X in the error case.  Replace an assert by an error
	return.

2011-04-26  Werner Koch  <wk@g10code.com>

	* export.c (transfer_format_to_openpgp): Do not apply
	encode_s2k_iterations to S2K_COUNT.

2011-04-25  Werner Koch  <wk@g10code.com>

	* delkey.c (do_delete_key): Mark classify_user_id for use with
	OpenPGP.
	* trustdb.c (register_trusted_key): Ditto.
	* revoke.c (gen_revoke): Ditto.
	* keyserver.c (keyserver_export, keyidlist, keyserver_export): Ditto.
	* getkey.c (key_byname): Ditto.
	* export.c (do_export_stream): Ditto.

2011-04-20  Marcus Brinkmann  <mb@g10code.com>

	* keylist.c (list_keyblock_colon): Use get_ownertrust_info, not
	get_ownertrust (which lead to binary zeroes in the output!).

2011-03-23  Werner Koch  <wk@g10code.com>

	* parse-packet.c (read_rest): Drop unsed PARTIAL arg.  Rewrite to
	detect premature EOF.  Suggested by Timo Schulz.

2011-03-10  Werner Koch  <wk@g10code.com>

	* passphrase.c (hash_passphrase): Remove.
	(passphrase_to_dek_ext): Use gcry_kdf_derive.

2011-03-03  Werner Koch  <wk@g10code.com>

	* keylist.c (print_card_key_info): Re-implement using the agent.
	* card-util.c (card_status) [GNUPG_MAJOR_VERSION!=1]: Call
	print_card_key_info.

	* keyid.c (hash_public_key): Remove shadowing NBITS.

	* misc.c (pubkey_nbits): Replace GCRY_PK_ by PUBKEY_ALGO_.
	(get_signature_count): Remove warning.

	* armor.c (armor_filter): Don't take a copy of radbuf while
	writing the checksum.  This works around a faulty gcc 4.4 warning.

2011-03-02  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_scd_pksign, agent_scd_pkdecrypt)
	(hash_algo_option): Remove these unused functions.

2011-02-10  Werner Koch  <wk@g10code.com>

	* seskey.c (encode_md_value): Change last fix to avoid a
	regression for DSA with SHA-2 hashes.

2011-02-09  Werner Koch  <wk@g10code.com>

	* keyserver.c: Replace all printf by es_printf.

2011-02-08  Werner Koch  <wk@g10code.com>

	* call-dirmngr.c (gpg_dirmngr_ks_fetch): New.
	* keyserver.c (keyserver_fetch): Rewrite to use dirmngr.

2011-02-07  Werner Koch  <wk@g10code.com>

	* seskey.c (encode_md_value): Truncate to MDLEN and not to QBYTES
	which makes a difference with 521 bit ECC keys.  For clarity
	rename QBYTES to QBITS and adjust accordingly.

2011-02-04  Werner Koch  <wk@g10code.com>

	* sig-check.c (do_check_messages): Remove the long deprecated
	SIGEXPIRED status line.

2011-02-03  Werner Koch  <wk@g10code.com>

	* export.c (transfer_format_to_openpgp) [!HAVE_GCRY_PK_GET_CURVE]:
	Fix syntax error.

	* decrypt-data.c: Include status.h.
	(decrypt_data): Emit a DECRYPTION_INFO status line.

	* misc.c (has_invalid_email_chars): Relax mailbox name checking.
	Fixes bug#1315.

	* sign.c (do_sign): Use openpgp_pk_algo_name.

	* keygen.c (ask_algo): Show ECC algos only in expert mode.  Add
	non-combined menu entries for ECDSA and ECDH.
	(ask_key_flags): Use openpgp_pk_algo_name.

2011-02-03  Werner Koch  <wk@g10code.com>

	Finished ECC integration.
	Wrote change description for 2011-01-13.

2011-02-02  Werner Koch  <wk@g10code.com>

	* encrypt.c (write_pubkey_enc_from_list): Don't compute the
	fingerprint.
	* pkglue.c (pk_encrypt): Replace PK_FP by PK and compute the
	fingerprint only when needed.
	* pkglue.h: Include packet.h.

	* import.c (transfer_secret_keys): Make sure keyids are available.

	* keyid.c (hash_public_key): Adjust for the ECC case.

2011-02-01  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Call setup_libgcrypt_logging.

	* import.c (transfer_secret_keys): Implement ECC case.
	(one_mpi_from_pkey): New.
	* export.c (transfer_format_to_openpgp): Ditto.
	* keygen.c (gpg_curve_to_oid): New.
	(ecckey_from_sexp): Factor curve name mapping out to new function.

2011-01-31  Werner Koch  <wk@g10code.com>

	* ecdh.c (pk_ecdh_encrypt_with_shared_point): Return an opaque MPI.

	* build-packet.c (mpi_write): Rename to gpg_mpi_write and make global.

2011-01-30  Werner Koch  <wk@g10code.com>

	* keyid.c (keygrip_from_pk): Adjust ECC cases.
	* pkglue.c (pk_verify): Ditto.

	* parse-packet.c (parse_key): Simply ECC case.
	(parse_pubkeyenc): Ditto.

	* misc.c (pubkey_get_npkey): Special case ECC.
	(pubkey_get_nskey): Ditto.
	(mpi_print): Support printing of opaque values.
	(openpgp_oid_to_str): New.
	(pubkey_nbits): For ECC pass curve parameter.

	* ecdh.c (pk_ecdh_default_params): Change to return an opaque MPI.

	* build-packet.c (do_key): Automatically handle real and opaque
	key parameters.
	(write_fake_data): Return an error code.
	(mpi_write): Support writing opaque MPIs.
	(do_pubkey_enc): Simplify ECC handling.

2011-01-28  Werner Koch  <wk@g10code.com>

	* keygen.c (gen_ecc): Rewrite.  Select a named curve and create a
	keyspec based on that.
	(pk_ecc_build_key_params): Remove.
	(get_parameter_algo): Map algo number.
	(ecckey_from_sexp): New.
	* misc.c (map_pk_gcry_to_openpgp): New.

2011-01-25  Werner Koch  <wk@g10code.com>

	* ecdh.c (pk_ecdh_default_params_to_mpi): Remove.
	(pk_ecdh_default_params): Rewrite.  Factor KEK table out to ..
	(kek_params_table): .. here.
	(pk_ecdh_generate_ephemeral_key): New.
	(pk_ecdh_encrypt): Remove.
	(pk_ecdh_encrypt_with_shared_point): Make public.

	* pubkey-enc.c (get_it): Fix assertion.  Use GPG_ERR_WRONG_SECKEY
	instead of log_fatal.  Add safety checks for NFRAME.

	* keygen.c (pk_ecc_keypair_gen): Make static.
	(ask_keysize): Use proper rounding for ECC.
	(pk_ecc_build_key_params): Remove NBITSSTR.

2011-01-20  Werner Koch  <wk@g10code.com>

	* keyserver.c: Rewrite most stuff for use with dirmngr.  Get rid
	of all spawn code.  More work pending.

	* export.c (export_pubkeys_buffer): New.

	* import.c (import_keys_es_stream): New.

	* call-dirmngr.c, call-dirmngr.h: New.
	* gpg.h (server_control_s): Add DIRMNGR_LOCAL.
	* gpg.c: Include call-dirmngr.h.
	(gpg_deinit_default_ctrl): Call gpg_dirmngr_deinit_session_data.

2011-01-13  Andrey Jivsov  <openpgp@brainhub.org>  (wk)

	Integrated ECC support.  Below are the changes finally merged into
	the git master after some cleanup by wk until 2011-02-03.

	* ecdh.c: New.

	* sign.c (mpi_from_sexp): Remove.
	(match_dsa_hash): Uses SHA-512 for ECDSA with 521 bits.
	(hash_for): Support ECDSA.
	(make_keysig_packet): Ditto.

	* seskey.c (encode_session_key): Add arg OPENPGP_PK_ALGO.  Support
	ECDH.
	(encode_md_value): Map pkalgo.  Extend size checks to ECDSA.

	* pubkey-enc.c (get_it): Support ECDH.

	* pkglue.c (mpi_from_sexp): Make global.
	(pk_verify, pk_encrypt, pk_check_secret_key): Support ECC.

	* parse-packet.c (read_size_body): New.
	(parse_pubkeyenc): Support ECC.
	(parse_key): Ditto.

	* misc.c (map_pk_openpgp_to_gcry, map_pk_gcry_to_openpgp): New.
	(openpgp_pk_test_algo, openpgp_pk_test_algo2): Map algo numbers.
	(openpgp_pk_algo_usage): Support ECDH and ECDSA.
	(openpgp_pk_algo_name): Simplify.
	(ecdsa_qbits_from_Q): New.

	* mainproc.c (proc_pubkey_enc): Support ECC.

	* keyid.c (pubkey_letter): Add 'E' and 'e'.
	(keygrip_from_pk): Supporf ECC.

	* keygen.c: Include pkglue.h.
	(ask_algo): Add option 9 for ECDSA and ECDH.
	(ask_keysize): Support ECDSA and ECDH.
	(do_create): Ditto.
	(gen_ecc): New.
	(pk_ecc_build_key_params): New.

	* getkey.c (cache_public_key): Support ECC.

	* encrypt.c (write_pubkey_enc_from_list): Pass PK to PK_ENCRYPT
	and the pkalgo to encode_session_key.

	* build-packet.c (do_key, do_pubkey_enc): Support ECC.
	(write_size_body_mpi): New.

2011-01-06  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Use keyserver_spec_t.

	* options.h (struct opt): Factor definition of struct keyserver
	out to ../common/keyserver.h.
	(keyserver_spec_t): New.

2011-01-21  Werner Koch  <wk@g10code.com>

	* seskey.c (encode_md_value): Truncate the DSA hash again.

	* misc.c (openpgp_pk_algo_name): Always use the gcrypt function.

2010-12-09  Werner Koch  <wk@g10code.com>

	* tdbio.c (tdbio_set_dbname) [W32CE]: Take care of missing errno.
	(strerror) [W32CE]: Dummy replacement.
	(open_db) [W32CE]: Use CreateFile.

2010-12-02  Werner Koch  <wk@g10code.com>

	* misc.c (openpgp_cipher_algo_name): Use gnupg_cipher_algo_name.

2010-11-23  Werner Koch  <wk@g10code.com>

	* Makefile.am (gpg2_LDFLAGS, gpgv2_LDFLAGS): Add extra_bin_ldflags.

	* plaintext.c (handle_plaintext): Change to use estream.
	s/rc/err/.  Replace some xmalloc by xtrymalloc.  Use more
	gpg_strerror.
	* options.h (struct): Change type of OUTFP to estream_t.
	* decrypt.c (decrypt_message_fd): Adjust accordingly.

2010-11-17  Werner Koch  <wk@g10code.com>

	* keyedit.c (find_pk_from_sknode): Remove.
	* misc.c (get_signature_count): Call agent.
	* keygen.c (gen_card_key): Rework.  Remove arg PARA.
	(generate_keypair): Change arg BACKUP_ENCRYPTION_DIR to the flag
	CARD_BACKUP_KEY.
	(pBACKUPENCDIR): Change to pCARDBACKUPKEY.
	(struct output_control_s): Remove struct SEC.  Remove all usages
	of it.
	(gen_card_key_with_backup): Remove arg BACKUP_DIR.

	* call-agent.c (agent_scd_genkey): Remove extra memset.

2010-11-16  Werner Koch  <wk@g10code.com>

	* keygen.c (generate_card_subkeypair): Remove arg SEC_KEYBLOCK and
	change to return an error code.  Rework for removed secring code.
	* card-util.c (card_generate_subkey): Remove arg SEC_KEYBLOCK.
	Return an error code instead of a success flag. Change caller.

2010-10-29  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (select_algo_from_prefs): Make sure the scores can't
	overflow when picking an algorithm (not a security issue since we
	can't pick something not present in all preference lists, but we
	might pick something that isn't scored first choice).

	* pkclist.c (select_algo_from_prefs): Slightly improve the
	handling of MD5 in preference lists.  Instead of replacing MD5
	with SHA-1, just remove MD5 from the list altogether, and let the
	next-highest ranked algorithm be chosen.

2010-10-27  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_expire_interval): Do not print the y2038 if we
	have an unsigned time_t.
	* keyid.c (IS_INVALID_TIME_T): New.
	(mk_datestr): Use it to detect the y2038 problem.

2010-10-26  Werner Koch  <wk@g10code.com>

	* keyedit.c (change_passphrase): Handle the passwd_nonce.
	* call-agent.c (cache_nonce_parm_s): New.
	(cache_nonce_status_cb): Use that new struct.
	(agent_genkey, agent_import_key, agent_export_key, agent_passwd):
	Adjust for that change.

2010-10-25  Werner Koch  <wk@g10code.com>

	* passphrase.c (gpg_format_keydesc): Fix printing of main keyid.

	* keyedit.c (JNLIB_NEED_LOG_LOGV): Define.
	* call-agent.c (agent_passwd): New.

2010-10-21  Werner Koch  <wk@g10code.com>

	* keyedit.c (keyedit_passwd): Simplify.
	(change_passphrase): Return an error code and not the change
	flag.  Remove editing of the keyring.

	* seckey-cert.c: Remove.
	* Makefile.am (gpg2_SOURCES): Remove seckey-cert.c

	* revoke.c (gen_revoke): Check that the secret key is available.

2010-10-20  Werner Koch  <wk@g10code.com>

	* verify.c (verify_signatures): Use gpg_strerror on open failure
	for consistency of error messages.

	* packet.h (PKT_public_key): s/mdc_feature/flags.mdc/.  Change all
	users.
	(PKT_public_key): Split is_disabled into flags.disabled_valid and
	flags.disabled.  Change all users.
	(pk_is_disabled): Adjust for change.
	(PKT_public_key): s/is_primary/flags.primary/. Change all users.
	(PKT_public_key): s/is_revoked/flags.revoked/. Change all users.
	(PKT_public_key): s/maybe_revoked/flags.maybe_revoked/. Change all
	users.
	(PKT_public_key): s/is_valid/flags.valid/. Change all users.
	(PKT_public_key): s/dont_cache/flags.dont_cache/. Change all users.
	(PKT_public_key): s/backsig/flags.backsig/. Change all users.

	* sign.c (openpgp_card_v1_p): New.
	(hash_for): Re-implement test for v1 cards.
	* packet.h (PKT_public_key): Add field serialno and
	flags.serialno_valid.
	* free-packet.c (release_public_key_parts): Free serialno.

	* parse-packet.c (parse_key): Cast -1 to size_t.
	* trustdb.c (validate_keys): Cast -1 to size_t.  Suggested by
	Steven M. Schweda.

2010-10-18  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_scd_pksign): Replace sprintf by bin2hex.
	(agent_scd_pkdecrypt, agent_pksign): Ditto.

	* sign.c (do_sign): Remove warning and commented old code.

2010-10-14  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_genkey): Add arg NO_PROTECTION.
	* keygen.c (do_create, gen_elg, gen_dsa, gen_rsa, common_gen): Add
	arg KEYGEN_FLAGS.
	(read_parameter_file): Add options no-protection and transient-key.
	(KEYGEN_FLAG_NO_PROTECTION, KEYGEN_FLAG_TRANSIENT_KEY): New.
	(gen_rsa, gen_dsa, gen_elg): Use transient-key.

2010-10-13  Werner Koch  <wk@g10code.com>

	* call-agent.c (start_agent): Send option agent-awareness.
	(status_sc_op_failure): Take care of GPG_ERR_FULLY_CANCELED.
	* passphrase.c (passphrase_get): Ditto.
	* import.c (transfer_secret_keys): Ditto.
	* card-util.c (write_sc_op_status): Ditto.

	* getkey.c (enum_secret_keys): Rewrite.

	* pubkey-enc.c (get_session_key): Skip keys without an encryption
	capability.  Handle GPG_ERR_FULLY_CANCELED.
	* gpg.c: Add option --try-secret-key.
	* options.h (struct opt): Add field secret_keys_to_try.

	* passphrase.c (next_to_last_passphrase): Remove.

2010-10-12  Werner Koch  <wk@g10code.com>

	* keygen.c (generate_subkeypair): Check availibility of secret parts.

	* keylist.c (print_card_serialno): Change to take a hexified serialno.
	(list_keyblock_print): Print serialno and stub key indicators.
	(list_keyblock_colon): Ditto.

	* getkey.c (have_any_secret_key): Remove.  Replace all calls by
	agent_probe_any_secret_key.
	* gpgv.c (agent_probe_any_secret_key): New.
	(agent_get_keyinfo): New.

2010-10-08  Werner Koch  <wk@g10code.com>

	* gpg.c: Add option --with-keygrip.
	* options.h (struct opt): Add WITH_KEYGRIP.
	* keylist.c (list_keyblock_print, list_keyblock_colon): Implement
	new option.

2010-10-06  Werner Koch  <wk@g10code.com>

	* import.c (transfer_secret_keys): Ignore missing key parameters.
	Provide dummy IV.  Ignore stub keys.

2010-10-01  Werner Koch  <wk@g10code.com>

	* export.c (do_export_stream): Rewrite to take the secret keys
	from the agent.
	(canon_pubkey_algo, transfer_format_to_openpgp): New.

2010-09-29  Werner Koch  <wk@g10code.com>

	* keygen.c (key_from_sexp): Fix memory leak in the error case.

	* call-agent.c (agent_export_key): New.

2010-09-29  Werner Koch  <wk@g10code.com>

	* build-packet.c (build_packet): Fix up the pkttype.

	* keyid.c (keystr_with_sub): Make SUB_KID optional.
	(keystr_from_pk_with_sub): Ditto.

	* call-agent.c (agent_scd_pksign): Add missing space.

	* mainproc.c (struct mainproc_context): Add field CTRL.
	(proc_packets): Add arg CTRL.  Change all callers.
	(proc_signature_packets, proc_signature_packets_by_fd)
	(proc_encryption_packets): Add arg CTRL.  Change all callers.
	* compress.c (handle_compressed): Ditto.
	* getkey.c (get_pubkey_byname): Ditto.
	* keyserver.c (keyserver_spawn, keyserver_work): Ditto.
	(show_prompt, keyserver_export, keyserver_import)
	(keyserver_import_fprint, keyserver_import_keyid)
	(keyserver_refresh, keyserver_search, keyserver_fetch)
	(keyserver_import_name, keyserver_search_prompt)
	(keyserver_import_pka, keyserver_import_cert): Ditto.
	callers.
	* verify.c (verify_signatures, verify_files): Ditto.
	* sign.c (sign_file): Ditto.
	* encrypt.c (encrypt_crypt, encrypt_crypt_files): Ditto.
	* pkclist.c (find_and_check_key, build_pk_list): Ditto.
	* keylist.c (locate_one, public_key_list, secret_key_list): Ditto.
	* card-util.c (fetch_url, card_edit): Ditto.
	* import.c (check_prefs, import_one, revocation_present): Ditto.
	* keyedit.c (menu_addrevoker, keyedit_menu): Ditto.
	* decrypt-data.c (decrypt_data): Ditto.
	* decrypt.c (decrypt_message, decrypt_messages)
	(decrypt_message_fd): Ditto.
	* gpgv.c (main): Add CTRL structure.

2010-09-28  Werner Koch  <wk@g10code.com>

	* options.h (struct opt): Remove SIMPLE_SK_CHECKSUM.

	* export.c (parse_export_options): Remove option
	export-resert-subkey-passwd.
	(do_export_stream, do_export, export_pubkeys)
	(export_pubkeys_stream, export_seckeys, export_secsubkeys): Add
	arg CTRL.  Change all callers.

	* call-agent.c (hash_algo_option): New.
	(agent_scd_pksign): Use it.

2010-09-17  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_probe_any_secret_key): New.

2010-09-28  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: Make the example for force-v3-sigs match
	reality (it has defaulted to off since 2007-10-25).

2010-09-06  Werner Koch  <wk@g10code.com>

	* card-util.c (card_status): Remove stub creation for GnuPG >= 2.
	(card_store_subkey): Temporary disable this code.

	* keyedit.c (show_key_with_all_names): Merge secret and public key
	parts.
	(show_basic_key_info): Ditto.
	* delkey.c (do_delete_key): Ditto.
	* export.c (subkey_in_list_p, exact_subkey_match_p): Ditto.
	(new_subkey_list_item): Ditto.
	* keyid.c (keystr_from_sk, keystr_from_sk_with_sub)
	(keyid_from_sk, nbits_from_sk, datestr_from_sk)
	(expirestr_from_sk, colon_datestr_from_sk, fingerprint_from_sk)
	(serialno_and_fpr_from_sk, do_fingerprint_md_sk): Remove.
	* import.c (print_import_ok): Remove arg SK.
	(import_secret_one): Adjust for seckey_info format.
	(transfer_secret_keys): Ditto.  Use gpg_format_keydesc.
	(sec_to_pub_keyblock): Simplify.
	(pub_to_sec_keyblock): Remove.
	(auto_create_card_key_stub): Remove - not anymore needed.
	(update_sec_keyblock_with_cardinfo): Remove.
	(import_secret_one): Use arg option instead of the global option.
	* free-packet.c (copy_public_key): Adjust for seckey_info format.
	(copy_public_parts_to_secret_key, copy_secret_key)
	(cmp_secret_keys, cmp_public_secret_key): Remove.
	* passphrase.c (gpg_format_keydesc): Add arg MODE and change all
	callers.
	* keyring.c (keyring_search): Remove special case for secret keys.
	* mainproc.c (struct mainproc_context): Remove unused field
	LAST_SECKEY.
	* parse-packet.c (parse_key): Rewrite to cope with new seckey_info
	format.
	* build-packet.c (do_public_key, do_secret_key): Merge code into ...
	(do_key): .. new.  Cope with seckey_info format.

2010-09-03  Werner Koch  <wk@g10code.com>

	* packet.h (struct seckey_info): New.
	(PKT_public_key): Increase size of PKEY to allow storing of secret
	keys.  Add field SECKEY_INFO.
	(PKT_secret_key): Remove.
	* free-packet.c (release_public_key_parts): Take care of change.
	(release_secret_key_parts, free_secret_key): Remove.

2010-09-02  Werner Koch  <wk@g10code.com>

	* import.c (transfer_secret_keys, import_secret_one): Enable stats.
	(import_secret_one): Enable secret key merging.

2010-09-01  Werner Koch  <wk@g10code.com>

	* sign.c (do_sign, write_signature_packets, complete_sig): Add arg
	CACHE_NONCE.
	(make_keysig_packet): Ditto.
	* keygen.c (make_backsig, write_direct_sig, write_selfsigs)
	(write_keybinding): Add arg CACHE_NONCE.
	(do_generate_keypair): Use cache_nonce to avoid a pinentry for the
	self-signatures.

	* passphrase.c (gpg_format_keydesc): Remove now superfluous
	algo_name fallback.

	* keygen.c (gen_elg, gen_dsa, gen_rsa, do_create, common_gen): Add
	arg CACHE_NONCE_ADDR.
	(generate_subkeypair): Pass NULL for CACHE_NONCE_ADDR.
	(do_generate_keypair): Add cache nonce handling.

	* import.c (transfer_secret_keys): Support a cache nonce.
	* call-agent.c (cache_nonce_status_cb): New.
	(agent_genkey, agent_import_key): Add arg CACHE_NONCE_ADDR.
	(agent_pksign): Ditto.

2010-08-30  Werner Koch  <wk@g10code.com>

	* keyid.c (KEYID_STR_SIZE): New
	(keystr): Use snprintf and new macro.
	(keystr_with_sub): New.
	(keystr_from_sk_with_sub): New.
	(keystr_from_pk_with_sub): New.

2010-08-27  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Change scope of CTRL to the entire function.

	* import.c (import_secret_one, import, import_keys_internal)
	(import_keys, import_keys_stream): Add arg CTRL.
	* call-agent.c (agent_keywrap_key): New.
	(agent_import_key, inq_import_key_parms): New.

2010-08-26  Werner Koch  <wk@g10code.com>

	* misc.c (openpgp_pk_algo_name): New.
	(openpgp_md_algo_name): New.

2010-08-24  Werner Koch  <wk@g10code.com>

	* options.h (IMPORT_SK2PK): Remove.
	* import.c (parse_import_options): Turn convert-sk-to-pk into a
	dummy option.
	(sec_to_pub_keyblock): Use modern functions.

2010-08-16  Werner Koch  <wk@g10code.com>

	* gpg.c (list_config, gpgconf_list): Use es_printf.
	(print_hex, print_hashline, print_algo_numbers)
	(print_algo_names): Use es_printf.

2010-07-20  Werner Koch  <wk@g10code.com>

	* mainproc.c (print_pkenc_list): Write a STATUS_ERROR.  Fixes
	bug#1255.

2010-06-17  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Use CAST5 as default s2k algo.  The macro
	USE_CAST5 was only used with GnuPG 1.x.

2010-06-07  Werner Koch  <wk@g10code.com>

	* cpr.c: Use estream for status output.

2010-05-12  Werner Koch  <wk@g10code.com>

	* armor.c (radix64_read): Extended 2006-04-28 fix to fix bug#1179.

	* plaintext.c (handle_plaintext): Check return code of fflush.
	Fixes bug#1207.

2010-05-07  Werner Koch  <wk@g10code.com>

	* import.c (fix_bad_direct_key_sigs): New.
	(import_one): Call it.
	(chk_self_sigs): Re-indent, slighly re-arrange code, use test
	macros for the sig class.  Check direct key signatures.  Fixes
	bug#1223.

2010-04-27  Werner Koch  <wk@g10code.com>

	* passphrase.c (gpg_format_keydesc): New.
	* pubkey-enc.c (get_it): Use it.
	* sign.c (do_sign): Use it.

2010-04-26  Werner Koch  <wk@g10code.com>

	* keygen.c (keygen_set_std_prefs): Explicitly include Z0 in the
	default preferences if no compression algorithms are available.
	Remove a possible trailing space in the dummy_string.

2010-04-23  Werner Koch  <wk@g10code.com>

	* pubkey-enc.c (get_it): Use the agent for decryption.
	* call-agent.c (agent_pkdecrypt, inq_ciphertext_cb): New.

2010-04-22  Werner Koch  <wk@g10code.com>

	* photoid.c (show_photos): Remove arg SK.

	* pubkey-enc.c (get_session_key, get_it): Change to use the public
	key object.
	(get_it):  Remove card related stuff.  Now automagically handled
	by the agent.

	* skclist.c (build_sk_list): Remove UNLOCK arg.

	* keylist.c (print_fingerprint): Remove arg SK.
	* mainproc.c (list_node): Disable listing of secret key packets.

	* keyring.c (struct keyring_name, struct keyring_handle): Remove
	field SECRET.
	(keyring_register_filename, keyring_new, orename_tmp_file)
	(do_copy): Remove arg SECRET.
	* keydb.c (struct resource_item): Remove field SECRET.
	(keydb_add_resource): Remove arg SECRET.
	(keydb_new): Remove code fro secret keyrings.

	* gpg.c (main): Ignore --secret-keyring.  Remove all secret
	keyring related code.

2010-04-21  Werner Koch  <wk@g10code.com>

	* pkclist.c (default_recipient): Change to use public keys.

	* keydb.c (keydb_new): Remove arg SECRET.  Change all callers.

	* getkey.c (get_seckey): Change to take a public key.
	(have_secret_key): Rename to have_any_secret_key and make use of
	the agent.
	(key_byname): Rmemove unused arg SK.
	(get_seckey_byname2): Remove and move code to
	(get_seckey_byname): .. here.  Remove INLOCK arg.
	(get_seckey_bynames): Remove.
	(get_seckey_next): Remove.
	(get_seckey_end): Remove.  Use get_pubkey_end instead.
	(get_seckey_byfprint, get_seckeyblock_byfprint): Change to use
	public keys.
	(seckey_available): Rename to ..
	(have_secret_key_with_kid): .. this and change to employ the
	agent.  Change all callers.
	(sk_from_block): Remove.

	* call-agent.c (agent_probe_secret_key): New.
	(agent_havekey): Remove.
	* gpgv.c (agent_probe_secret_key): New.

	* keyedit.c (keyedit_menu)
	(sign_uids, menu_adduid, menu_deluid, menu_delkey)
	(menu_addrevoker, menu_expire, menu_backsign)
	(menu_set_primary_uid, menu_set_preferences)
	(menu_set_keyserver_url, menu_set_notation, menu_revsig)
	(menu_revuid, menu_revkey, menu_revsubkey): Remove all code to
	manage the secret keyring.

2010-04-20  Werner Koch  <wk@g10code.com>

	* keylist.c (list_keyblock_colon): Print the keygrip.

	* sign.c (do_sign): Call the agent to create the signature.
	(mpi_from_sexp): New.
	* keyid.c (keygrip_from_pk, hexkeygrip_from_pk): New.
	* call-agent.c (agent_pksign): New.

	* pkglue.c (pk_sign): Remove.

	* keygen.c (generate_keypair): Do not ask for a passphrase.

2010-04-15  Werner Koch  <wk@g10code.com>

	* keygen.c (gen_dsa, gen_elg, gen_rsa): Remove args SEC_ROOT, DEK,
	S2K and RET_SK.  Change to use the gpg-agent based key generation.
	Factor common code out to ...
	(common_gen): New.
	(do_create): Remove args SEC_ROOT, DEK, S2K and RET_SK.
	(do_generate_keypair, write_selfsigs, write_direct_sig)
	(write_keybinding, make_backsig): Adjust for above changes.
	(generate_subkeypair): Remove arg SEC_KEYBLOCK.
	(genhelp_protect, genhelp_factors): Remove.
	(get_parameter_dek, get_parameter_s2k): Remove.

	* call-agent.c (start_agent): Add dummy arg CTRL.
	(agent_havekey, keyinfo_status_cb, agent_get_keyinfo)
	(agent_genkey): New.

	* seckey-cert.c (check_secret_key): Remove
	(is_secret_key_protected): Take a public key as arg.
	(protect_secret_key): Remove.

	* seskey.c (encode_md_value): Remove SK arg.

2010-04-14  Werner Koch  <wk@g10code.com>

	* cpr.c (myread) [W32CE]: Do not use raise.

	* misc.c (check_compress_algo): Rewrite to handle the new HAVE_ZIP.
	* compress.c (push_compress_filter2): Ditto.
	(init_compress, do_compress, init_uncompress, do_uncompress)
	(compress_filter) [!HAVE_ZIP]: Do not build.
	* main.h (DEFAULT_COMPRESS_ALGO): Depend on HAVE_ZIP.
	* keygen.c (keygen_set_std_prefs): Use check_compress_algo also
	for ZIP and ZLIB.

	* Makefile.am (install-exec-hook) [W32CE]: New.
	(bin_PROGRAMS) [W32CE]: Do not build gpgv2.
	(gpg2_LDADD): Add extra_syslibs.

2010-04-06  Werner Koch  <wk@g10code.com>

	* openfile.c (mkdir): Remove.
	(try_make_homedir): Use gnupg_mkdir.

2010-04-01  Werner Koch  <wk@g10code.com>

	Use gpg_err_set_errno to set ERRNO.

2010-03-26  Werner Koch  <wk@g10code.com>

	* signal.c (pause_on_sigusr): Remove.  It was used in ancient gpg
	version with shared memory IPC.  Last caller removed on	2006-04-18.

2010-03-24  Werner Koch  <wk@g10code.com>

	* openfile.c (CMP_FILENAME): Depend on HAVE_DOSISH_SYSTEM instead
	of HAVE_DRIVE_LETTERS.

2010-03-15  Werner Koch  <wk@g10code.com>

	* card-util.c: Replace stdio by estream.
	* keylist.c: Ditto.

2010-03-12  Werner Koch  <wk@g10code.com>

	* plaintext.c (setup_plaintext_name): Do not encode pipe like
	filenames.  This helps with bug#1201.

	* seckey-cert.c (do_check): Return GPG_ERR_CANCELED.
	* keyedit.c (change_passphrase): Add arg R_ERR.
	(keyedit_passwd): Return the correct error or emit a success
	status message.

2010-03-11  Werner Koch  <wk@g10code.com>

	* misc.c (mpi_print): Change to take a estream_t arg.

	* parse-packet.c (listfp): Change to an estream_t.  Change all
	users to use estream functions.

	* kbnode.c (dump_kbnode): Change to use log functions.
	* pkclist.c (do_show_revocation_reason): Ditto

	* armor.c (parse_header_line): Replace print_string by
	es_print_sanitized.
	(fake_packet): Ditto.
	* keyedit.c (print_and_check_one_sig_colon): Ditto.
	(show_key_with_all_names_colon): Ditto.
	(ask_revoke_sig): Ditto.
	* keylist.c (list_keyblock_colon): Ditto.
	* mainproc.c (print_userid, list_node): Ditto.
	* trustdb.c (dump_key_array): Ditto.
	* gpg.c (list_config): ditto.

	* gpg.c: Include "asshelp.h".
	(main): Remove assuan_set_assuan_log_prefix.  Add
	assuan_set_log_cb.
	* server.c (gpg_server): Remove assuan_set_log_stream.

2010-03-10  Werner Koch  <wk@g10code.com>

	* Makefile.am (needed_libs): Remove libjnlib.a.

	* main.h: Remove "estream.h".

2010-03-08  Werner Koch  <wk@g10code.com>

	* main.h: Include "estream.h"
	* openfile.c (open_outfile): Replace dup/iobuf_fdopen by
	iobuf_fdopen_nc.
	* mainproc.c (proc_signature_packets_by_fd): Return error on
	memory failure.
	* plaintext.c (hash_datafile_by_fd): Ditto.
	* verify.c (gpg_verify): Use iobuf_fdopen_nc.  Change OUT_FP to an
	estream_t.
	* server.c (cmd_verify): Do not dup the fds.

	Use macros for iobuf_ioctl commands.

2010-02-17  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_user_id): Avoid infinite loop in case of invalid
	data.  Fixes bug#1186.

2010-02-02  Werner Koch  <wk@g10code.com>

	* keyedit.c (keyedit_menu): Change prompt to "gpg".
	* card-util.c (card_edit): Change prompt to "gpg/card".

2010-01-11  Werner Koch  <wk@g10code.com>

	* sign.c (only_old_style, write_onepass_sig_packets, hash_for)
	(write_signature_packets, print_status_sig_created)
	(clearsign_file, make_keysig_packet, mk_notation_policy_etc)
	(complete_sig, do_sign, update_keysig_packet): Replace all
	secret key access by the matching public key.
	* keylist.c (print_seckey_info): Ditto.
	* revoke.c (gen_desig_revoke): Ditto.
	* skclist.c (release_sk_list): Ditto.
	* keyedit.c (sign_uids): Ditto.
	* misc.c (get_signature_count): Ditto.
	* main.h (struct expand_args): s/sk/pksk/.  Change all users.

	* keyedit.c (keyedit_passwd): Finish implementation.

2010-01-10  Werner Koch  <wk@g10code.com>

	* skclist.c (GCRYCTL_FAKED_RANDOM_P): Remove because we require
	libgcrypt 1.4.
	(is_insecure, key_present_in_sk_list): Work with public keys.
	(build_sk_list): Change to work on public keys.
	* keydb.h (struct sk_list): Replace field SK by a PK field.

	* keylist.c (list_keyblock_print): Always look for the public key
	and ignore all secret key packets.
	(list_keyblock_colon): Ditto.
	(print_capabilities): Remove arg SK and all secret key stuff.
	Adjust all callers.
	(dump_attribs): Ditto.

	* getkey.c (getkey_bynames, getkey_next, get_pubkey_end): New.
	(getkey_byname): New.
	(getkey_ctx_s): Add WANT_SECRET.
	(key_byname): Set it.
	(merge_keys_and_selfsig): Remove all the secret key merging.
	(lookup): Simplify by removing secret key code.

	* keylist.c (list_all): Scan public keys and use have_secret_key
	to filter secret keys.
	(list_one): Use the new get_key functions.

	* gpg.h (kbnode_t): Add as alias for KBNODE.
	* keydb.h (getkey_ctx_t): Add as alias for GETKEY_CTX.

2010-01-09  Werner Koch  <wk@g10code.com>

	* getkey.c, keylist.c: Re-indent.

2010-01-08  Werner Koch  <wk@g10code.com>

	* cpr.c (write_status_error): Rename to write_status_errcode.
	Change all callers.
	(write_status_error): New.

	* gpg.c: Add option --passwd.
	(aPasswd): New.
	(main): Implement.
	* keyedit.c (keyedit_passwd): New.

	* gpg.c (oPasswd, oPasswdFD, oPasswdFile, oPasswdRepeat): Change
	to oPassphrase, oPassphraseFD, oPassphraseFile, oPassphraseRepeat.
	* options.h (struct): s/passwd_repeat/passphrase_repeat/.
	* gpg.c (main): Ditto.
	* passphrase.c (passphrase_to_dek_ext): Ditto.

2009-12-21  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_get_s2k_count): New.
	* gpg.c (main):  Set s2k_count to 0.
	* (encode_s2k_iterations): Move ...
	* passphrase.c (encode_s2k_iterations): ... here.  Call
	agent_get_s2k_count if called with a 0 arg.
	(passphrase_to_dek_ext): Set S2K_COUNT via encode_s2k_iterations.

2009-12-17  Werner Koch  <wk@g10code.com>

	* sig-check.c (do_check_messages): Evaluate the HAS_EXPIRED flag.
	Fixes bug#1059.

	* gpg.c: Add new option --faked-system-time.

2009-12-15  Werner Koch  <wk@g10code.com>

	* keydb.c (keydb_add_resource): s/readonly/read_only/g.
	* keyring.c (keyring_register_filename): Ditto.

	* tdbio.c (tdbio_set_dbname): Do not call log_fatal after creating
	the directory.  Fixes bug#1169.  Reported by Daniel Leidert.

2009-12-08  Werner Koch  <wk@g10code.com>

	* keyring.h: Include userids.h.
	* gpg.h (KEYDB_SEARCH_DESC): Remove.
	* packet.h: Include userids.h.
	(PKT_user_id): Declare using gpg_pkt_user_id_s.
	* keydb.h (KeydbSearchMode, struct keydb_search_desc): Remove.  We
	now use those in ../kbx.
	* getkey.c (classify_user_id): Remove.  It is now in common/.
	(key_byname): Adjust for changed classify_user_id.
	* delkey.c (do_delete_key): Ditto.
	* trustdb.c (register_trusted_key): Ditto.
	* revoke.c (gen_desig_revoke, gen_revoke): Ditto.
	* keyserver.c (parse_keyrec, keyserver_export, keyserver_import)
	(keyidlist): Ditto.
	* export.c (do_export_stream): Ditto.

	* pkclist.c (find_and_check_key): Replace GPG_ERR_INV_NAME by
	GPG_ERR_INV_USER_ID.

2009-12-04  Werner Koch  <wk@g10code.com>

	* keygen.c (DEFAULT_STD_ALGO, DEFAULT_STD_KEYSIZE): New.
	(ask_keysize): Use new macro.
	(gen_rsa): Set default size if NBITS is 0.
	(get_parameter_algo): Add algo name "default".  Add arg	R_DEFAULT.
	(proc_parameter_file): Process default flag.

2009-12-03  Werner Koch  <wk@g10code.com>

	* gpg.c (set_debug): Allow for numerical debug leveles.  Print
	active debug flags.

2009-11-27  Werner Koch  <wk@g10code.com>

	* keyedit.c (cmds, keyedit_menu): New command "checkbkupkey".

2009-11-25  Marcus Brinkmann  <marcus@g10code.de>

	* server.c (gpg_server): Use assuan_fd_t and assuan_fdopen on fds.

2009-11-23  Werner Koch  <wk@g10code.com>

	* gpg.c (gpgconf_list): Add key "default_pubkey_algo".

2009-11-18  Werner Koch  <wk@g10code.com>

	* gpg.c: Add option --skip-hidden-recipients and no- variant.
	* options.h (struct opt): Add field SKIP_HIDDEN_RECIPIENTS.
	* pubkey-enc.c (get_session_key): Implement that option.

2009-11-04  Werner Koch  <wk@g10code.com>

	* server.c (register_commands): Add NULL arg to
	assuan_register_command.

2009-11-02  Marcus Brinkmann  <marcus@g10code.de>

	* server.c (reset_notify, input_notify, output_notify): Update to
	new assuan interface.
	(register_commands): Use assuan_handler_t.

2009-10-19  Werner Koch  <wk@g10code.com>

	* options.h (glo_ctrl): Add field LASTERR.
	* mainproc.c (proc_encrypted): Set LASTERR.
	* server.c (cmd_decrypt): Check LASTERR.

2009-10-02  Werner Koch  <wk@g10code.com>

	* server.c (cmd_encrypt, cmd_decrypt): Implement.
	* decrypt.c (decrypt_message_fd): New.
	* options.h (struct opt): Add field OUTFP.
	* plaintext.c (handle_plaintext): Support opt.outfp.

	* encr-data.c: Rename to decrypt-data.c to reflect the action and
	not the processed packet type.

2009-10-02  Werner Koch  <wk@g10code.com>

	* encr-data.c (decode_filter_context_s): Add fields PARTIAL and
	LENGTH.
	(decrypt_data): Set them.  Simplify premature EOF detection.
	(mdc_decode_filter): Take fixed length packets in account.
	(decode_filter): Ditto.  Better EOF detection.
	* parse-packet.c (parse_encrypted): Store ed->LEN without the MDC
	version byte.

2009-09-30  Werner Koch  <wk@g10code.com>

	* parse-packet.c (skip_packet, parse_gpg_control) <list_mode>: Take
	care of premature EOFs.

	* gpg.c (main): Remove obsolete GCRYCTL_DISABLE_INTERNAL_LOCKING.

2009-09-29  Werner Koch  <wk@g10code.com>

	* openfile.c (open_outfile): Re-indent.  Use xstrconcat.
	(NAME_OF_DEV_NULL): New.
	(open_outfile): Use it.
	(overwrite_filep): Use it.  Also use case insensitive compare
	when needed.  Re-indent.
	(open_outfile): Add arg INP_FD.  Change all callers.

	* encrypt.c (encrypt_crypt): Add new args FILEFD, OUTPUTFD and
	PROVIDED_KEYS.  Change all callers.

2009-09-28  Werner Koch  <wk@g10code.com>

	* server.c (skip_options, has_option): New.
	(cmd_recipient): Implement.

	* keydb.h (pk_list_t): New.

	* pkclist.c (send_status_inv_recp): New.  Replace direct calls.
	(build_pk_list): Factor some code out to ...
	(find_and_check_key): ... new.

	* encode.c: Rename to encrypt.c.  Re-indent all.
	* encrypt.c (encode_symmetric, encode_store, encode_seskey)
	(encode_simple, encode_crypt, encode_filter)
	(encode_crypt_files): Rename all to encrypt_*.  Change all callers.

	* trustdb.c (get_validity_info): Take care of a NULL PK.  Fixes
	bug#1138.
	(get_validity_string): Ditto.

2009-09-25  Werner Koch  <wk@g10code.com>

	* pkglue.c (pk_sign, pk_verify, pk_encrypt, pk_decrypt)
	(pk_check_secret_key): Allow deprecated RSA identifiers 2 and 3.
	Fixes bug#1139.

2009-09-23  Marcus Brinkmann  <marcus@g10code.de>

	* call-agent.c: Include "scdaemon.h" before <assuan.h> because of
	GPG_ERR_SOURCE_DEFAULT check.
	(learn_status_cb, dummy_data_cb, get_serialno_cb, default_inq_cb)
	(learn_status_cb, inq_writecert_parms, inq_writekey_parms)
	(scd_genkey_cb, membuf_data_cb): Return gpg_error_t instead of
	int.
	* gpg.c: Include "scdaemon.h" before <assuan.h> because of
	GPG_ERR_SOURCE_DEFAULT check.
	(main): Update to new Assuan API.
	* server.c: Include "scdaemon.h" before <assuan.h> because of
	GPG_ERR_SOURCE_DEFAULT check.
	(option_handler, cmd_recipient, cmd_signer, cmd_encrypt)
	(cmd_decrypt, cmd_verify, cmd_sign, cmd_import, cmd_export)
	(cmd_delkeys, cmd_message, do_listkeys, cmd_listkeys)
	(cmd_listsecretkeys, cmd_genkey, cmd_getinfo): Return gpg_error_t
	instead of int.
	(register_commands): Allocate assuan context before starting
	server.
	(gpg_server): Allocate assuan_context before starting server.

2009-09-04  Werner Koch  <wk@g10code.com>

	* keyedit.c (menu_select_uid): Use IDX ==-1 t select all.
	(menu_select_key): Ditto.
	(keyedit_menu) <cmdSELKEY, cmdSELUID>: Allow '*' to select all.

2009-09-03  Werner Koch  <wk@g10code.com>

	* keyedit.c (menu_adduid): Pass keyblock to generate_user_id.
	* keygen.c (generate_user_id): Add arg KEYBLOCK.  Factor code out
	to ...
	(uid_from_string): ... new.
	(ask_user_id): Add arg KEYBLOCK and check for duplicates.  Fix
	bug#1122.

	* Makefile.am (uninstall-local): New.

	* compress-bz2.c (do_uncompress): Detect unexpected EOF.  Fix
	bug#1011.

2009-08-26  Werner Koch  <wk@g10code.com>

	* keyedit.c (menu_revsig): Check for signature right away.  Fix
	Debian-bug#543530.

2009-08-20  Daiki Ueno  <ueno@unixuser.org>

	* mainproc.c (proc_encrypted): Clear passphrase cached with S2K
	cache ID if decryption failed.
	* passphrase.c (passphrase_to_dek_ext): Set dek->s2k_cacheid.
	* gpgv.c (passphrase_clear_cache): New stub.

2009-08-11  Werner Koch  <wk@g10code.com>

	* call-agent.c (get_serialno_cb): New.  From ../agent/call-scd.c.
	(gpg_agent_get_confirmation): New.
	(select_openpgp): New.
	(agent_scd_pkdecrypt, agent_scd_pksign): Use it here.

2009-08-06  Werner Koch  <wk@g10code.com>

	* skclist.c (build_sk_list): Print INV_SGNR status line.
	* seckey-cert.c (do_check): Return G10ERR_UNU_SECKEY instead of
	general error.

2009-08-05  Werner Koch  <wk@g10code.com>

	* card-util.c: Enable readline support also in GnuPG-2.

	* call-agent.c (agent_learn): Always select the card first.

	* gpg.c: Add --key-edit alias.

	* call-agent.c (scd_genkey_cb): Forward progress status lines.

	* card-util.c (generate_card_keys): Remove special case for
	GnuPG-2.  Ask for the keysize and change it.
	(card_generate_subkey): Ask for the keysize and change it.
	(get_info_for_key_operation): Read KEY-ATTR.
	(show_keysize_warning, ask_card_keysize): New.
	(do_change_keysize): New.

2009-07-31  David Shaw  <dshaw@jabberwocky.com>

	* gpg.c (main): --pgp6 includes --disable-mdc.

2009-07-23  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_import_ldap): Try a DNS-SD lookup to find
	a domain-specific LDAP server before resorting to keys.{domain}.

2009-07-22  Werner Koch  <wk@g10code.com>

	* card-util.c (generate_card_keys): Ask for off-card keys only if
	the card supports it.
	(get_info_for_key_operation): Read EXTCAP.
	(card_store_subkey): Check for non matching sizes.

	* call-agent.h (struct agent_card_info_s): Add field EXTCAP.
	* call-agent.c (agent_learn): Use a direct SCD command.
	(did_early_card_test): New.
	(start_agent): Perform an early test for the card.  Add arg FOR_CARD.
	(status_sc_op_failure): New.
	(agent_scd_setattr, agent_scd_writekey, agent_scd_genkey)
	(agent_scd_pksign, agent_scd_pkdecrypt, agent_scd_change_pin)
	(agent_scd_checkpin): Call new function.
	(learn_status_cb): Parse KEY_TIME and EXTCAP.

	* gpg.c (main) <aFixTrustDB>: Show commands to run.
	* trustdb.c (how_to_fix_the_trustdb): New.
	* tdbio.c (tdbio_invalid): Show commands to re-create the trustdb.
	Fixes bug#929.

2009-07-20  Werner Koch  <wk@g10code.com>

	* keygen.c (generate_keypair): Allow Elgamal > 3072 in BOTH mode.
	Reported by Jeroen Schot.  Fixes bug#1091.

2009-07-17  Werner Koch  <wk@g10code.com>

	* keyring.c (keyring_rebuild_cache): Replace the assert by a
	proper error message and allow to delete a bad keyblock.

2009-07-13  Werner Koch  <wk@g10code.com>

	* exec.c: Fix function name indentation.
	(expand_args): Simplify by using membuf functions.
	(exec_write): Fix memory leak on error.
	(w32_system): Use DETACHED_PROCESS so that a new console is not
	created.

2009-07-09  Werner Koch  <wk@g10code.com>

	* card-util.c (card_store_subkey): Do not restrict to 1024 bit keys.
	Print an error message on write errors.

	* gpg.c (main): Remove the SHA-1 default from the personal digest
	list.  This was used in the past as a hack to avoid preferring
	RMD-160.

	* keygen.c (keygen_set_std_prefs): Remove RMD-160 from the list.
	Change order to SHA-256, SHA-1, SHA-384, SHA-512, SHA-224.
	(gen_dsa): Use a 256 bit Q for 2048 bit P.  Round to FIPS allowed
	values in non-expert mode.

2009-07-07  Werner Koch  <wk@g10code.com>

	* gpg.c (set_opt_session_env): New.
	(main): Allocate opt.session_env.  Use it for oDisplay, oTTYname,
	oTTYtype and oXauthority.

	* options.h: Include session_env.h.
	(opt): Add field SESSION_ENV, remove obsolete fields.

	* call-agent.c (start_agent): Adjust start_new_gpg_agent for
	changed args.

2009-06-24  Werner Koch  <wk@g10code.com>

	* keyedit.c (menu_select_key): Remove dead assign to I.
	(menu_select_uid): Ditto.
	* keyring.c (keyring_search): Remove dead assign to NAME.
	* card-util.c (card_edit): Remove useless DID_CHECKPIN.
	* call-agent.c (unhexify_fpr): Remove dead op on N.
	* passphrase.c (passphrase_to_dek_ext): Do not deref a NULL PW.
	* revoke.c (gen_revoke): Remove unused malloc of PK.
	* parse-packet.c (mpi_read): Init NREAD.
	Reported by Fabian Keil.

2009-06-17  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse): Use a casted -1 instead of a 32 bit
	constant to check for a garbled package.  Fixes bug#1040.

	* card-util.c (put_data_to_file, read_cert): New.
	(card_edit): Add command "readcert".
	(fetch_url): Allow code also for this gnupg major version 2.
	* call-agent.c (agent_scd_readcert): New.

2009-06-15  Werner Koch  <wk@g10code.com>

	* keyserver.c (keyserver_search_prompt): No prompt in batch+colons
	mode.

2009-06-09  Werner Koch  <wk@g10code.com>

	* card-util.c (write_sc_op_status): New.
	(change_pin): Use it.
	(change_url, change_login, change_private_do, change_cert)
	(change_lang, change_sex, change_cafpr, toggle_forcesig)
	(check_pin_for_key_operation): Ditto.

2009-06-05  David Shaw  <dshaw@jabberwocky.com>

	* gpg.c (main), misc.c (openpgp_cipher_test_algo): Remove Camellia
	restriction.

	* misc.c (map_cipher_openpgp_to_gcry), main.h: Add macros for
	openpgp_cipher_open, openpgp_cipher_get_algo_keylen, and
	openpgp_cipher_get_algo_blklen to wrap around the corresponding
	gcry_* functions, but pass the algorithm number through
	map_cipher_openpgp_to_gcry.  This is needed in case the gcry
	algorithm number doesn't match the OpenPGP number (c.f. Camellia).

	* encr-data.c, pubkey-enc.c, mainproc.c, cipher.c, encode.c,
	seskey.c, passphrase.c, seckey-cert.c: Use new openpgp_cipher_*
	macros here.

2009-06-02  Werner Koch  <wk@g10code.com>

	* card-util.c (get_manufacturer): Add new manufacturer.

2009-05-26  Werner Koch  <wk@g10code.com>

	* parse-packet.c (mpi_read): Workaround for zero-length MPI bug in
	libgcrypt<1.5.0.

2009-05-22  Werner Koch  <wk@g10code.com>

	* signal.c (got_fatal_signal): Call new function
	tty_cleanup_after_signal.

2009-05-20  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Fix --fingerprint/--with-fingerprint command
	detection.  Fixes bug#1044.

	* keygen.c (ask_keysize): Allow selection of DSA key size even
	without --enable-dsa2.
	(gen_dsa): Remove size check.

	* keygen.c (ask_key_flags): Fix bug in the translation check.
	Fixes bug#1056.

2009-05-18  Daiki Ueno  <ueno@unixuser.org>  (wk)

	* encode.c (encode_simple): Tell passphrase_to_dek to cache
	the passphrase.
	(setup_symkey): Ditto.
	* mainproc.c (proc_symkey_enc): Tell passphrase_to_dek to cache
	the passphrase.
	(proc_encrypted): Ditto.
	* passphrase.c (hash_passphrase): Remove arg CREATE.
	(passphrase_to_dek): New mode 3 and 4 for caching passphrase for
	symmetric encryption.

2009-05-17  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_algo): Add arg R_SUBKEY_ALGO.  Change return value
	semantics.  Change presented order of algorithms.  Make RSA+RSA
	the default.
	(generate_keypair): Adjust for change.
	(ask_keysize): Add arg PRIMARY_KEYSIZE for subkey creation.
	Change callers.

2009-05-15  Werner Koch  <wk@g10code.com>

	* keygen.c (gen_card_key_with_backup): Get the size of the key
	from the card.
	* call-agent.h (struct agent_card_info_s): Add field KEY_ATTR.
	* call-agent.c (learn_status_cb): Support KEY-ATTR.
	* card-util.c (card_status): Print key attributes.

2009-05-15  Marcus Brinkmann  <marcus@g10code.de>

	* gpg.c (gpgconf_list): Remove dead entry "allow-pka-lookup" (a
	verify option for a couple of years now).

2009-05-14  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_get_passphrase): Add arg CHECK.
	* passphrase.c (passphrase_get): Pass new arg.

	* keygen.c (gen_card_key_with_backup): Print a status error.
	(do_generate_keypair): Ditto.
	(do_ask_passphrase): Add arg MODE.
	(generate_raw_key): Call with mode 1.
	* passphrase.c (ask_passphrase): Remove becuase it is not used.
	(passphrase_to_dek): Factor code out to ...
	(passphrase_to_dek_ext): .. New.  Add args CUSTDESC and CUSTPROMPT.

2009-05-13  Werner Koch  <wk@g10code.com>

	* keygen.c (parse_expire_string): Base ISO date string at noon.
	Also allow full ISO timestamp.

2009-05-11  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_key): Print the key id in list mode.

	* skclist.c (build_sk_list): Use log_info for "duplicated entry".
	Fixes bug#1045.

	* encode.c (encode_simple): Print empty file warning only in
	verbose mode.  Closes bug#1039.
	(encode_crypt): Ditto.
	* sign.c (write_plaintext_packet): Ditto.

2009-05-10  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_typemap): gpgkeys_hkp handles hkps as
	well.  From 1.4.

2009-05-06  Werner Koch  <wk@g10code.com>

	* getkey.c (finish_lookup): Remove dead code.

	* keyring.c (keyring_get_keyblock): Fix memory leak due to ring
	trust packets.  Fixes bug#1034.

2009-04-03  Werner Koch  <wk@g10code.com>

	* gpgv.c (main): Open keyrings readonly.
	* keydb.c (keydb_add_resource): Add readonly flag bit.
	(keydb_rebuild_caches): Don't act on readonly resources.

	* keyring.c (keyring_register_filename): Add arg READONLY.
	(struct keyring_name): Add field READONLY.
	(keyring_is_writable): Implement readonly feature.
	(keyring_update_keyblock): Return GPG_ERR_EACCES for readonly
	keyrings.
	(keyring_insert_keyblock, keyring_delete_keyblock): Ditto.

2009-04-01  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Properly handle UTF8 usernames with --sign-key and
	--lsign-key.  From 1.4, David 2008-12-21.

2009-03-20  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* keyring.c (rename_tmp_file): Force a fsync (via iobuf_ioctl) on
	secret keyring files to be extra safe on filesystems that may not
	sync data and metadata together (ext4).  Also check return code
	from the cache invalidation to make sure we're safe over NFS and
	similar.

2009-03-31  Werner Koch  <wk@g10code.com>

	* passphrase.c (ask_passphrase): Use percent_plus_unescape.
	* misc.c (unescape_percent_string): Remove.

	* call-agent.c (unescape_status_string): Chnage to use
	percent_plus_unescape.

2009-03-25  Werner Koch  <wk@g10code.com>

	* mainproc.c (print_pkenc_list): Use snprintf.

2009-03-17  Werner Koch  <wk@g10code.com>

	* call-agent.c (my_percent_plus_escape): Remove.
	(agent_get_passphrase): Rewrite using percent_plus_escape.

2009-03-17  Daiki Ueno  <ueno@unixuser.org>

	* passphrase.c (passphrase_get): Add extra arg REPEAT and adjust
	callers; remove special treatment for MODE==2.
	(passphrase_to_dek): Move --passphrase-repeat handling to
	gpg-agent.

	* call-agent.c (agent_get_passphrase): Add extra arg REPEAT.
	* call-agent.h: Ditto.

2009-03-16  Werner Koch  <wk@g10code.com>

	* gpg.c (my_strusage): Revert last change.  Systems w/o a gpg1 may,
	and actually do, install gpg2 as gpg.
	* gpgv.c (my_strusage): Ditto.

2009-03-14  David Shaw  <dshaw@jabberwocky.com>

	* gpg.c (my_strusage): gpg2 and gpgv2 (not gpg and gpgv).
	* gpgv.c (my_strusage): Same.

	* gpgv.c (my_strusage): Fix name of program in "Syntax" line.

2009-02-27  Werner Koch  <wk@g10code.com>

	* call-agent.c (agent_scd_pksign, agent_scd_pkdecrypt): First send
	the SERIALNO command.

2009-02-24  Werner Koch  <wk@g10code.com>

	* pkglue.c (pk_verify): Return an error for improper DATA instead
	of calling BUG().

2009-02-09  Werner Koch  <wk@g10code.com>

	* keylist.c (print_capabilities): Take care of cert-only keys.
	Fixes bug#998.
	* keyedit.c (show_key_with_all_names_colon): Print the capabilities.

2009-01-26  Werner Koch  <wk@g10code.com>

	* card-util.c (card_status): Detect a Geldkarte.

2009-01-13  Werner Koch  <wk@g10code.com>

	* call-agent.c (dummy_data_cb): New.
	(agent_learn): Use it.
	* card-util.c (card_status): Print type of non-OpenPGP card.
	* call-agent.h (agent_card_info_s): Add field APPTYPE.

2009-01-12  Werner Koch  <wk@g10code.com>

	* getkey.c (finish_lookup): Take care of keys with a zero
	timestamp.  Reported by Peter Gutmann.

2009-01-08  Werner Koch  <wk@g10code.com>

	* misc.c (has_invalid_email_chars): Let non-ascii pass through.

	* cpr.c [USE_SHM_COPROCESSING]: Remove this code.

2008-12-12  Werner Koch  <wk@g10code.com>

	* passphrase.c (passphrase_get): Write a STATUS_ERROR.
	* cpr.c (write_status_error): New.

	* Makefile.am (common_source): Add rmd160.h.

2008-12-11  Werner Koch  <wk@g10code.com>

	* sig-check.c (signature_check2): Change algorithm used to compute
	the SIG_ID.
	(check_revocation_keys): Close message digest.

	* rmd160.c, rmd160.h: New.  Based on code from GnuPG-1.4.
	* t-rmd160.c: New.
	* Makefile.am: Add support to run tests.
	* keyid.c (namehash_from_uid): Use rmd160_hash_buffer.

2008-12-10  Werner Koch  <wk@g10code.com>

	* trustdb.h (NAMEHASH_HASH): Remove unsued constant.

	* gpg.c (print_mds): Print RMD160 only is enabled.

	* keygen.c (keygen_set_std_prefs): Include RMD160 only if
	available.

2008-12-09  Werner Koch  <wk@g10code.com>

	* gpg.c (main) [IS_DEVELOPMENT_VERSION]: Fix strusage use.

2008-12-09  Werner Koch  <wk@g10code.com>

	* keygen.c (proc_parameter_file): Check that key and subkey usages
	are allowed.

2008-12-09  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* trustdb.c (validate_one_keyblock): Fix the trust signature
	calculations so that we lower the trust depth of signatures to fit
	within the current chain, rather than discarding any signature
	that does not fit within the trust depth.

2008-12-09  Werner Koch  <wk@g10code.com>

	* keyserver.c (show_prompt): Flush stdout.

	* gpg.c (open_info_file): Add arg BINARY and adjust callers.

	* gpg.c (main): Call i18n_init before init_common_subsystems.
	* gpgv.c (main): Ditto.

	* keylist.c (set_attrib_fd): Do not close ATTRIB_FP if it is the
	log stream.
	(set_attrib_fd) [W32]: Set to binary mode.
	(dump_attribs): Flush the stream after writing.

2008-12-05  Werner Koch  <wk@g10code.com>

	* call-agent.c (percent_plus_escape): Rename to
	my_percent_plus_escape and also escape the percent character.
	Change all callers.

2008-11-18  Werner Koch  <wk@g10code.com>

	* gpg.c (build_lib_list): Remove.
	(make_libversion): New.
	(my_strusage): Use it.
	* gpgv.c (make_libversion): New.
	(my_strusage): Print libgcrypt version.

2008-11-13  Werner Koch  <wk@g10code.com>

	* gpgv.c: Use new ARGPARSE macros and re-indent.

2008-11-11  Werner Koch  <wk@g10code.com>

	* gpg.c (opts): Use new ARGPARSE macros for clarity.

2008-10-24  Werner Koch  <wk@g10code.com>

	* keyedit.c (change_passphrase): Clear passphrase cache.

2008-10-20  Werner Koch  <wk@g10code.com>

	* gpgv.c: Mark all args of the stub fucntions as unused.

	* card-util.c (generate_card_keys): Remove unused arg SERIALNO and
	adjust caller.

	* build-packet.c (write_sign_packet_header): Mark unused arg.
	* gpg.c (gpg_init_default_ctrl, gpg_deinit_default_ctrl): Ditto.
	* getkey.c (skip_unusable): Ditto.
	(write_version): Ditto.
	* keydb.c (keydb_locate_writable): Ditto.
	* keyring.c (update_offset_hash_table): Ditto.
	(keyring_lock): Ditto.
	* misc.c (register_secured_file): Ditto.
	(unregister_secured_file): Ditto.
	(is_secured_file): Ditto.
	(is_secured_filename): Ditto.
	* parse-packet.c (parse_marker): Ditto.
	(parse_key, parse_attribute): Ditto.
	(parse_trust, parse_compressed, parse_mdc, parse_gpg_control): Ditto.
	* cpr.c (progress_cb): Ditto.
	* passphrase.c (passphrase_clear_cache): Ditto.
	(ask_passphrase): Ditto.
	* keyedit.c (keyedit_completion): Ditto.
	* import.c (import_revoke_cert): Ditto.
	(chk_self_sigs, delete_inv_parts, append_uid): Ditto.
	(merge_sigs, merge_keysigs, append_key): Ditto.
	* trustdb.c (list_trust_path): Ditto.
	(enum_cert_paths, enum_cert_paths_print): Ditto.
	* tdbdump.c (list_trustdb): Ditto.
	* keygen.c (keygen_upd_std_prefs): Ditto.
	(genhelp_factors): Ditto.
	* call-agent.c (agent_scd_setattr): Ditto.
	(agent_scd_writekey, agent_scd_change_pin, agent_scd_genkey): Ditto.
	(agent_clear_pin_cache): Ditto.

	* server.c (option_handler): Mark non yet used arg.
	(input_notify, output_notify): Ditto.
	(cmd_recipient, cmd_signer, cmd_encrypt, cmd_decrypt, cmd_verify)
	(cmd_sign, cmd_import, cmd_export, cmd_delkeys, do_listkeys)
	(cmd_genkey): Ditto.
	* verify.c (gpg_verify): Ditto.

2008-10-17  Werner Koch  <wk@g10code.com>

	* main.h (idea_cipher_warn): Use do while construct in place of an
	empty definition.

2008-10-03  David Shaw  <dshaw@jabberwocky.com>

	* main.h, mainproc.c (check_sig_and_print)
	* keylist.c (list_keyblock_print)
	* pkclist.c (do_edit_ownertrust)
	* keyedit.c (menu_showphoto)
	* photoid.c (generate_photo_id, show_photos)
	* misc.c (pct_expando): Add %v and %V expandos so
	 that displaying photo IDs can show the attribute validity
	 tag (%v) and string (%V).  Originally by Daniel Gillmor.

2008-09-29  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Remove -sat kludge.  Note that we printed a
	warning for two years.

	* seskey.c (encode_md_value): Remove extra gcry_md_test_algo since
	it is not needed with Libgcrypt 1.4.
	* skclist.c (random_is_faked): Simplify.
	* sign.c (match_dsa_hash): Remove runtime check for SHA224.
	* gpg.c (print_mds): Use GCRY_MD_SHA224 constant.

2008-09-25  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (keyedit_menu): Fix bug where a modified keyring loses
	its modified status after a "clean" or "minimize" that doesn't
	need to do anything.

2008-09-25  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse): Remove special treatment for compressed
	new style packets.  Fixes bug#931.

	* card-util.c (change_pin): Support setting of the reset code.

2008-09-24  Werner Koch  <wk@g10code.com>

	* call-agent.h (struct agent_card_info_s): Add field IS_V2.
	* call-agent.c (learn_status_cb): That that field.

	* card-util.c (change_pin): Rename first arg to UNBLOCK_v2 and use
	it this way.
	(card_edit): Add new command UNBLOCK.

2008-09-23  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (select_algo_from_prefs): Redo function to rank prefs
	and pick a consensus winner across all keys.

2008-09-16  Werner Koch  <wk@g10code.com>

	* card-util.c (fpr_is_ff): New.
	(card_status): Do not print general key info for an all-ff fpr.
	(change_login, change_private_do): Factor common code out to ...
	(get_data_from_file): .. new.
	(change_cert): New.
	(card_edit): Add command "writecert".
	* call-agent.c (writecert_parm_s): New.
	(inq_writecert_parms, agent_scd_writecert): New.

2008-09-04  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_import_cert): Allow keyserver URLs in
	addition to full URLs in CERT records.

2008-08-11  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_expire_interval): Check for time overflow of an
	u32.  Fixes bug #947.

2008-08-01  Werner Koch  <wk@g10code.com>

	* tdbio.c (open_db) [!EROFS]: Move closing parens out of the
	ifdef.  Reported by Ken Takusagawa.

2008-06-25  Marcus Brinkmann  <marcus@g10code.de>

	* gpg.c (enum cmd_and_opt_values): Remove option
	oEnableW32HandleTranslation.
	(opts): Remove option --enable-w32-handle-translation.
	(main): Remove variable w32_handle_translation.

2008-06-19  Werner Koch  <wk@g10code.com>

	* gpg.c (gpgconf_list): Add "group".

2008-06-18  Marcus Brinkmann  <marcus@g10code.de>

	* gpg.c (enum cmd_and_opt_values): New option
	oEnableW32HandleTranslation.
	(opts): New option --enable-w32-handle-translation.
	(main): New variable w32_handle_translation to keep track of
	option.

2008-06-16  Werner Koch  <wk@g10code.com>

	* keygen.c (output_control_s): Add ASK_PASSPHRASE.
	(read_parameter_file): Add commands %ask-passphrase and
	%no-ask-passphrase.

2008-06-11  Werner Koch  <wk@g10code.com>

	* gpg.c: Make --fixed-list-mode a dummy.
	* options.h (struct): Removed FIXED_LIST_MODE.
	* keyid.c (colon_strtime, colon_datestr_from_pk)
	(colon_datestr_from_sk, colon_datestr_from_sig)
	(colon_expirestr_from_sig): Remove fixed_list_mode case.
	* keylist.c (list_keyblock_colon): Ditto.  Remove all now unsed
	code and reindent.

2008-05-31  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_user_id): Change the string printed as header of
	the user ID generation.  Use code to not break existing
	translations.  Suggested by Eric Tetz.

2008-05-08  Werner Koch  <wk@g10code.com>

	* sig-check.c (do_check_messages): Print a revocation diagnostic
	in verbose mode.

2008-05-07  Werner Koch  <wk@g10code.com>

	* gpg.c: New command --locate-keys.  New options --with-sig-list
	and --with-sig-check.
	* keylist.c (locate_one): New.
	(public_key_list): Add arg LOCATE_MODE and use locate_one.
	* getkey.c (get_pubkey_byname): Fix nodefault case.  Add option
	RETCTX, change all callers.
	(struct getkey_ctx_s): Add field extra_ptr;
	(get_pubkey_end): Free it.

2008-04-18  Werner Koch  <wk@g10code.com>

	* misc.c (map_cipher_openpgp_to_gcry, map_cipher_gcry_to_openpgp)
	(openpgp_cipher_test_algo): Add camellia-192.
	(openpgp_cipher_blocklen): New.
	* parse-packet.c (parse_key): Use new function here.

2008-04-15  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (merge_selfsigs_subkey): If there are multiple 0x19
	backsigs, take the most recent one.

2008-04-08  Werner Koch  <wk@g10code.com>

	* options.h (opt): Add AKL_NODEFAULT and AKL_LOCAL.
	* getkey.c (parse_auto_key_locate): Parse them.
	(get_pubkey_byname): Implement them.  Add arg NO_AKL and use that
	in all cases where a local key is expected.
	* import.c (import_one): Fill in the fingerprint in all cases.
	Use log_get_stream.
	* keyserver.c (keyserver_import_pka): Set FPR to NULL on error.
	Return G10ERR_NO_PUBKEY if no PKA info is available or no key URI
	is given in the PKA record..
	(keyserver_import_cert): Return G10ERR_NO_PUBKEY if a CERT record
	was not found.

	* getkey.c (get_pubkey_byname): Release FPR in the error case.
	Continue with next mechanism on error.  Better diagnostics.

2008-04-07  Werner Koch  <wk@g10code.com>

	* keyserver.c (parse_keyserver_uri): Allow a default host name.

	* getkey.c (get_pubkey_byname): Replace sprintf by bin2hex.

2008-04-02  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Do not allow DSA2 with a too old Libgcrypt.

2008-03-26  Werner Koch  <wk@g10code.com>

	* tdbio.c (lookup_hashtable): Make cmp args const.
	(cmp_trec_fpr): Make FPR const.
	(tdbio_search_trust_byfpr): Remove cast.

2008-03-25  Werner Koch  <wk@g10code.com>

	* keyserver.c (parse_keyrec): Take care of char defaulting to
	unsigned when using hextobyte.

2008-03-25  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* import.c (collapse_uids): Fix bug 894: possible memory
	corruption around deduplication of user IDs.

2008-03-25  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_key): Parse a secret key encrypted with
	Camellia.

	* options.skel: Make the default keyserver keys.gnupg.net.

2008-03-18  Werner Koch  <wk@g10code.com>

	* seckey-cert.c (do_check): Use GCRYMPI_FMT_PGP for v3 keys.
	Reported by Petr Cerny.

2008-03-13  Werner Koch  <wk@g10code.com>

	* passphrase.c (PROMPTSTRING): Change string to me more similar to
	the X.509 prompt.

2008-02-26  Werner Koch  <wk@g10code.com>

	* getkey.c (get_pubkey_byname): Fix comment.

2008-02-14  Werner Koch  <wk@g10code.com>

	* call-agent.c (default_inq_cb): New.
	(agent_learn, agent_scd_getattr, agent_scd_pksign)
	(agent_scd_pkdecrypt, agent_scd_change_pin, agent_scd_checkpin)
	(agent_get_passphrase, agent_clear_passphrase): Use new callback.
	(inq_writekey_parms): Fall back to the new callback for other
	inquiries.
	(start_agent): Tell agent that we accept pinentry notifications.

2008-02-11  Werner Koch  <wk@g10code.com>

	* server.c (cmd_getinfo): New.
	(register_commands): Register GETINFO.

2008-02-09  Marcus Brinkmann  <marcus@g10code.de>

	* gpg.c (main): New variable default_configname.  Use it if
	save_configname is NULL (can happen if default configfile does
	not exist).  Move default configname determination to ...
	(get_default_configname): ... this new function.

2008-01-30  Werner Koch  <wk@g10code.com>

	* keydb.c (maybe_create_keyring): Fixed last change.
	* tdbio.c (tdbio_set_dbname): Also test for forward slash.

2008-01-29  Werner Koch  <wk@g10code.com>

	* keydb.c (maybe_create_keyring): Take care of a missing slash.
	(maybe_create_keyring) [W32]: Also test for forward slash.

2008-01-26  Werner Koch  <wk@g10code.com>

	* card-util.c (get_manufacturer): Add vendor 0004.

2008-01-02  Werner Koch  <wk@g10code.com>

	* gpg.c: Add --logger-file as an alias for log-file.

2007-12-14  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Set opt.no_homedir_creation during the first option
	parsing pass.

2007-12-12  Werner Koch  <wk@g10code.com>

	* misc.c (print_pubkey_algo_note): Print a warning if a type 20
	key is used.
	(openpgp_pk_test_algo, openpgp_pk_test_algo2)
	(openpgp_pk_algo_usage): Allow type 20 keys only in rfc2440 mode.

2007-12-12  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* trustdb.c (sanitize_regexp): New.  Protect against dangerous
	regexps (malloc bombs) by force-commenting any characters aside
	from the ones we explicitly want.
	(check_regexp): Use it here before passing the regexp to
	regcomp().

2007-12-12  Werner Koch  <wk@g10code.com>

	* misc.c (map_cipher_openpgp_to_gcry): New.  Used to map Camellia
	algorithms to Gcrypt.
	(openpgp_cipher_test_algo): Call new map function.  Replace
	all remaining calls to gcry_cipher_test_algo by a call to this.
	(openpgp_cipher_algo_name): New.  Replace all remaining calls to
	gcry_cipher_algo_name by a call to this.
	(map_cipher_gcry_to_openpgp): New.
	(string_to_cipher_algo): Use it.
	* gpg.c	(main): Print a warning if Camellia support is build in.

	* gpg.c (print_algo_names): New.  From the 1.4 branch by David.
	(list_config): Use it here for the "ciphername" and "digestname"
	config items so we can get a script-parseable list of the names.

	* parse-packet.c (parse_onepass_sig): Sigclass is hex, so include
	the 0x.

	* sign.c (match_dsa_hash): Remove conditional builds dending on
	USE_SHAxxx.  We don't need this becuase it can be expected that
	libgcrypt provides it.  However we need to runtime test for SHA244
	becuase that is only available with libgcrypt 2.4.

2007-12-11  Werner Koch  <wk@g10code.com>

	* mainproc.c (proc_pubkey_enc): Allow type 20 Elgamal key for
	decryption.

2007-12-10  Werner Koch  <wk@g10code.com>

	* import.c (auto_create_card_key_stub): Do not clear the entire
	fingerprint.  This finally makes the stub creation work.  My past
	tests seemed to work because there was a key with a all zero
	fingerprint available (Elgamal signing keys).

2007-12-08  Werner Koch  <wk@g10code.com>

	* misc.c (openpgp_pk_algo_usage): Allow Elgamal type 20 for
	encryption.

2007-12-04  Werner Koch  <wk@g10code.com>

	* helptext.c (get_help_from_file): New.
	(display_online_help): Use it to geting the help through a file.
	(helptexts): Remove.

2007-12-03  Werner Koch  <wk@g10code.com>

	* keygen.c (ask_key_flags): Add a translation remark and implement
	a workaround.

	* gpg.c (reopen_std): Moved to ../common and renamed to
	gnupg_reopen_std.

	* gpg.c: Remove second inclusion of fcntl.h.

2007-11-19  Werner Koch  <wk@g10code.com>

	* keyedit.c (keyedit_menu): String grammar fix.

2007-11-15  Werner Koch  <wk@g10code.com>

	* gpg.c (main): New option --xauthority.
	* call-agent.c (start_agent): Adjust changed start_new_gpg_agent.

2007-11-12  Werner Koch  <wk@g10code.com>

	* cpr.c (do_get_from_fd): s/bool/getbool/ to overcome problems
	with Mac OS 10.5 which seems to include stdbool.h silently.

2007-11-07  Werner Koch  <wk@g10code.com>

	Replace all includes of errors.h by status.h (found in common/).

	* status.h: Remove.
	* status.h: Move prototypes to main.h.
	* status.c:  Rename to ..
	* cpr.c: .. this.
	(get_status_string): Remove.  We take this now from common/.

2007-10-25  David Shaw  <dshaw@jabberwocky.com>  (wk)

	From 1.4 (October):

	* gpg.c (main): Add --require-cross-certification to
	--openpgp/--rfc4880 mode.

	* gpg.c (main): Disable --rfc2440-text and --force-v3-sigs by
	default.  Enable --require-cross-certification by default.
	--openpgp (--rfc4880) is the same as --rfc2440 except with
	"--enable-dsa2 --no-rfc2440-text --escape-from-lines".

	* misc.c (compliance_option_string, compliance_failure): Minor
	cleanup.

	* armor.c (is_armor_header): Comment about 4880.

	* options.h, gpg.c (main): Add --rfc4880, and make --openpgp an
	alias to it.  --rfc2440 now stands alone.  For now, use the old
	2440 defaults for 4880.
	* misc.c (compliance_option_string): Ditto.

	* keyedit.c (keyedit_menu): Use compliance_option_string() instead
	of printing the compliance modes here.

2007-10-25  David Shaw  <dshaw@jabberwocky.com>  (wk)

	From 1.4 (September):

	* import.c (collapse_uids): Significant speedup for de-duping user
	IDs.

2007-10-25  David Shaw  <dshaw@jabberwocky.com>  (wk)

	From 1.4 (July):

	* armor.c (parse_header_line): Improve test so that the header
	test only allows "Hash" in the signed data section.

	* armor.c (is_armor_tag): New.  Detect if an armor header matches
	2440bis-21.
	(parse_header_line): Call it here, as bis-21 requires warning the
	user (but continuing to process the message) when seeing an
	unknown header.

	* encode.c (encode_crypt): Missed one call to
	setup_plaintext_name().  This is bug#809.

	* sign.c (mk_notation_policy_etc): Expect all sigs that this is
	called for are >=v4.
	(write_signature_packets, make_keysig_packet): Only call it for
	>=v4 sigs.  This allows --force-v3-sigs and --force-v4-certs to
	enable or disable notations, policies, and keyserver URLs.  This
	is bug#800.

2007-10-19  Werner Koch  <wk@g10code.com>

	* passphrase.c (passphrase_get): Use new utf8 switching fucntions.

2007-09-14  Werner Koch  <wk@g10code.com>

	* gpg.c (build_lib_list): New.
	(my_strusage): Print lib info.

2007-08-27  Werner Koch  <wk@g10code.com>

	* trustdb.c (USE_INTERNAL_REGEX): Remove support.

2007-08-24  Werner Koch  <wk@g10code.com>

	* keyring.c (keyring_register_filename): Use same_file_p().

2007-08-21  Werner Koch  <wk@g10code.com>

	* misc.c (openpgp_md_test_algo): Remove rfc2440bis hash algorithms.
	(openpgp_cipher_test_algo): Likewise for algos 5 and 6.

2007-08-02  Werner Koch  <wk@g10code.com>

	* gpg.c: Include gc-opt-flags.h and remove their definition here.

2007-07-17  Werner Koch  <wk@g10code.com>

	* gpg.c (gpgconf_list): Declare --encrypt-to and --default-key.

	* card-util.c (get_manufacturer): Add the unmanaged S/N range.

2007-07-12  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Use translate_sys2libc_fd_int when passing an int
	value.
	* gpgv.c (main): Ditto.

2007-07-05  Werner Koch  <wk@g10code.com>

	* card-util.c (card_generate_subkey, card_store_subkey): Enable
	the code also for GnuPG-2.

	* keygen.c (make_backsig): Add arg TIMESTAMP.
	(write_keybinding): Add arg TIMESTAMP, pass it to make_backsig.
	(write_direct_sig, write_selfsigs): Add arg TIMESTAMP.
	(gen_elg, gen_dsa, gen_rsa): Add arg TIMESTAMP.
	(do_create): Ditto.
	(do_generate_keypair): Use the same timestamp for key creation
	time and all key signatures. Return an error if write_direct_sig
	for the secret key fails.
	(generate_subkeypair): Ditto.
	(gen_card_key): New arg TIMESTAMP.
	(generate_card_subkeypair): Pass current time to gen_card_key.
	(gen_card_key_with_backup): New arg TIMESTAMP.
	(read_parameter_file): Add option Creation-Date.
	(parse_creation_string): New.
	(do_generate_keypair): Use the Creation-Date if available.
	(save_unprotected_key_to_card): Use P for P and not D.
	* call-agent.c (agent_scd_genkey): Add arg CREATETIME.
	* keyedit.c (menu_backsign): Use the same timestamp for all backsigs.

2007-06-26  Werner Koch  <wk@g10code.com>

	* openfile.c (try_make_homedir): Support W32; use standard_homedir.

2007-06-25  Werner Koch  <wk@g10code.com>

	* gpg.c, gpgv.c: Include sysutils.h.
	(main): Replace iobuf_translate_file_handle by
	translate_sys2libc_fd.

2007-06-21  Werner Koch  <wk@g10code.com>

	* main.h: Include util.h.

	* call-agent.c (start_agent): Factored almost all code out to
	../common/asshelp.c.

	* gpg.h (ctrl_t): Remove.  It is now declared in ../common/util.h.

2007-06-20  Werner Koch  <wk@g10code.com>

	* misc.c (setsysinfo, trap_unaligned): Remove.  It is also in
	common/sysutils.c.
	(disable_core_dumps, get_session_marker):

	* sign.c (sleep): Remove sleep wrapper.

2007-06-18  Marcus Brinkmann  <marcus@g10code.de>

	* gpg.c (gpgconf_list): Percent escape output of --gpgconf-list.

2007-06-14  Werner Koch  <wk@g10code.com>

	* call-agent.c (start_agent): Use gnupg_module_name.

2007-06-12  Werner Koch  <wk@g10code.com>

	* openfile.c (copy_options_file): Use gnupg_datadir.
	* misc.c (get_libexecdir): Remove.  Changed all callers to use
	gnupg_libexecdir.
	* gpg.c (check_permissions): Use gnupg_libdir.

	* gpg.c (main): Replace some calls by init_common_subsystems.
	* gpgv.c (main): Ditto.

2007-06-11  Werner Koch  <wk@g10code.com>

	* Makefile.am (needed_libs): Use libcommonstd macro.

	* gpgv.c (main) [W32]: Call pth_init.
	* gpg.c (main) [W32]: Call pth_init.

2007-06-08  Werner Koch  <wk@g10code.com>

	* Makefile.am (gpg2_LDADD): Syntax fix.

2007-06-06  Werner Koch  <wk@g10code.com>

	* passphrase.c (passphrase_get) [!ENABLE_NLS]: Do not define
	orig_codeset.

	* Makefile.am (gpgv2_LDADD, gpg2_LDADD): Include LDADD before
	libgcrypt.

	* plaintext.c (handle_plaintext): Replace eof by eof_seen as W32's
	io.h has a symbol with that name.

	* misc.c: Do not include dynload.h.
	(w32_shgetfolderpath): Remove. It is now in common/homedir.c.

	* gpgv.c (i18n_init): Remove.
	* gpg.c (i18n_init): Remove.
	(main): Make --load-extension a dummy

2007-05-19  Marcus Brinkmann  <marcus@g10code.de>

	* passphrase.c (passphrase_get): Use PACKAGE_GT, not PACKAGE.

	* passphrase.c (passphrase_get): Free ORIG_CODESET on error.

2007-05-16  Werner Koch  <wk@g10code.com>

	* sig-check.c (check_backsig): Check the digest algorithm before
	using it.  Fixed bug 797.

2007-05-09  Werner Koch  <wk@g10code.com>

	* openfile.c (overwrite_filep, open_outfile) [W32]: Need to use
	just "nul".  Though, I am pretty sure that some MSDOS versions
	grok the extra /dev/.

2007-05-07  Werner Koch  <wk@g10code.com>

	* openfile.c (open_outfile, overwrite_filep) [W32]: Use "/dev/nul".

2007-05-02  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, mainproc.c (reset_literals_seen): New function to
	reset the literals count.

	* verify.c (verify_one_file), decrypt.c (decrypt_messages): Call
	it here so we allow multiple literals in --multifile mode (in
	different files - not concatenated together).

2007-04-26  Marcus Brinkmann  <marcus@g10code.de>

	* passphrase.c (passphrase_to_dek): Write missing passphrase
	status message in case of cancellation.

2007-04-16  Werner Koch  <wk@g10code.com>

	* build-packet.c (mpi_write): Made buffer a bit larger.  Reported
	by Alexander Feigl.

2007-04-13  Werner Koch  <wk@g10code.com>

	* call-agent.c (start_agent): Don't use log_error when using the
	fallback hack to start the agent.  This is bug 782.

2007-04-05  David Shaw  <dshaw@jabberwocky.com>

	From STABLE-BRANCH-1-4

	* parse-packet.c (parse_marker): New.  Enforce that the marker
	contains 'P', 'G', 'P', and nothing but.
	(parse): Call it here.
	(skip_packet): No longer need to handle marker packets here.

2007-03-14  David Shaw  <dshaw@jabberwocky.com>

	From STABLE-BRANCH-1-4

	* keyserver.c: Windows Vista doesn't grok X_OK and so fails
	access() tests.  Previous versions interpreted X_OK as F_OK
	anyway, so we'll just use F_OK directly.

2007-03-09  David Shaw  <dshaw@jabberwocky.com>

	From STABLE-BRANCH-1-4

	* parse-packet.c (parse_signature): It's hex.

	* getkey.c (merge_selfsigs_subkey): Avoid listing the contents of
	a backsig when list mode is on.  Noted by Timo Schulz.

2007-03-08  Werner Koch  <wk@g10code.com>

	* plaintext.c (handle_plaintext): Add two extra fflush for stdout.

2007-03-08  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* keyedit.c (keyedit_menu): If we modify the keyblock (via
	fix_keyblock() or collapse_uids()) make sure we reprocess the
	keyblock so the flags are correct.  Noted by Robin H. Johnson.

	* getkey.c (fixup_uidnode): Properly clear flags that don't apply
	to us (revoked, expired) so that we can reprocess a uid.

2007-03-05  Werner Koch  <wk@g10code.com>

	Converted this file to UTF-8.

	Ported David and my multiple messages changes from 1.4.7.

	* options.h, gpg.c (main), mainproc.c (check_sig_and_print): Allow
	multiple sig verification again as this is protected via the
	multiple-messages code.  New option --allow-multiple-messages and
	--no variant.
	* status.h (STATUS_ERROR): New status code.
	* status.c (get_status_string): Ditto.
	* mainproc.c (proc_plaintext): Emit it if multiple messages are
	detected. Error out if more than one plaintext packet is
	encountered.
	* mainproc.c (literals_seen): New.

2007-02-26  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Add verify option show-primary-uid-only.
	* options.h (VERIFY_SHOW_PRIMARY_UID_ONLY): New.
	* mainproc.c (check_sig_and_print): Implement it.

2007-02-22  Werner Koch  <wk@g10code.com>

	* encr-data.c (decrypt_data): Correctly test for unknown algorithm.
	* import.c (check_prefs): Ditto.
	* keyedit.c (show_prefs): Ditto.
	* mainproc.c (proc_symkey_enc): Ditto.

2007-02-06  Werner Koch  <wk@g10code.com>

	* export.c (do_export_stream): Allow reset-subkey-passwd along
	with sexp-format.

2007-02-04  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_signature): Limit bytes read for an
	unknown alogorithm.  Fixes Debian bug#402592.

2007-01-31  Werner Koch  <wk@g10code.com>

	* verify.c (verify_signatures): Do no dereference a NULL afx.

	* passphrase.c (passphrase_get): Set the cancel flag on all error
	from the agent.  Fixes a bug reported by Tom Duerbusch.

2007-01-30  Werner Koch  <wk@g10code.com>

	* status.c (write_status_begin_signing): New.
	* sign.c (sign_file, sign_symencrypt_file): Call it.
	* textfilter.c (copy_clearsig_text): Call it.

	* call-agent.c (agent_scd_pksign): Pass --hash-rmd160 to SCD if
	required.

	* gpg.c (main): Let --no-use-agent and --gpg-agent-info print a
	warning.
	* misc.c (obsolete_option): New.

2007-01-29  Werner Koch  <wk@g10code.com>

	* pkclist.c (do_we_trust_pre): Issue a user-id-hint status code.

2007-01-15  Werner Koch  <wk@g10code.com>

	* parse-packet.c (read_protected_v3_mpi): Make sure to stop
	reading even for corrupted packets.
	* keygen.c (generate_user_id): Need to allocate one byte more.
	Reported by Felix von Leitner.

2006-12-21  Werner Koch  <wk@g10code.com>

	* gpg.c (main): New command --server.
	* gpg.h (struct server_control_s, ctrl_t): New.
	* server.c: New.
	* verify.c (gpg_verify): New.
	* mainproc.c (mainproc_context): Made SIGNED_DATA a structure.
	(proc_signature_packets_by_fd): New.
	(proc_compressed_cb): Divert depending on SIGNED_DATA.
	* plaintext.c (hash_datafile_by_fd): New.
	* mainproc.c (proc_tree): Use it here.

	* verify.c (verify_signatures): Init AFX only when needed.
	Don't leak a context on error.
	(verify_one_file): Don't leak a context on error.

2006-12-07  Werner Koch  <wk@g10code.com>

	* openfile.c (copy_options_file): Use log_info instead of
	log_error to avoid an error return of gpg due to a missing
	skeleton file.

2006-12-07  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am: Link to iconv for jnlib dependency.

2006-12-05  Werner Koch  <wk@g10code.com>

	* passphrase.c (passphrase_to_dek): Handle a Cancel request
	correctly.  [Bug#737]
	* mainproc.c (proc_symkey_enc): Removed workaround for bogus cancel
	processing.
	* encode.c (encode_simple): Distinguish error message between
	cancel and invalid passphrase.
	(setup_symkey): Ditto.
	* sign.c (sign_symencrypt_file): Ditto
	* keyedit.c (change_passphrase): Allow cancellation.
	* keygen.c (do_ask_passphrase): New arg R_CANCELED.
	(generate_keypair): Handle a passphrase cancellation.
	(generate_raw_key): Ditto.
	(generate_subkeypair): Ditto.

2006-12-04  Werner Koch  <wk@g10code.com>

	* filter.h (armor_filter_context_t): New element REFCOUNT.
	* armor.c (armor_filter): Made static.
	(push_armor_filter, release_armor_context, new_armor_context): New.
	(armor_filter): Release the context.
	* gpg.c (main): Use new armor context functions and
	push_armor_filter.
	* export.c (do_export): Ditto.
	* encode.c (encode_simple, encode_crypt): Ditto.
	* decrypt.c (decrypt_message, decrypt_messages): Ditto.
	* dearmor.c (dearmor_file, enarmor_file): Ditto.
	* verify.c (verify_signatures, verify_one_file): Ditto.
	* sign.c (sign_file, clearsign_file, sign_symencrypt_file): Ditto.
	* revoke.c (gen_desig_revoke, gen_revoke): Ditto.
	* keyserver.c (keyserver_spawn): Ditto.
	* keygen.c (output_control_s): Turn AFX fields into pointers.
	(read_parameter_file): Allocate and release AFX fields.
	(do_generate_keypair): Use push_armor_filter.
	* import.c (import): Replace iobuf_push_filter2 hack by the new
	armor context stuff.

2006-12-03  Werner Koch  <wk@g10code.com>

	* filter.h: New element REFCOUNT.
	(handle_progress): Remove prototype.
	* progress.c (new_progress_context, release_progress_context): New.
	(progress_filter): Use new function to release context.  Made static.
	(handle_progress): Bumb reference counter.  No more check for
	enabled progress as this is handled by new_progress_context.
	* verify.c (verify_signatures, verify_one_file): Replace stack
	based progress context by a heap based one.
	* sign.c (sign_file, clearsign_file, sign_symencrypt_file): Ditto.
	* plaintext.c (ask_for_detached_datafile, hash_datafiles): Ditto.
	* encode.c (encode_simple, encode_crypt): Ditto.
	* decrypt.c (decrypt_message, decrypt_messages): Ditto.

	* keyedit.c (menu_clean): Made strings translatable.

2006-12-03  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_clean): Show "already minimized" rather than
	"already clean" when a minimized key is minimized again.  From
	Dirk Traulsen.

2006-12-02  David Shaw  <dshaw@jabberwocky.com>

	* options.h, gpg.c (main), passphrase.c (passphrase_to_dek): Add
	--passphrase-repeat option to control how many times gpg will
	re-prompt for a passphrase to ensure the user has typed it
	correctly.  Defaults to 1.

2006-12-02  Werner Koch  <wk@g10code.com>

	* encr-data.c: Allocate DFX context on the heap and not on the
	stack.  Changes at several places.  Fixes CVE-2006-6235.

2006-11-27  Werner Koch  <wk@g10code.com>

	* openfile.c (ask_outfile_name): Fixed buffer overflow occurring
	if make_printable_string returns a longer string.  Fixes bug 728.

2006-11-21  Werner Koch  <wk@g10code.com>

	* Makefile.am (needed_libs): libgnu needs to come after libcommon.

	* keygen.c (ask_expire_interval): Print y2038 warning only for 32
	bit time_t.
	(save_unprotected_key_to_card): Made RSA_N_LEN et al a size_t.
	Cast printf args.
	(get_parameter_algo): Allow "ELG" as alias for "ELG-E".

	* seckey-cert.c (do_check): Made NBYTES a size_t.
	(do_check): Made NDATA a size_t.
	(protect_secret_key): Made NARR a size_t.
	(protect_secret_key): Made NVYES a size_t.
	* pubkey-enc.c (get_it): Made INDATALEN a size_t.
	(get_it): Made NFRAME a size_t.
	* keyid.c (hash_public_key): Made NBITS an unsigned int.
	* misc.c (checksum_mpi): Made NBYTES a size_t.
	(openpgp_pk_test_algo2): Made USE_BUF a size_t.
	* seskey.c (encode_session_key): Made NFRAME a size_t.
	(do_encode_md): Ditto.
	(encode_md_value): Cast size_t argument of printf.
	(encode_md_value): Ditto.

2006-11-10  Werner Koch  <wk@g10code.com>

	* parse-packet.c (mpi_read): Changed NREAD to size_t to match the
	gcry_mpi-scan prototype.
	(mpi_read): Fixed double increment of bytes read to correctly
	detect overlong MPIs.

2006-11-05  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Remove the default --require-cross-certification.
	* options.skel: Enable require-cross-certification.

2006-10-31  Werner Koch  <wk@g10code.com>

	* pkclist.c (warn_missing_aes_from_pklist): New.
	* encode.c (encrypt_filter, encode_crypt): Use it here.

2006-10-27  Werner Koch  <wk@g10code.com>

	* pkclist.c (warn_missing_mdc_from_pklist): New.
	* encode.c (use_mdc): Use it here.

2006-10-24  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (AM_CFLAGS): Add $(LIBASSUAN_CFLAGS).

2006-10-23  Werner Koch  <wk@g10code.com>

	* gpg.c (main): New command --gpgconf-test.

	* Makefile.am (bzip2_source): New.

2006-10-20  Werner Koch  <wk@g10code.com>

	* getkey.c (classify_user_id): Reserve '&' for search by keygrip.

2006-10-19  Werner Koch  <wk@g10code.com>

	* keygen.c (get_parameter_algo): Add special case for ELG_E which
	is not supported by libgcrypt's mapping function.

2006-10-18  Werner Koch  <wk@g10code.com>

	* keyid.c (v3_keyid): Don't use mempcy as we need to hold the
	keyids in the native endian format.

	* import.c (import_print_stats): Use log_printf.

	* build-packet.c (do_public_key): Care about mpi_write errors.
	(do_secret_key, do_pubkey_enc, do_signature): Ditto.
	(mpi_write): Print an extra warning on error.

2006-10-17  Werner Koch  <wk@g10code.com>

	* Makefile.am (LDADD): Replaced W32LIBS by NETLIBS.

2006-10-12  David Shaw  <dshaw@jabberwocky.com>

	* parse-packet.c (parse_symkeyenc): Show the unpacked as well as
	the packed s2k iteration count.

	* main.h, options.h, gpg.c (encode_s2k_iterations, main),
	passphrase.c (hash_passphrase): Add --s2k-count option to specify
	the number of s2k hash iterations.

2006-10-08  Werner Koch  <wk@g10code.com>

	* gpgv.c: Remove the tty stubs as we are now required to link to
	tty anyway (it is included in libcommand and has dependencies to
	other modules as well).

	* keyedit.c (keyedit_menu): Use keyedit_completion only if
	readline is available.  It would be better to move this code into
	gpgrlhelp.c

2006-10-06  Werner Koch  <wk@g10code.com>

	* Makefile.am (AM_CFLAGS): Use PTH version of libassuan.

2006-10-06  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Write the 16-digit keyid rather
	than whatever key selector the user used on the command line.

2006-10-05  Werner Koch  <wk@g10code.com>

	* status.c (progress_cb): Changed to libgcrypt API.
	(set_status_fd): Register the progress cb.

	* seskey.c (encode_md_value): Check that the hash algo is valid
	before getting the OID.

2006-10-04  Werner Koch  <wk@g10code.com>

	* passphrase.c: Allow for a static passphrase in batch mode.

	* call-agent.c (agent_havekey): Removed.
	(percent_plus_escape): New.
	(agent_get_passphrase): New.
	(agent_clear_passphrase): New.

	* passphrase.c: Changed so that we always require the agent.
	(agent_send_option, agent_send_all_options, agent_open): Removed.
	(agent_get_passphrase): Cleaned up.  Does now use the call-agent
	functions.  Renamed to
	(passphrase_get): .. this.  Changed all callers.
	(passphrase_clear_cache): Rewritten.
	(passphrase_to_dek, hash_passphrase): Re-indented.

	* gpg.c (main): Made --use-agent a dummy option.
	* seckey-cert.c (check_secret_key): We require the agent, so always
	allow for 3 tries.

	* gpg.c (main): Print a warning if -sat has been used.
	(main): Removed the special treatment of the -k option. -k is now
	an alias for --list-keys.
	(main): Removed --list-ownertrust.

2006-10-02  Werner Koch  <wk@g10code.com>

	* encr-data.c (decrypt_data, mdc_decode_filter): Check the MDC
	right here and don't let parse-packet handle the MDC.

2006-09-29  Werner Koch  <wk@g10code.com>

	* compress.c (do_uncompress): Removed use of Z_PARTIAL_FLUSH.
	This is outdated and old zlib versions which still require it have
	security problems.

2006-09-27  Werner Koch  <wk@g10code.com>

	Replaced all STRLIST by strlist_t.

2006-09-21  Werner Koch  <wk@g10code.com>

	* signal.c (got_fatal_signal): Replaced readline stuff by a tty
	function.

	* Makefile.am (LDADD): Include libgpgrl.a.

	* gpg.c (main): Call gpg_rl_initialize.

	* keyedit.c: Removed double inclusion of stdio.h.

2006-09-20  Werner Koch  <wk@g10code.com>

	* call-agent.c: Include asshelp.h.
	(start_agent): Use send_pinentry_environment.

2006-09-14  Werner Koch  <wk@g10code.com>

	Replaced all call gpg_error_from_errno(errno) by
	gpg_error_from_syserror().

2006-09-13  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Made --require-cross-certification the default.

2006-09-06  Marcus Brinkmann  <marcus@g10code.de>

	* Makefile.am (gpg2_LDADD, gpgv2_LDADD): Replace -lassuan and
	-lgpg-error with $(LIBASSUAN_LIBS) and $(GPG_ERROR_LIBS).
	(AM_CFLAGS): Add $(LIBASSUAN_CFLAGS) and $(GPG_ERROR_CFLAGS).

2006-09-06  Werner Koch  <wk@g10code.com>

	* gpg.c (main): Enable new assuan API.
	* call-agent.c: Changed to new Assuan API.

2006-09-01  Werner Koch  <wk@g10code.com>

	* call-agent.c: Do not force using the pipe server.

	* gpg.c (main): Enable card related commands.

2006-08-22  Werner Koch  <wk@g10code.com>

	* mainproc.c (proc_plaintext): Fixed a #warning

2006-08-21  Werner Koch  <wk@g10code.com>

	* skclist.c (random_is_faked): Implemented.
	(is_insecure): Also test for the old uppercase version of the
	insecure string.
	* gpg.c (main): Renamed --quick-random to debug-quick-quick-random.

	* gpg.c (print_mds): Do not use the USE_SHA macros.

	* mainproc.c (proc_encrypted): Remove assign inside condition for
	better readibility.

	* packet.h: Moved consts to new header ../common/openpgpdefs.h.

2006-08-16  Werner Koch  <wk@g10code.com>

	* keyserver.c (GPGKEYS_PREFIX): Rename to gpg2keys_.  This is so
	that we can install helpers from 1.4 and 2 without conflicts and
	first of all don't get lost with weird bug reports.

	* keyid.c (serialno_and_fpr_from_sk): New. Actually lost during
	the last 1.4 to 1.9 merge.

	* gpg.c (list_config): Output ccid-reader-id only for gnupg 1.

	* call-agent.c (agent_scd_writekey): New.
	(inq_writekey_parms): New.

	* gpgv.c: Include call-agent.h for use by stubs.

	* misc.c: Include call-agent.h for use by get_signature_count.

2006-07-27  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_comment): Cap comments at 65k.
	(parse_gpg_control): Skip too large control packets.

2006-07-24  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* keydb.h, pkclist.c (select_algo_from_prefs, algo_available):
	Pass a union for preference hints rather than doing void * games.

	* sign.c (sign_file): Use it here.

	* sign.c (sign_file): When signing with multiple DSA keys, one
	being DSA1 and one being DSA2 and encrypting at the same time, if
	the recipient preferences give a hash that can work with the DSA2
	key, then allow the DSA1 key to be promoted rather than giving up
	and using hash_for().

	* pkclist.c (algo_available): Automatically enable DSA2 mode when
	handling a key that clearly isn't DSA1 (i.e. q!=160).

2006-06-30  Werner Koch  <wk@g10code.com>

	* misc.c (checksum_mpi): No need for nbits as they are alredy
	included in the buffer.

2006-06-29  Werner Koch  <wk@g10code.com>

	* parse-packet.c (parse_signature, parse_key): Need store the
	length of opaque data as number of bits.
	* card-util.c (card_store_subkey): Ditto.

	* mainproc.c (print_pkenc_list, check_sig_and_print): Replaced
	log_get_stream by calls to log_printf.  This avoids the extra LFs
	inserted by the logging function. They are a bit too smart
	sometimes.
	* pkclist.c (do_show_revocation_reason): Print final LF through
	log_printf to avoid extra LFs.
	* pubkey-enc.c (get_it): Ditto.

	* seskey.c (encode_md_value): Fix call to gcry.

2006-06-27  Werner Koch  <wk@g10code.com>

	Applied patches from 1.4.x (2006-05-22 to 2006-06-23) from David:

	* keygen.c (keygen_upd_std_prefs, keygen_add_std_prefs)
	(proc_parameter_file): Add --default-keyserver-url to specify a
	keyserver URL at key generation time, and "Keyserver:" keyword for
	doing the same through a batch file.
	* options.h, gpg.c (main): Ditto.

	* sign.c (do_sign): For now don't accept a truncated hash even
	for DSA1 keys (be liberal in what you accept, etc).

	* import.c (import_one): Add a flag (from_sk) so we don't check
	prefs on an autoconverted public key.  The check should only
	happen on the sk side.  Noted by Dirk Traulsen.

	* keygen.c (gen_card_key): Add optional argument to return a
	pointer (not a copy) of the stub secret key for the secret key we
	just generated on the card.
	(generate_card_subkeypair): Use it here so that the signing key on
	the card can use the card to generate the 0x19 backsig on the
	primary key.  Noted by Janko Heilgeist and Jonas Oberg.

	* parse-packet.c (parse_user_id): Cap the user ID size at 2048
	bytes.  This prevents a memory allocation attack with a very large
	user ID.  A very large packet length could even cause the
	allocation (a u32) to wrap around to a small number.  Noted by
	Evgeny Legerov on full-disclosure.

	* keygen.c (gen_dsa): Allow generating DSA2 keys.  Allow
	specifying sizes > 1024 when --enable-dsa2 is set.  The size of q
	is set automatically based on the key size.
	(ask_keysize, generate_keypair): Ask for DSA size when
	--enable-dsa2 is set.

	* exec.c (make_tempdir) [W32]: Fix bug with a temporary directory
	on W32 that is over 256 bytes long.  Noted by Israel G. Lugo.

	* gpg.c (reopen_std): New function to reopen fd 0, 1, or 2 if we
	are called with them closed.  This is to protect our
	keyring/trustdb files from corruption if they get attached to one
	of the standard fds.  Print a warning if possible that this has
	happened, and fail completely if we cannot reopen (should never
	happen).
	(main): Call it here.

	* parse-packet.c (dump_sig_subpkt, parse_signature): Fix meaning
	of key expiration and sig expiration subpackets - zero means
	"never expire" according to 2440, not "expire instantly".
	* build-packet.c (build_sig_subpkt_from_sig): Ditto.
	* getkey.c (fixup_uidnode, merge_selfsigs_main)
	(merge_selfsigs_subkey): Ditto.
	* keygen.c (keygen_add_key_expire): Ditto.

	* getkey.c (get_pubkey_byname)
	* import.c (import_one): Fix key selection problem when
	auto-key-locate returns a list of keys, not all of which are
	usable (revoked, expired, etc).  Noted by Simon Josefsson.

2006-05-24  Werner Koch  <wk@g10code.com>

	* keyid.c (hash_public_key): Do not double hash the length bytes,
	they are already included by mpi_print.

	* misc.c (openpgp_pk_test_algo2): Get test call right.

	* misc.c (string_to_cipher_algo, string_to_digest_algo): New.
	* keygen.c (keygen_set_std_prefs): use them here.
	* gpg.c (main): and here.

2006-05-23  Werner Koch  <wk@g10code.com>

	* card-util.c (generate_card_keys): Removed temporary kludge for
	generate_keypair.

	* call-agent.c (agent_scd_setattr): Add arg SERIALNO.
	(agent_scd_genkey): Ditto.
	(agent_scd_change_pin): Ditto.

	* call-agent.h (struct agent_card_info_s): Updated to match the
	one of 1.4.3.

	* Makefile.am (LDADD): Include ZLIBS.

	* gpgv.c: Removed stubs not anymore useful due to libgcrypt.

2006-05-22  Werner Koch  <wk@g10code.com>

	* keyserver.c (keyidlist): Replaced mpi_get_keyid by v3_keyid.
	* keydb.h (v3_keyid): Added.

	* import.c (import): Better initialize KEYBLOCK as to quiet
	compiler warning.

	* skclist.c (random_is_faked): New.

	* mainproc.c: Include pka.h.

2006-05-19  Werner Koch  <wk@g10code.com>

	* misc.c (openpgp_pk_test_algo2): Need to use gcry_pk_algo_info
	directly.
	(string_count_chr): New.

	* armor.c (parse_header_line): Use renamed function
	length_sans_trailing_ws.

	* options.h, gpg.c: Option --strict is not used thus removed code
	but kept option.

2006-04-28  David Shaw  <dshaw@jabberwocky.com>  (wk)

	* keyserver.c (direct_uri_map): New.
	(keyserver_spawn): Used here to add "_uri" to certain gpgkeys_xxx
	helpers when the meaning is different if a path is provided (i.e.
	ldap).
	(keyserver_import_cert): Show warning if there is a CERT
	fingerprint, but no --keyserver set.

	* keyserver.c: Fix build problem with platforms that stick libcurl
	in a place not in the regular include search path.

	* options.h, gpg.c (main): Add --enable-dsa2 and --disable-dsa2.
	Defaults to disable.

	* pkclist.c (algo_available): If --enable-dsa2 is set, we're
	allowed to truncate hashes to fit DSA keys.

	* sign.c (match_dsa_hash): New.  Return the best match hash for a
	given q size.
	(do_sign, hash_for, sign_file): When signing with a DSA key, if it
	has q==160, assume it is an old DSA key and don't allow truncation
	unless --enable-dsa2 is also set.  q!=160 always allows truncation
	since they must be DSA2 keys.
	(make_keysig_packet): If the user doesn't specify a
	--cert-digest-algo, use match_dsa_hash to pick the best hash for
	key signatures.

	* gpg.c (print_mds): Add SHA-224.
	* armor.c (armor_filter, parse_hash_header): Add SHA-224.

	* sign.c (write_plaintext_packet):
	Factor common literal packet setup code from here, to...
	* encode.c (encode_simple): .. there.

	* main.h, plaintext.c (setup_plaintext_name): Here. New. Make sure
	the literal packet filename field is UTF-8 encoded.

	* options.h, gpg.c (main): Make sure --set-filename is UTF-8
	encoded and note when filenames are already UTF-8.

	* keyedit.c (menu_backsign): Give some more verbose errors when we
	have no need to backsign.

	* getkey.c (parse_auto_key_locate): Fix dupe-removal code.

	* keyedit.c (menu_backsign): Allow backsigning even if the secret
	subkey doesn't have a binding signature.

	* armor.c (radix64_read): Don't report EOF when reading only a pad
	(=) character.  The EOF actually starts after the pad.

	* gpg.c (main): Make --export, --send-keys, --recv-keys,
	--refresh-keys, and --fetch-keys follow their arguments from left
	to right.  Suggested by Peter Palfrader.

2006-04-18  Werner Koch  <wk@g10code.com>

	* tdbio.c (open_db, migrate_from_v2): Removed feature to migration
	from old trustdb version 2.

	* gpg.c, mainproc.c: Removed pipemode feature.

	* status.c: Removed shared memory coprocess stuff

	Merged with current gpg 1.4.3 code.

	* keygen.c, keyid.c, misc.c, openfile.c, verify.c, trustdb.c
	* textfilter.c, tdbio.c, tdbdump.c, status.c, skclist.c, signal.c
	* sign.c, sig-check.c, seskey.c, seckey-cert.c, revoke.c
	* pubkey-enc.c, progress.c, plaintext.c, pkclist.c, photoid.c
	* passphrase.c, parse-packet.c, mdfilter.c, mainproc.c
	* keyserver.c, keyring.c, keylist.c, keyedit.c, keydb.c, kbnode.c
	* import.c, getkey.c, gpgv.c, helptext.c, free-packet.c
	* build-packet.c, cipher.c, compress.c, dearmor.c, decrypt.c
	* delkey.c, encr-data.c, encode.c, exec.c, export.c
	* gpg.c, armor.c: Updated from gnupg-1.4.3 and merged back gcry and
	gnupg-1.9 related changes.
	* trustdb.h, tdbio.h, status.h, photoid.h, packet.h, options.h
	* main.h, keyserver-internal.h, keyring.h, keydb.h, filter.h
	* exec.h: Ditto.
	* global.h: Removed after merging constants with gpg.h.
	* comment.c, pipemode.c: Removed.
	* card-util.c: Updated from gnupg-1.4.3.
	* compress-bz2.c: New.

2005-06-15  Werner Koch  <wk@g10code.com>

	* g10.c (print_hashline, add_group): Fixes for signed/unsigned
	pointer mismatch warnings.

2005-06-01  Werner Koch  <wk@g10code.com>

	* mkdtemp.c: Removed.
	* exec.c: Include mkdtemp.h

2004-12-21  Werner Koch  <wk@g10code.com>

	* gpgv.c, g10.c (main): Use default_hoemdir ().

2004-12-18  Werner Koch  <wk@g10code.com>

	* gpg.h (map_assuan_err): Define in terms of
	map_assuan_err_with_source.

2004-12-15  Werner Koch  <wk@g10code.com>

	* Makefile.am (LDADD): Remove ZLIBS.

2004-10-22  Werner Koch  <wk@g10code.com>

	* g10.c (main): Display a bit fat warning that this gpg should not
	be used.

	* card-util.c (fetch_url): Disable for gnupg 1.9
	(card_generate_subkey): Ditto.
	(card_store_subkey): Ditto.

2004-09-30  Werner Koch  <wk@g10code.com>

	* gpgv.c (i18n_init): Always use LC_ALL.

	* Makefile.am (LDADD): Adjusted for gettext 0.14.

2004-09-20  Werner Koch  <wk@g10code.com>

	* keyedit.c (show_key_with_all_names): Print the card S/N.

2004-09-11  Moritz Schulte  <moritz@g10code.com>

	* openfile.c (copy_options_file): Fixed last commit (added a `+').

2004-08-31  Werner Koch  <wk@g10code.de>

	* openfile.c (copy_options_file): Use gpg-conf.skel. Better take
	the length of SKELEXT into account, someone might make it larger.
	* Makefile.am: Install options.skel as gpg-conf.skel.

2004-08-18  Marcus Brinkmann  <marcus@g10code.de>

	* passphrase.c (agent_get_passphrase): Fix detection of gpg-agent
	cancellation.

2004-07-01  Werner Koch  <wk@gnupg.org>

	* card-util.c (change_login): Kludge to allow reading data from a
	file.
	(card_edit): Pass ARG_STRING to change_login.
	(card_status): Print CA fingerprints.
	(change_cafpr): New.
	(card_edit): New command CAFPR.

	* call-agent.h: Add members for CA fingerprints.
	* call-agent.c (agent_release_card_info): Invalid them.
	(learn_status_cb): Store them.

2004-04-30  Werner Koch  <wk@gnupg.org>

	* g10.c (main) <gpgconf>: Use gpg.conf and not /dev/null as
	default filename.

2004-04-28  Werner Koch  <wk@gnupg.org>

	* card-util.c (card_edit): Remove PIN verification.
	(generate_card_keys): New arg SERIALNO.  Do PIN verification here
	after resetting forced_chv1.

2004-04-26  Werner Koch  <wk@gnupg.org>

	* card-util.c (change_name): Check that the NAME is not too long.
	(change_url): Likewise.
	(change_login): Likewise.

2004-03-23  Werner Koch  <wk@gnupg.org>

	* g10.c: New options --gpgconf-list, --debug-level and --log-file
	(set_debug): Add arg DEBUG_LEVEL.
	(main): Look at less and less version specific config files.  From
	gnupg 1.3.

2004-02-17  Werner Koch  <wk@gnupg.org>

	* call-agent.c (start_agent): Ignore an empty GPG_AGENT_INFO.
	* passphrase.c (agent_open): Ditto.

2004-02-12  Werner Koch  <wk@gnupg.org>

	* gpgv.c: Removed g10defs.h.

	* Makefile.am: Include cmacros.am for common flags.

2004-02-11  Werner Koch  <wk@gnupg.org>

	* openfile.c (try_make_homedir): Use GNUPG_DEFAULT_HOMEDIR.
	* gpgv.c (main): Ditto.
	* g10.c (main): Ditto.

2004-01-19  Moritz Schulte  <mo@g10code.com>

	* keygen.c (do_generate_keypair): Print member fname, instead of
	newfname, again.
	(do_generate_keypair): Don't try to execute certain pieces of code
	in case an error occured.
	(gen_card_key): Don't print out a message, which is already
	printed by do_generate_keypair().

2004-01-18  Moritz Schulte  <mo@g10code.com>

	* keygen.c (do_generate_keypair): Print member fname, instead of
	newfname.

2003-12-17  Werner Koch  <wk@gnupg.org>

	* card-util.c (print_name): Fixed bad format string usage.
	(print_isoname): Ditto.

	* trustdb.c (check_regexp): s/exp/expr/.

	* keyedit.c (trustsig_prompt): Removed a "> 255" term; it is
	always false due to the data type.

	* passphrase.c (agent_get_passphrase): Use xasprintf and avoid
	non-literal format strings.

	* tdbio.c (upd_hashtable, drop_from_hashtable, lookup_hashtable):
	Fixed log_error format string bugs.  Kudos to the now working
	gcc-3.3 -Wformat-nonliteral and Florian Weimer's investigations in
	gnupg 1.2.3.

2003-12-15  Werner Koch  <wk@gnupg.org>

	* seckey-cert.c (protect_secret_key): Use gry_create_nonce for the
	IV; there is not need for real strong random here and it even
	better protect the random bits used for the key.

2003-11-16  Moritz Schulte  <mo@g10code.com>

	* signal.c: Removed unused file.

2003-11-10  Moritz Schulte  <mo@g10code.com>

	* Makefile.am (INCLUDES): Added: @LIBGCRYPT_CFLAGS@.

2003-10-25  Werner Koch  <wk@gnupg.org>

	* call-agent.c (learn_status_cb, scd_genkey_cb): Fixed faulty use
	of !spacep().

2003-10-20  Werner Koch  <wk@gnupg.org>

	* card-util.c (card_edit): New command "passwd".  Add logic to
	check the PIN in advance.
	(card_status): Add new args to return the serial number.  Changed
	all callers.
	* call-agent.c (agent_scd_checkpin): New.

2003-10-08  Werner Koch  <wk@gnupg.org>

	* call-agent.c (agent_scd_getattr): Don't clear the passed info
	structure, so that it can indeed be updated.

	* card-util.c (fpr_is_zero): New.
	(generate_card_keys): New.
	(card_edit): New command "generate".
	* keygen.c (generate_keypair): New arg CARD_SERIALNO, removed call
	to check_smartcard.
	(check_smartcard,show_smartcard): Removed.
	(show_sha1_fpr,fpr_is_zero): Removed.

2003-10-01  Werner Koch  <wk@gnupg.org>

	* card-util.c: Tweaked to use this source also under 1.3.

2003-09-30  Werner Koch  <wk@gnupg.org>

	* keylist.c (print_card_serialno): New.
	(list_keyblock_print): Use it here.

	* card-util.c (toggle_forcesig): New.
	(card_edit): New command "forcesig".

	* card-util.c (print_name, print_isoname): Use 0 and not LF fro
	the max_n arg of tty_print_utf8_string2.

	* call-agent.c (agent_scd_getattr): New.
	(learn_status_cb): Release values before assignment so that it can
	be used by getattr to update the structure.

	* card-util.c (change_pin): Simplified.  We now have only a PIN
	and an Admin PIN.

2003-09-27  Werner Koch  <wk@gnupg.org>

	* sign.c (do_sign): Removed disabled testcode.

2003-09-26  Timo Schulz  <twoaday@freakmail.de>

	* card_status (card_status): Do not use fputs since the fp
	parameter can be NULL. This fixes a segv.

2003-09-24  Werner Koch  <wk@gnupg.org>

	* card-util.c (print_isoname,card_status): Handle opt.with_colons.
	(print_sha1_fpr_colon): New.

2003-09-23  Werner Koch  <wk@gnupg.org>

	Merged most of David Shaw's changes in 1.3 since 2003-06-03.

	* Makefile.am: Include W32LIBS where appropriate.

	* armor.c (parse_hash_header,armor_filter): Drop TIGER/192 support.
	* g10.c (print_hex,print_mds): Ditto.
	* pkclist.c (algo_available): Ditto.

	* armor.c (armor_filter): Allow using --comment multiple times to
	get multiple Comment header lines.  --no-comments resets list.
	* options.h, g10.c (main): Ditto. Deprecate --default-comment in
	favor of --no-comments.

	* g10.c (main): Trim --help to commonly used options.  Remove -f.

	* g10.c (main): Add --multifile as an alias to turn --encrypt into
	--encrypt-files (plus --verify-files, --decrypt-files).  Error out
	if --multifile is used with the commands that don't support it yet.

	* encode.c (use_mdc), g10.c (main): Use RFC1991 and RFC2440
	directly to check for MDC usability.  Do not set the force_mdc or
	disable_mdc flags since there is no point any longer.

	* g10.c (main): Use "keyserver-url" instead of
	"preferred-keyserver" for the sake of short and simple commands.
	(add_keyserver_url): Clarify a few strings.  It's a
	"preferred keyserver URL".
	* keyedit.c (keyedit_menu): Ditto.
	* sign.c (mk_notation_policy_etc): Ditto.

	* main.h, keygen.c (keygen_add_keyserver_url): Signature callback
	for adding a keyserver URL.
	* keyedit.c (keyedit_menu, menu_set_keyserver_url): New command to
	set preferred keyserver to specified (or all) user IDs.
	* build-packet.c (build_sig_subpkt): Set preferred keyserver flag
	while building a preferred keyserver subpacket.

	* keylist.c (show_policy_url, show_keyserver_url): URLs might be
	UTF8.

	* keyedit.c (menu_addrevoker): Fix leaking a few bytes.

	* keyedit.c (show_key_with_all_names): Use list-option
	show-long-keyid in main --edit-key display.

	* keyedit.c (print_and_check_one_sig): Use list-option
	show-long-keyid in --edit-key "check" function.

	* passphrase.c (agent_send_all_options): Make use of $GPG_TTY.

	* g10.c (main): Disable use-agent if passphrase-fd is given
	later. Suggested by Kurt Garloff.

	* exec.c, g10.c, gpgv.c, passphrase.c, photoid.c:
	s/__MINGW32__/_WIN32/ to help building on native Windows
	compilers.  Requested by Brian Gladman.  From Werner on stable
	branch.

	* options.h, g10.c (main): Add list-option
	list-preferred-keyserver.

	* keyedit.c (change_passphrase): When responding 'no' to the blank
	passphrase question, re-prompt for a new passphrase.  This is bug
	#202.

	* mainproc.c (check_sig_and_print): Use two different preferred
	keyserver displays - one if the key is not present (to tell the
	user where to get the key), the other if it is present (to tell
	the user where the key can be refreshed).

	* packet.h, parse-packet.c (parse_signature): Set flag if a
	preferred keyserver is present.

	* keylist.c (list_keyblock_print): Show keyserver url in listings
	with list-option show-keyserver-url.

	* mainproc.c (check_sig_and_print): Get the uid validity before
	printing any sig results to avoid munging the output with trustdb
	warnings.

	* g10.c (main): Don't include --show-keyring in --help as it is
	deprecated.

	* options.skel: Note that keyserver.pgp.com isn't synchronized,
	and explain the roundrobin a bit better.

	* sig-check.c (check_key_signature2), import.c (import_one,
	import_revoke_cert, chk_self_sigs, delete_inv_parts,
	collapse_uids, merge_blocks): Make much quieter during import of
	slightly munged, but recoverable, keys. Use log_error for
	unrecoverable import failures.

	* keyring.c (keyring_rebuild_cache): Comment.

	* sign.c (mk_notation_and_policy): Making a v3 signature with
	notations or policy urls is an error, not an info (i.e. increment
	the errorcount). Don't print the notation or policy url to stdout
	since it can be mixed into the output stream when piping and munge
	the stream.

	* packet.h, sig-check.c (signature_check2, do_check,
	do_check_messages): Provide a signing-key-is-revoked flag.  Change
	all callers.

	* status.h, status.c (get_status_string): New REVKEYSIG status tag
	for a good signature from a revoked key.

	* mainproc.c (do_check_sig, check_sig_and_print): Use it here.

	* import.c (import_revoke_cert, merge_blocks, merge_sigs): Compare
	actual signatures on import rather than using keyid or class
	matching.  This does not change actual behavior with a key, but
	does mean that all sigs are imported whether they will be used or
	not.

	* parse-packet.c (parse_signature): Don't give "signature packet
	without xxxx" warnings for experimental pk algorithms.  An
	experimental algorithm may not have a notion of (for example) a
	keyid (i.e. PGP's x.509 stuff).

	* options.h, g10.c (main), keylist.c (list_keyblock_print),
	keyedit.c (print_and_check_one_sig): New "show-sig-expire"
	list-option to show signature expiration dates (if any).

	* options.h, g10.c (main, add_keyserver_url): Add
	--sig-preferred-keyserver to implant a "where to get my key"
	subpacket into a signature.

	* sign.c (mk_notation_and_policy): Rename to
	mk_notation_policy_etc and add preferred keyserver support for
	signatures.

	* keygen.c (do_add_key_flags): Don't set the certify flag for
	subkeys.
	(ask_algo): Provide key flags for DSA, Elgamal_e, and Elgamal
	subkeys.
	(generate_keypair): Provide key flags for the default DSA/Elgamal
	keys.

	* sig-check.c (signature_check, signature_check2,
	check_key_signature, check_key_signature2): Allow passing NULLs
	for unused parameters in the x2 form of each function to avoid the
	need for dummy variables. getkey.c, mainproc.c: Change all
	callers.

	* trustdb.h, trustdb.c (read_trust_options): New.  Returns items
	from the trustdb version record.
	* keylist.c (public_key_list): Use it here for the new "tru"
	record.
	* gpgv.c (read_trust_options): Stub.

	* keyedit.c (show_key_with_all_names): Use list-option
	show-validity in --edit-key interface as well.

	* options.h, g10.c (main), mainproc.c (check_sig_and_print): Add
	verify-options "show-validity" and "show-long-keyid" to show
	trustdb validity and long keyids during (file) signature
	verification.

	* packet.h, main.h, sig-check.c (signature_check2)
	(check_key_signature2, do_check): If ret_pk is set, fill in the pk
	used to verify the signature.  Change all callers in getkey.c,
	mainproc.c, and sig-check.c.

	* keylist.c (list_keyblock_colon): Use the ret_pk from above to
	put the fingerprint of the signing key in "sig" records during a
	--with-colons --check-sigs.  This requires --no-sig-cache as well
	since we don't cache fingerprints.

	* parse-packet.c (parse_signature): No need to reserve 8 bytes for
	the unhashed signature cache any longer.

	* misc.c (pct_expando): Add two new expandos - signer's
	fingerprint (%g), and signer's primary fingerprint (%p).

	* g10.c (main): Add --rfc2440 alias for --openpgp since in a few
	months, they won't be the same thing.

	* keyserver.c (parse_keyserver_uri): Accept "http" as an alias for
	"hkp", since it is occasionally written that way.
	(keyserver_spawn): Use ascii_isspace to avoid locale issues.

	* keygen.c (ask_user_id): Make --allow-freeform-uid apply to the
	email field as well as the name field, and allow mixing fields
	when it is set.

	* trustdb.c (validate_one_keyblock): Certifications on revoked or
	expired uids do not count in the web of trust.

	* signal.c (init_one_signal, pause_on_sigusr, do_block): Only use
	sigprocmask() if we have sigset_t, and only use sigaction() if we
	have struct sigaction.  This is for Forte c89 on Solaris which
	seems to define only the function call half of the two pairs by
	default.
	(pause_on_sigusr): Typo.
	(do_block): If we can't use sigprocmask() and sigset_t, try to get
	the number of signals from NSIG as well as MAXSIG, and if we
	can't, fail with an explanation.

	* signal.c, tdbio.c: Comment out the transaction code.  It was not
	used in this version, and was causing some build problems on
	quasi-posix platforms (Solaris and Forte c89).

	* keylist.c (list_keyblock_colon): Don't include validity values
	when listing secret keys since they can be incorrect and/or
	misleading.  This is a temporary kludge, and will be handled
	properly in 1.9/2.0.

	* mainproc.c (check_sig_and_print): Only show the "key available
	from" preferred keyserver line if the key is not currently
	present.

	* keyedit.c (sign_uids): Do not sign expired uids without --expert
	(same behavior as revoked uids).  Do not allow signing a user ID
	without a self-signature.  --expert overrides.  Add additional
	prompt to the signature level question.
	(menu_expire): When changing expiration dates, don't replace
	selfsigs on revoked uids since this would effectively unrevoke
	them. There is also no point in replacing expired selfsigs.  This
	is bug #181

	* g10.c (add_notation_data): Make sure that only ascii is passed
	to iscntrl.  Noted by Christian Biere.
	* getkey.c (classify_user_id2): Replaced isspace by spacep
	* keygen.c (ask_user_id): Ditto.
	(get_parameter_algo): Ditto.
	* keyedit.c (keyedit_menu): Ditto.
	* tdbdump.c (import_ownertrust): Ditto.  s/isxdigit/hexdigitp/.
	* revoke.c (ask_revocation_reason):
	* keyserver.c (keyserver_spawn): Dito.

	* parse-packet.c (parse): Disallow old style partial length for
	all key material packets to avoid possible corruption of keyrings.

	* import.c (import_keys_internal): Invalidate the cache so that
	the file descriptor gets closed.  Fixes bug reported by Juan
	F. Codagnone.

	* options.h, g10.c (main), main.h, keylist.c (show_keyserver_url),
	mainproc.c (check_sig_and_print), parse-packet.c (dump_sig_subpkt,
	parse_one_sig_subpkt, can_handle_critical): Add read-only support
	for preferred keyserver subpackets.  They're basically policy URLs
	with a different name.  Add a verify-option
	"show-preferred-keyserver" to turn them on and off (on by default,
	as per stable branch).

	* g10.c (main): Add "--set-notation" as alias to "--notation-data"
	this is to make things consistent with --set-policy-url meaning
	both sigs and certs.

	* options.h, g10.c (main), keylist.c (list_keyblock_print): Add
	"show-validity" and "show-long-keyid" list-options.

	* gpgv.c (get_validity, trust_value_to_string): Stubs.

	* g10.c (main): Use SAFE_VERSION instead of VERSION in the
	version-specific gpg.conf file so it can be overridden on RISCOS.

	* keyedit.c (show_key_with_all_names): Fix assertion failure when
	using toggle to see a secret key.  Reported by Maxim Britov.


2003-09-22  Timo Schulz  <twoaday@freakmail.de>

	* card-util.c (card_status): Free pk in case of an error
	and return if the card is no OpenPGP card.

2003-09-18  Werner Koch  <wk@gnupg.org>

	* g10.c: New command --card-edit.
	* card-util.c (card_status): Use tty_fprintf for all output.
	(print_sha1_fpr, print_isoname): Ditto.
	(get_one_name,change_name, change_url, change_login,change_lang)
	(change_sex): New; taken from keygen.c.
	* keygen.c (smartcard_get_one_name, smartcard_change_name)
	(smartcard_change_url, smartcard_change_login_data)
	(smartcard_change_lang, smartcard_change_sex): Removed.
	(check_smartcard): Removed most menu items.

2003-09-06  Werner Koch  <wk@gnupg.org>

	* misc.c (openpgp_pk_algo_usage): Allow AUTH where SIGN is allowed.

	* keygen.c (ask_passphrase): No need to allocated S2K in secure
	memory.

2003-09-04  Werner Koch  <wk@gnupg.org>

	* keygen.c (do_add_key_flags, parse_parameter_usage)
	(do_generate_keypair): Add support the proposed AUTH key flag.
	* getkey.c (fixup_uidnode, merge_selfsigs_main)
	(merge_selfsigs_subkey, premerge_public_with_secret): Ditto.
	* keylist.c (print_capabilities): Ditto.

2003-08-25  Timo Schulz  <twoaday@freakmail.de>

	* pkglue.c (mpi_from_sexp): New. Used to factor out
	some common code.

2003-08-24  Werner Koch  <wk@gnupg.org>

	* keygen.c (do_generate_keypair): Print a reminder to use --gen-revoke.

2003-08-18  Timo Schulz  <twoaday@freakmail.de>

	* encode.c (encode_sesskey): Checked the code and removed
	the warning since all compatibility checks with PGP succeeded.
	* mainproc.c (symkey_decrypt_sesskey): Better check for the
	algorithm and check the return values of some functions.
	* mdc.c (use_mdc): Simplified.

2003-08-07  Werner Koch  <wk@gnupg.org>

	* pkglue.c (pk_sign): Fix last change.
	(pk_verify): Check for valid DATA array so that we don't segv in
	Libgcrypt.
	(pk_verify): Ditto.

2003-08-06  Werner Koch  <wk@gnupg.org>

	* pkglue.c (pk_sign): Allow signing using RSA.

2003-08-05  Werner Koch  <wk@gnupg.org>

	* Makefile.am (install-data-local): Dropped check for the ancient
	gpgm tool.
	(bin_PROGRAMS): Renamed gpg to gpg2 and gpgv to gpgv2.  This is so
	that it won't conflict with the current stable version of gpg.

	* pkglue.c (pk_check_secret_key): New.
	* seckey-cert.c (do_check): Reenable this test here again.

	* g10.c (main): Add command -K as an alias for
	--list-secret-keys. Command "-k" is now an alias to --list-keys.
	Remove special treatment of -kv and -kvv.
	(set_cmd): Ditto.
	(main): Strip a "-cvs" suffix when testing for a version specific
	config file.

	* status.h, status.c, g10.c [USE_SHM_COPROCESSING]: Removed.  This
	is not any longer available.

2003-07-29  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Add secmem features and set the random seed file.
	(g10_exit): Update the random seed file.

	* parse-packet.c (parse_signature,read_protected_v3_mpi)
	(parse_key): Fixed use of mpi_set_opaque.
	* keygen.c (gen_card_key): Ditto.

2003-07-28  Werner Koch  <wk@gnupg.org>

	* status.c (progress_cb): Adjusted for use with Libcgrypt.
	(set_status_fd): Register that callback.

	* keygen.c (smartcard_change_login_data): New.
	(smartcard_change_lang): New.
	(smartcard_change_sex): New.
	(check_smartcard): Add menu entries to edit the above.
	(gen_elg,gen_dsa,gen_rsa): Reimplemented in terms of Libgcrypt.
	(genhelp_protect, genhelp_factors, key_from_sexp): New.
	* comment.c (make_comment_node_from_buffer): New.
	(make_comment_node): Reimplemented in terms of above.

2003-07-27  Werner Koch  <wk@gnupg.org>

	Adjusted for gcry_mpi_print and gcry_mpi_scan API change.

2003-07-24  Werner Koch  <wk@gnupg.org>

	* g10.c: New command --card-status.
	* card-util.c (card_status): New.
	* call-agent.c (learn_status_cb): Parse more information.

	* keylist.c (print_pubkey_info): Add FP arg for optional printing
	to a stream.  Changed all callers.

2003-07-23  Werner Koch  <wk@gnupg.org>

	* keygen.c (generate_keypair): Create an AUTHKEYTYPE entry for cards.
	(do_generate_keypair): Abd generate the authkey.
	(check_smartcard): Changed menu accordingly.

2003-07-22  Werner Koch  <wk@gnupg.org>

	* g10.c: New command --change-pin.
	* card-util.c: New.
	* call-agent.c (agent_scd_change_pin): New.
	(agent_release_card_info): New.
	* keygen.c (check_smartcard): Use it here.

2003-07-16  Werner Koch  <wk@gnupg.org>

	* export.c (parse_export_options): New option sexp-format.
	(export_seckeys,export_secsubkeys): Check sexp-format option.
	(do_export): Ignore armor for sexp format.
	(do_export_stream): Handle sexp-format.
	(write_sexp_line,write_sexp_keyparm, build_sexp_seckey): New.
	(build_sexp): New.

2003-07-03  Werner Koch  <wk@gnupg.org>

	* options.h (DBG_CIPHER): Reintroduced it.
	* seskey.c (encode_session_key): Debug output of the session key.

	* pubkey-enc.c (get_it): Handle card case.
	* call-agent.c (agent_scd_pkdecrypt): New.
	* pkglue.c (pk_encrypt): Add RSA support.

	* g10.c (main): Default to --use-agent.

	* keygen.c (show_smartcard): Print info about the public key.
	(check_smartcard): Check for existing key here.
	(gen_card_key): And not anymore here.
	(fpr_is_zero): New.
	(generate_keypair): Generate both keys for a card.
	(smartcard_change_url): Nw.

2003-07-02  Werner Koch  <wk@gnupg.org>

	* seckey-cert.c (is_secret_key_protected): Let it handle mode 1002.

2003-07-01  Werner Koch  <wk@gnupg.org>

	* keygen.c (gen_card_key): Obviously we should use the creation
	date received from SCDAEMON, so that the fingerprints will match.
	* sign.c (do_sign): Pass the serialno to the sign code.
	* keyid.c (serialno_and_fpr_from_sk): New.

2003-06-30  Werner Koch  <wk@gnupg.org>

	* call-agent.h (agent_card_info_s): Add field serialno.
	* call-agent.c (store_serialno): New.
	(learn_status_cb): Store the serial number.
	* keygen.c (gen_card_key): Store the serial number
	(check_smartcard): New argument to return the serial number.
	(generate_keypair): Get the serial number from check_smartcard and
	store it as a parameter.
	* parse-packet.c (parse_key): Use the protect.iv field to store the
	serial number.
	* build-packet.c (do_secret_key): Write the serial number.

2003-06-27  Werner Koch  <wk@gnupg.org>

	* seckey-cert.c (check_secret_key): Bypass the unprotection for
	mode 1002.
	* sign.c (do_sign): Handle card case (i.e. mode 1002).

2003-06-26  Werner Koch  <wk@gnupg.org>

	* build-packet.c (do_secret_key): Implement special protection
	mode 1002.
	* parse-packet.c (parse_key): Likewise.

	* keygen.c (smartcard_gen_key): New.
	* call-agent.c (agent_scd_setattr): New.

2003-06-24  Werner Koch  <wk@gnupg.org>

	* Makefile.am: Removed signal.c

	* g10.c (emergency_cleanup): New.
	(main): Use gnupg_init_signals and register malloc for assuan.

2003-06-23  Werner Koch  <wk@gnupg.org>

	* keyid.c (do_fingerprint_md): Made it work again.

2003-06-19  Werner Koch  <wk@gnupg.org>

	Fixed all "==" comparisons against error code constants to use
	gpg_err_code().

	* import.c (import_secret_one):
	(import_revoke_cert):
	(chk_self_sigs):

	* misc.c (openpgp_md_map_name): Check also for the Hx format.
	(openpgp_cipher_map_name): Check also for the Sx format.
	(pubkey_get_npkey): Adjusted for changed gcrypt API.
	(pubkey_get_nskey): Ditto.
	(pubkey_get_nsig): Ditto.
	(pubkey_get_nenc): Ditto.

2003-06-18  Werner Koch  <wk@gnupg.org>

        Finished the bulk of changes for gnupg 1.9.  This included
	switching to libgcrypt functions, using shared error codes from
	libgpg-error, replacing the old functions we used to have in
	../util by those in ../jnlib and ../common, renaming the malloc
	functions and a couple of types.  Note, that not all changes are
	listed below becuause they are too similar and done at far too
	many places.  As of today the code builds using the current
	libgcrypt from CVS but it is very unlikely that it actually works.

	* sig-check.c (cmp_help): Removed.  Was never used.

	* pkglue.c: New. Most stuff taken from gnupg 1.1.2.
	* pkglue.h: New.

	* misc.c (pull_in_libs): Removed.

	* keygen.c (count_chr): New.
	(ask_user_id): Removed faked RNG support.

	* misc.c (openpgp_md_map_name,openpgp_cipher_map_name)
	(openpgp_pk_map_name): New.

	* skclist.c (build_sk_list): Removed faked RNG support.
	(is_insecure): Removed.

	* comment.c (make_mpi_comment_node): Use gcry MPI print function.

	* keyid.c (v3_keyid): New.

	* misc.c (mpi_write,mpi_write_opaque,mpi_read,mpi_read_opaque)
	(mpi_print): New.  Taken from gnupg 1.1.2.
	(checksum_mpi): Replaced by implementation from 1.1.2.

	* g10.c (my_strusage): Renamed from strusage and return NULL
	instead calling a default function.
	(add_to_strlist2): New.  Taken from ../util/strgutil.c of gnupg 1.2.

	* plaintext.c (handle_plaintext): New arg CREATE_FILE to cope with
	the fact that gpg-error does not have this error code anymore.

	* mainproc.c (symkey_decrypt_sesskey): Ditto.

	* seskey.c (make_session_key): Adjusted for use with libgcrypt.
	(encode_session_key): Ditto.
	(do_encode_md): Ditto.
	(encode_md_value): Ditto.

	* keyring.c: Use libgpg-error instead of READ_ERROR etc.

	* g10.c: Adjusted all algorithm name/id mapping functions.
	(set_debug): Pass MPI and CRYPTO debug values to libgcrypt.

	* Makefile.am (INCLUDES): Define LOCALEDIR and the default error
	source.

	* g10.c (i18n_init): s/G10_LOCALEDIR/LOCALEDIR/.

	Renamed m_alloc et al to xmalloc et al.
	s/g10_errstr/gpg_strerror/
	s/MPI/gcry_mpi_t/
	Adjusted all md_open calls to the libgcrypt API.

	* build-packet.c (do_comment): Return error code from iobuf write
	function.
	(do_user_id): Ditto.
	(do_public_key): Ditto.

	* Makefile.am: Add new files, link gpg with libgpg-error.
	* g10.c, options.h: New option --agent-program.
	* call-agent.c: New.
	* gpg.h, call-agent.h: New.

2003-06-03  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), keylist.c (list_keyblock_print): Add
	"show-validity" and "show-long-keyid" list-options.

	* gpgv.c (get_validity, trust_value_to_string): Stubs.

	* g10.c (main): Use SAFE_VERSION instead of VERSION in the
	version-specific gpg.conf file so it can be overridden on RISCOS.

2003-06-01  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main), keylist.c (show_policy_url, show_notation),
	mainproc.c (check_sig_and_print): Emulate the old policy and
	notation behavior (display by default).  Send to status-fd whether
	it is displayed on the screen or not.

	* g10.c (main): Since we now have some options in devel that won't
	work in a stable branch gpg.conf file, try for a version-specific
	gpg.conf-VERSION file before falling back to gpg.conf.

	* main.h, options.h: Move various option flags to options.h.

2003-05-31  David Shaw  <dshaw@jabberwocky.com>

	* mainproc.c (check_sig_and_print), main.h, keylist.c
	(show_policy, show_notation): Collapse the old print_notation_data
	into show_policy() and show_notation() so there is only one
	function to print notations and policy URLs.

	* options.h, main.h, g10.c (main), keyedit.c
	(print_and_check_one_sig), keylist.c (list_one,
	list_keyblock_print), pkclist.c (do_edit_ownertrust), sign.c
	(mk_notation_and_policy): New "list-options" and "verify-options"
	commands.  These replace the existing
	--show-photos/--no-show-photos,
	--show-notation/--no-show-notation,
	--show-policy-url/--no-show-policy-url, and --show-keyring
	options.  The new method is more flexible since a user can specify
	(for example) showing photos during sig verification, but not in
	key listings.  The old options are emulated.

	* main.h, misc.c (parse_options): New general option line
	parser. Fix the bug in the old version that did not handle report
	syntax errors after a valid entry.

	* import.c (parse_import_options), export.c
	(parse_export_options): Call it here instead of duplicating the
	code.

2003-05-30  David Shaw  <dshaw@jabberwocky.com>

	* keylist.c (list_one): Don't show the keyring filename when in
	--with-colons mode.  Actually translate "Keyring" string.

	* mainproc.c (proc_tree): We can't currently handle multiple
	signatures of different classes or digests (we'd pretty much have
	to run a different hash context for each), but if they are all the
	same, make an exception.  This is Debian bug #194292.

	* sig-check.c (check_key_signature2): Make string translatable.

	* packet.h, getkey.c (fixup_uidnode): Mark real primary uids
	differently than assumed primaries.

	* keyedit.c (no_primary_warning): Use the differently marked
	primaries here in a new function to warn when an --edit-key
	command might rearrange the self-sig dates enough to change which
	uid is primary.
	(menu_expire, menu_set_preferences): Use no_primary_warning()
	here.

	* Makefile.am: Use @DLLIBS@ for -ldl.

2003-05-26  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (premerge_public_with_secret): Made "no secret subkey
	for" warning a verbose item and translatable. (From wk on stable
	branch)

	* sig-check.c (check_key_signature2): Made "no subkey for subkey
	binding packet" a verbose item instead of a !quiet one.  There are
	too many garbled keys out in the wild. (From wk on stable branch)

	* filter.h: Remove const from WHAT. (From wk on stable branch)

	* progress.c (handle_progress): Store a copy of
	NAME. (progress_filter): Release WHAT, make sure not to print a
	NULL WHAT. (From wk on stable branch)

	* openfile.c (open_sigfile): Adjust free for new progress
	semantics. (From wk on stable branch)

	* plaintext.c (ask_for_detached_datafile): Don't dealloc
	pfx->WHAT. (From wk on stable branch)

	* seckey-cert.c (do_check): Issue the RSA_OR_IDEA status when the
	cipher algo is IDEA to make it easier to track down the
	problem. (From twoaday on stable branch)

2003-05-24  David Shaw  <dshaw@jabberwocky.com>

	* armor.c, g10.c, kbnode.c, misc.c, pkclist.c, sign.c,
	build-packet.c, getkey.c, keydb.c, openfile.c, plaintext.c,
	status.c, gpgv.c, keygen.c, options.h, sig-check.c, tdbio.h,
	encode.c, mainproc.c, parse-packet.c, signal.c, textfilter.c: Edit
	all preprocessor instructions to remove whitespace before the '#'.
	This is not required by C89, but there are some compilers out
	there that don't like it.

2003-05-21  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.h, trustdb.c (is_disabled), gpgv.c (is_disabled): Rename
	is_disabled to cache_disabled_value, which now takes a pk and not
	just the keyid. This is for speed since there is no need to
	re-fetch a key when we already have that key handy.  Cache the
	result of the check so we don't need to hit the trustdb more than
	once.

	* getkey.c (skip_disabled): New function to get a pk and call
	is_disabled on it. (key_byname): Use it here.

	* packet.h, getkey.c (skip_disabled), keylist.c
	(print_capabilities): New "pk_is_disabled" macro to retrieve the
	cached disabled value if available, and fill it in via
	cache_disabled_value if not available.

	* trustdb.c (get_validity): Cache the disabled value since we have
	it handy and it might be useful later.

	* parse-packet.c (parse_key): Clear disabled flag when parsing a
	new key.  Just in case someone forgets to clear the whole key.

	* getkey.c (merge_selfsigs_main): Add an "if all else fails" path
	for setting a single user ID primary when there are multiple set
	primaries all at the same second, or no primaries set and the most
	recent user IDs are at the same second, or no signed user IDs at
	all. This is arbitrary, but deterministic.

	* exec.h, photoid.h: Add copyright message.

	* keylist.c (list_keyblock_print): Don't dump attribs for
	revoked/expired/etc uids for non-colon key listings.  This is for
	consistency with --show-photos.

	* main.h, keylist.c (dump_attribs), mainproc.c
	(check_sig_and_print): Dump attribs if --attrib-fd is set when
	verifying signatures.

	* g10.c (main): New --gnupg option to disable the various
	--openpgp, --pgpX, etc. options.  This is the same as --no-XXXX
	for those options.

	* revoke.c (ask_revocation_reason): Clear old reason if user
	elects to repeat question.  This is bug 153.

	* keyedit.c (sign_uids): Show keyid of the key making the
	signature.

2003-05-21  Werner Koch  <wk@gnupg.org>

	* progress.c (handle_progress)
	* sign.c (write_plaintext_packet)
	* encode.c (encode_simple,encode_crypt): Make sure that a filename
	of "-" is considered to be stdin so that iobuf_get_filelength
	won't get called.  This fixes bug 156 reported by Gregery Barton.

2003-05-02  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, build-packet.c (build_sig_subpkt), export.c
	(do_export_stream), import.c (remove_bad_stuff, import),
	parse-packet.c (dump_sig_subpkt, parse_one_sig_subpkt): Remove
	vestigal code for the old sig cache subpacket.  This wasn't
	completely harmless as it caused subpacket 101 to disappear on
	import and export.

	* options.h, armor.c, cipher.c, g10.c, keyedit.c, pkclist.c,
	sign.c, encode.c, getkey.c, revoke.c: The current flags for
	different levels of PGP-ness are massively complex.  This is step
	one in simplifying them. No functional change yet, just use a
	macro to check for compliance level.

	* sign.c (sign_file): Fix bug that causes spurious compression
	preference warning.

	* sign.c (clearsign_file): Fix bug that prevents proper warning
	message from appearing when clearsigning in --pgp2 mode with a
	non-v3 RSA key.

	* main.h, misc.c (compliance_option_string, compliance_string,
	compliance_failure), pkclist.c (build_pk_list), sign.c (sign_file,
	clearsign_file), encode.c (encode_crypt,
	write_pubkey_enc_from_list): New functions to put the "this
	message may not be usable...." warning in one place.

	* options.h, g10.c (main): Part two of the simplification.  Use a
	single enum to indicate what we are compliant to (1991, 2440,
	PGPx, etc.)

	* g10.c (main): Show errors for failure in export, send-keys,
	recv-keys, and refresh-keys.

	* options.h, g10.c (main): Give algorithm warnings for algorithms
	chosen against the --pgpX and --openpgp rules.

	* keydb.h, pkclist.c (algo_available): Make TIGER192 invalid in
	--openpgp mode.

	* sign.c (sign_file), pkclist.c (algo_available): Allow passing a
	hint of 0.

2003-05-01  David Shaw  <dshaw@jabberwocky.com>

	* tdbio.c (create_version_record): Only create new trustdbs with
	TM_CLASSIC or TM_PGP.

	* trustdb.h, trustdb.c (trust_string, get_ownertrust_string,
	get_validity_string, ask_ownertrust, validate_keys), pkclist.c
	(do_edit_ownertrust): Rename trust_string to trust_value_to_string
	for naming consistency.

	* trustdb.h, trustdb.c (string_to_trust_value): New function to
	translate a string to a trust value.

	* g10.c (main): Use string_to_trust_value here for
	--force-ownertrust.

	* options.h, g10.c (main), trustdb.c (trust_model_string,
	init_trustdb, check_trustdb, update_trustdb, get_validity,
	validate_one_keyblock): An "OpenPGP" trust model is misleading
	since there is no official OpenPGP trust model.  Use "PGP"
	instead.

2003-04-30  David Shaw  <dshaw@jabberwocky.com>

	* build-packet.c (build_sig_subpkt): Comments.

	* exec.c (exec_write): Cast NULL to void* to properly terminate
	varargs list.

	* keyedit.c (show_key_with_all_names): Just for safety, catch an
	invalid pk algorithm.

	* sign.c (make_keysig_packet): Crucial that the call to mksubpkt
	comes LAST before the calls to finalize the sig as that makes it
	possible for the mksubpkt function to get a reliable pointer to
	the subpacket area.

	* pkclist.c (do_we_trust_pre): If an untrusted key was chosen by a
	particular user ID, use that ID as the one to ask about when
	prompting whether to use the key anyway.
	(build_pk_list): Similar change here when adding keys to the
	recipient list.

	* trustdb.c (update_validity): Fix bug that prevented more than
	one validity record per trust record.
	(get_validity): When retrieving validity for a (user) supplied
	user ID, return the validity for that user ID only, and do not
	fall back to the general key validity.
	(validate_one_keyblock): Some commentary on whether
	non-self-signed user IDs belong in the web of trust (arguably,
	they do).

2003-04-27  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Add --no-textmode.

	* export.c (do_export_stream), keyedit.c (show_key_with_all_names,
	menu_addrevoker), mainproc.c (check_sig_and_print), photoid.c
	(show_photos), sign.c (mk_notation_and_policy), trustdb.c
	(get_validity, reset_trust_records, validate_keys): Make some
	strings translatable.

	* mainproc.c (check_sig_and_print): Show digest algorithm and sig
	class when verifying a sig with --verbose on, and add version, pk
	and hash algorithms and sig class to VALIDSIG.

	* parse-packet.c (enum_sig_subpkt): Make a warning message a
	--verbose warning message since we don't need to warn every time
	we see an unknown critical (we only need to invalidate the
	signature).

	* trustdb.c (init_trustdb): Check the trustdb options even with
	TM_AUTO since the auto may become TM_CLASSIC or TM_OPENPGP.

2003-04-26  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (do_sign): Show the hash used when making a signature in
	verbose mode.

	* tdbio.h, tdbio.c (tdbio_read_model): New function to return the
	trust model used in a given trustdb.

	* options.h, g10.c (main), trustdb.c (init_trustdb, check_trustdb,
	update_trustdb): Use tdbio_read_model to implement an "auto" trust
	model which is set via the trustdb.

2003-04-23  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_revoke_cert): Remove ultimate trust when
	revoking an ultimately trusted key.

	* keyedit.c (sign_uids): Allow replacing expired signatures.
	Allow duplicate signatures with --expert.

	* pkclist.c (check_signatures_trust): Don't display a null
	fingerprint when checking a signature with --always-trust enabled.

	* filter.h (progress_filter_context_t), progress.c
	(handle_progress), plaintext.c (ask_for_detached_datafile,
	hash_datafiles): Fix compiler warnings.  Make "what" constant.

	* build-packet.c (do_plaintext): Do not create invalid literal
	packets with >255-byte names.

2003-04-15  Werner Koch  <wk@gnupg.org>

	* Makefile.am (AM_CFLAGS): Make use of AM_CFLAGS and AM_LDFLAGS.

	* g10.c, options.h: New option --enable-progress-filter.
	* progress.c (handle_progress): Make use of it.

2003-04-15  Marcus Brinkmann  <marcus@g10code.de>

	* progress.c: New file.
	* Makefile.am (common_source): Add progress.c.
	* filter.h (progress_filter_context_t): New type.
	(progress_filter, handle_progress): New prototypes.
	* main.h (open_sigfile): New argument for prototype.
	* openfile.c (open_sigfile): New argument to install progress
	filter.
	* encode.c (encode_simple): New variable PFX.  Register
	progress filter.  Install text_filter after that.
	(encode_crypt): Likewise.
	* sign.c (sign_file): Likewise.
	(clearsign_file): Likewise.
	* decrypt.c (decrypt_message): Likewise.
	(decrypt_messages): Likewise.
	* verify.c (verify_signatures): Likewise.
	(verify_one_file): Likewise.
	* plaintext.c (hash_datafiles): Likewise.
	(ask_for_detached_datafile): Likewise.

2003-04-10  Werner Koch  <wk@gnupg.org>

	* passphrase.c (read_passphrase_from_fd): Do a dummy read if the
	agent is to be used.  Noted by Ingo Klöcker.
	(agent_get_passphrase): Inhibit caching when we have no
	fingerprint.  This is required for key generation as well as for
	symmetric only encryption.

	* passphrase .c (agent_get_passphrase): New arg CANCELED.
	(passphrase_to_dek): Ditto.  Passed to above.  Changed all
	callers to pass NULL.
	* seckey-cert.c (do_check): New arg CANCELED.
	(check_secret_key): Terminate loop when canceled.

	* keyedit.c (change_passphrase): Pass ERRTEXT untranslated to
	passphrase_to_dek and translate where appropriate.
	* seckey-cert.c (check_secret_key): Ditto.
	* keygen.c (ask_passphrase): Ditto.
	* passphrase.c (agent_get_passphrase): Translate the TRYAGAIN_TEXT.
	Switch the codeset to utf-8.

2003-04-09  Werner Koch  <wk@gnupg.org>

	* decrypt.c (decrypt_messages): Fixed error handling; the function
	used to re-loop with same file after an error.  Reported by Joseph
	Walton.

2003-04-08  David Shaw  <dshaw@jabberwocky.com>

	* main.h, g10.c (main), import.c (parse_import_options,
	fix_pks_corruption): It's really PKS corruption, not HKP
	corruption.  Keep the old repair-hkp-subkey-bug command as an
	alias.

	* g10.c (main): Rename --no-version to --no-emit-version for
	consistency.  Keep --no-version as an alias.

2003-04-04  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (algo_available): PGP 8 can use the SHA-256 hash.

	* sign.c (sign_file, clearsign_file, sign_symencrypt_file): Remove
	unused code.

2003-04-01  Werner Koch  <wk@gnupg.org>

	* mainproc.c (check_sig_and_print): Add primary key fpr to VALIDSIG
	status.

2003-03-24  David Shaw  <dshaw@jabberwocky.com>

	* keydb.h: Err on the side of making an unknown signature a SIG
	rather than a CERT.

	* import.c (delete_inv_parts): Discard any key signatures that
	aren't key types (i.e. 0x00, 0x01, etc.)

	* g10.c (main): Add deprecated option warning for
	--list-ownertrust.  Add --compression-algo alias for
	--compress-algo.  Change --version output strings to match
	"showpref" strings, and make translatable.

	* status.c (do_get_from_fd): Accept 'y' as well as 'Y' for
	--command-fd boolean input.

	* trustdb.c: Fix typo (DISABLE_REGEXP -> DISABLE_REGEX)

	* keyedit.c (show_key_with_all_names_colon): Show no-ks-modify
	flag.

2003-03-11  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), keyserver.c (kopts): Add "try-dns-srv"
	keyserver option.  Defaults to on.

	* passphrase.c (agent_get_passphrase): Fix memory leak with
	symmetric messages.  Fix segfault with symmetric messages.  Fix
	incorrect prompt with symmetric messages.

2003-03-10  Werner Koch  <wk@gnupg.org>

	* compress.c (init_uncompress): Use a 15 bit window size so that
	the output of implementations which don't run for PGP 2
	compatibility won't get garbled.

2003-03-04  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (validate_keys): Mask the ownertrust when building the
	list of fully valid keys so that disabled keys are still counted
	in the web of trust.
	(get_ownertrust_with_min): Do the same for the minimum ownertrust
	calculation.

	* parse-packet.c (dump_sig_subpkt): Show the notation names for
	not-human-readable notations.  Fix cosmetic off-by-one length
	counter.

	* options.skel: Add explantion and commented-out
	"no-mangle-dos-filenames".

	* mainproc.c (proc_encrypted): Make string translatable.

	* keyserver.c (keyserver_spawn): Quote ':', '%', and any 8-bit
	characters in the uid strings sent to the keyserver helper.

	* keyring.c (keyring_rebuild_cache): Lock the keyring while
	rebuilding the signature caches to prevent another gpg from
	tampering with the temporary copy.

	* keygen.c (keygen_set_std_prefs): Include AES192 and AES256 in
	default prefs.

	* keyedit.c (show_prefs): Make strings translatable.

	* keydb.c: Double the maximum number of keyrings to 40.

	* gpgv.c (main): Fix bug #113 - gpgv should accept the
	--ignore-time-conflict option.

	* g10.c (main): --openpgp disables --pgpX.  Double the amount of
	secure memory to 32k (keys are getting bigger these days).

	* Makefile.am: Makefile.am: Use @CAPLIBS@ to link in -lcap if we
	are using capabilities.

2003-02-26  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Include various pieces of
	information about the key in the data sent to the keyserver
	helper.  This allows the helper to use it in instructing a remote
	server which may not have any actual OpenPGP smarts in parsing
	keys.

	* main.h, export.c (export_pubkeys_stream, do_export_stream): Add
	ability to return only the first match in an exported keyblock for
	keyserver usage.  This should be replaced at some point with a
	more flexible solution where each key can be armored seperately.

2003-02-22  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (sign_file): Do not push textmode filter onto an unopened
	IOBUF (segfault).  Noted by Marcus Brinkmann.  Push and
	reinitialize textmode filter for each file in a multiple file
	list.

	* packet.h, getkey.c (fixup_uidnode), keyedit.c (show_prefs): Set
	and show the keyserver no-modify flag.

	* keygen.c (add_keyserver_modify): New.
	(keygen_upd_std_prefs): Call it here.
	(keygen_set_std_prefs): Accept "ks-modify" and "no-ks-modify" as
	prefs to set and unset keyserver modify flag.

	* g10.c (main): Accept "s1" in addition to "idea" to match the
	other ciphers.

	* main.h, misc.c (idea_cipher_warn): We don't need this if IDEA
	has been disabled.

2003-02-21  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (keygen_set_std_prefs): Don't put AES or CAST5 in
	default prefs if they are disabled.

	* g10.c (main): Use 3DES instead of CAST5 if we don't have CAST5
	support.  Use 3DES for the s2k cipher in --openpgp mode.
	(print_mds): #ifdef all of the optional digest algorithms.

2003-02-12  David Shaw  <dshaw@jabberwocky.com>

	* keydb.h, getkey.c (classify_user_id, classify_user_id2): Make
	'exact' a per-desc item.  Merge into one function since
	'force_exact' is no longer needed.
	(key_byname): Use new classify_user_id function, and new exact
	flag in KEYDB_SEARCH_DESC.

	* keyring.h, keyring.c (keyring_search): Return an optional index
	to show which KEYDB_SEARCH_DESC was the matching one.

	* keydb.h, keydb.c (keydb_search): Rename to keydb_search2, and
	pass the optional index to keyring_search.  Add a macro version of
	keydb_search that calls this new function.

	* export.c (do_export_stream): If the keyid! syntax is used,
	export only that specified key.  If the key in question is a
	subkey, export the primary plus that subkey only.

2003-02-11  David Shaw  <dshaw@jabberwocky.com>

	* exec.c (set_exec_path): Add debugging line.

	* g10.c (print_hex, print_mds): Print long hash strings a lot
	neater.  This assumes at least an 80-character display, as there
	are a few other similar assumptions here and there.  Users who
	need unformatted hashes can still use with-colons.  Check that
	SHA384 and 512 are available before using them as they are no
	longer always available.

	* Makefile.am: Use a local copy of libexecdir along with @PACKAGE@
	as GNUPG_LIBEXECDIR so it can be easily overridden at make time.

2003-02-04  David Shaw  <dshaw@jabberwocky.com>

	* armor.c (parse_hash_header, armor_filter): Accept the new SHAs
	in the armor Hash: header.

	* g10.c (print_hex): Print long hash strings a little neater.
	(print_mds): Add the new SHAs to the hash list.

2003-02-02  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_revuid): Properly handle a nonselfsigned uid on
	a v4 key (treat as a v4 revocation).

	* import.c (print_import_check): Do not re-utf8 convert user IDs.

2003-01-27  David Shaw  <dshaw@jabberwocky.com>

	* mainproc.c (list_node): Show signature expiration date in
	with-colons sig records.

	* keylist.c (list_keyblock_colon), mainproc.c (list_node): Show
	trust sig information in with-colons sig records.

2003-01-16  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (add_group): Trim whitespace after a group name so it does
	not matter where the user puts the = sign.

	* options.skel: Comment out the first three lines in case someone
	manually copies the skel file to their homedir.

	* sign.c (clearsign_file): Only use pgp2mode with v3 keys and
	MD5. This matches what we do when decoding such messages and
	prevents creating a message (v3+RIPEMD/160) that we can't verify.

	* sig-check.c (signature_check2): Use G10ERR_GENERAL as the error
	for signature digest conflict.  BAD_SIGN implies that a signature
	was checked and we may try and print out a user ID for a key that
	doesn't exist.

2003-01-15  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (init_trustdb, get_validity): Don't use a changed
	trust model to indicate a dirty trustdb, and never auto-rebuild a
	dirty trustdb with the "always" trust model.

	* g10.c (add_group): Last commit missed the \t ;)

2003-01-14  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, parse-packet.c (setup_user_id), free-packet.c
	(free_user_id), keydb.h, keyid.c (namehash_from_uid): New function
	to rmd160-hash the contents of a user ID packet and cache it in
	the uid object.

	* keylist.c (list_keyblock_colon): Use namehash in field 8 of
	uids.  Show dates for creation (selfsig date), and expiration in
	fields 6 and 7.

	* trustdb.c (get_validity, get_validity_counts, update_validity):
	Use new namehash function rather than hashing it locally.

2003-01-14  Werner Koch  <wk@gnupg.org>

	* g10.c (add_group): Fixed group parsing to allow more than one
	delimiter in a row and also allow tab as delimiter.

2003-01-12  David Shaw  <dshaw@jabberwocky.com>

	* tdbio.c (tdbio_set_dbname): Fix assertion failure with
	non-fully-qualified trustdb names.

2003-01-11  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (get_validity_info, get_ownertrust_info,
	trust_letter): Simplify by returning a ? for error directly.

	* keyedit.c (show_key_with_all_names): Use get_validity_string and
	get_ownertrust_string to show full word versions of trust
	(i.e. "full" instead of 'f').

	* trustdb.h, trustdb.c (get_ownertrust_string,
	get_validity_string): Same as get_ownertrust_info, and
	get_validity_info, except returns a full string.

	* trustdb.c (get_ownertrust_with_min): New.  Same as
	'get_ownertrust' but takes the min_ownertrust value into account.

2003-01-10  David Shaw  <dshaw@jabberwocky.com>

	* armor.c (armor_filter): Comment about PGP's end of line tab
	problem.

	* trustdb.h, trustdb.c (trust_letter): Make
	static. (get_ownertrust_info, get_validity_info): Don't mask the
	trust level twice.

	* trustdb.h, gpgv.c, trustdb.c (get_validity, get_validity_info),
	keylist.c (list_keyblock_colon), keyedit.c
	(show_key_with_all_names_colon, menu_revuid): Pass a user ID in
	rather than a namehash, so we only have to do the hashing in one
	place.

	* packet.h, pkclist.c (build_pk_list), free-packet.c
	(release_public_key_parts): Remove unused namehash element for
	public keys.

2003-01-07  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (keygen_set_std_prefs): Warn when setting an IDEA
	preference when IDEA is not available.

2003-01-06  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (get_validity_info): 'd' for disabled is not a
	validity value any more.

	* packet.h, tdbio.h, tdbio.c (tdbio_read_record,
	tdbio_write_record), trustdb.c (update_validity): Store temporary
	full & marginal counts in the trustdb.
	(clear_validity, get_validity_counts): Return and clear temp
	counts.
	(store_validation_status): Keep track of which keyids have been
	stored.
	(validate_one_keyblock, validate_key_list): Use per-uid copies of
	the full & marginal counts so they can be recalled for multiple
	levels.
	(validate_keys): Only use unused keys for each new round.
	(reset_unconnected_keys): Rename to reset_trust_records, and only
	skip specifically excluded records.

	* keylist.c (print_capabilities): Show 'D' for disabled keys in
	capabilities section.

	* trustdb.c (is_disabled): Remove incorrect comment.

2003-01-03  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_one): Only do the work to create the status
	display for interactive import if status is enabled.

	* keyring.c (keyring_search): skipfnc didn't work properly with
	non-keyid searches.  Noted by Stefan Bellon.

	* getkey.c (merge_selfsigs_main): Remove some unused code and make
	sure that the pk selfsigversion member accounts for 1F direct
	sigs.

2003-01-02  Werner Koch  <wk@gnupg.org>

	* keydb.c (keydb_add_resource): Don't assume that try_make_homedir
	terminates but check again for the existence of the directory and
	continue then.
	* openfile.c (copy_options_file): Print a warning if the skeleton
	file has active options.

2002-12-29  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (merge_selfsigs_main), main.h, sig-check.c
	(check_key_signature2): Pass the ultimately trusted pk directly to
	check_key_signature2 to avoid going through the key selection
	mechanism.  This prevents a deadly embrace when two keys without
	selfsigs each sign the other.

2002-12-27  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_refresh): Don't print the "refreshing..."
	line if there are no keys to refresh or if there is no keyserver
	set.

	* getkey.c (merge_selfsigs_main): Any valid user ID should make a
	key valid, not just the last one.  This also fixes Debian bug
	#174276.

2002-12-27  Stefan Bellon  <sbellon@sbellon.de>

	* import.c (print_import_check): Changed int to size_t.

2002-12-27  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (keyedit_menu, menu_revuid): Add "revuid" feature to
	revoke a user ID.  This is the same as issuing a revocation for
	the self-signature, but a much simpler interface to do it.

2002-12-26  David Shaw  <dshaw@jabberwocky.com>

	* keydb.h, getkey.c (key_byname): Flag to enable or disable
	including disabled keys.  Keys specified via keyid (i.e. 0x...)
	are always included.

	* getkey.c (get_pubkey_byname, get_seckey_byname2,
	get_seckey_bynames), keyedit.c (keyedit_menu, menu_addrevoker):
	Include disabled keys in these functions.

	* pkclist.c (build_pk_list): Do not include disabled keys for -r
	or the key prompt.  Do include disabled keys for the default key
	and --encrypt-to.

	* trustdb.h, trustdb.c (is_disabled): New skipfnc for skipping
	disabled keys.

	* gpgv.c (is_disabled): Stub.

	* keygen.c (keygen_add_key_expire): Properly handle updating a key
	expiration to a no-expiration value.

	* keyedit.c (enable_disable_key): Comment.

	* import.c (import_one): When in interactive mode and --verbose,
	don't repeat some key information twice.

2002-12-22  Timo Schulz  <ts@winpt.org>

	* import.c (print_import_check): New.
	(import_one): Use it here.
        Use merge_keys_and_selfsig in the interactive mode to avoid
        wrong key information.
        * status.h: Add new status code.
        * status.c: Ditto.

2002-12-13  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (do_we_trust): Tweak language to refer to the "named
	user" rather than "owner".  Noted by Stefan Bellon.

	* trustdb.h, trustdb.c (trustdb_pending_check): New function to
	check if the trustdb needs a check.

	* import.c (import_keys_internal): Used here so we don't rebuild
	the trustdb if it is still clean.
	(import_one, chk_self_sigs): Only mark trustdb dirty if the key
	that is being imported has any sigs other than self-sigs.
	Suggested by Adrian von Bidder.

	* options.skel: Include the required '=' sign in the sample
	'group' option.  Noted by Stefan Bellon.

	* import.c (chk_self_sigs): Don't try and check a subkey as if it
	was a signature.

2002-12-11  David Shaw  <dshaw@jabberwocky.com>

	* tdbio.c (tdbio_read_record, tdbio_write_record): Compact the
	RECTYPE_TRUST records a bit.

	* g10.c (main): Comment out --list-trust-path until it can be
	implemented.

	* import.c (import_one): Warn when importing an Elgamal primary
	that this may take some time (to verify self-sigs).
	(chk_self_sigs): Try and cache all self-sigs so the keyblock is
	written to the keyring with a good rich cache.

	* keygen.c (ask_algo): Make the Elgamal sign+encrypt warning
	stronger, and remove the RSA sign+encrypt warning.

2002-12-06  Stefan Bellon  <sbellon@sbellon.de>

	* options.h: Fixed typo (mangle_dos_names instead of
	mangle_dos_filenames).

2002-12-05  Werner Koch  <wk@gnupg.org>

	* g10.c: New options --[no-]mangle-dos-filenames.
	* options.h (opt): Added mangle-dos-filenames.
	* openfile.c (open_outfile) [USE_ONLY_8DOT3]: Truncate the
	filename only when this option is set; this is the default.

2002-12-04  David Shaw  <dshaw@jabberwocky.com>

	* main.h, keyedit.c, keygen.c: Back out previous (2002-12-01)
	change.  Minimal isn't always best.

	* sign.c (update_keysig_packet): Use the current time rather then
	a modification of the original signature time.  Make sure that
	this doesn't cause a time warp.

	* keygen.c (keygen_add_key_expire): Properly handle a key
	expiration date in the past (use a duration of 0).

	* keyedit.c (menu_expire): Use update_keysig_packet so any sig
	subpackets are maintained during the update.

	* build-packet.c (build_sig_subpkt): Mark sig expired or unexpired
	when the sig expiration subpacket is added.
	(build_sig_subpkt_from_sig): Handle making an expiration subpacket
	from a sig that has already expired (use a duration of 0).

	* packet.h, sign.c (update_keysig_packet), keyedit.c
	(menu_set_primary_uid, menu_set_preferences): Add ability to issue
	0x18 subkey binding sigs to update_keysig_packet and change all
	callers.

	* trustdb.c (validate_keys): Show trust parameters when building
	the trustdb, and make sure that the version record update was
	successful.
	(init_trustdb): If the current parameters aren't what was used for
	building the trustdb, the trustdb is invalid.

	* tbio.c (tdbio_db_matches_options): Update to work with new
	trustdbs.

2002-12-03  David Shaw  <dshaw@jabberwocky.com>

	* tdbio.h, tdbio.c (tdbio_read_record, tdbio_write_record): Store
	trust model in the trustdb version record.
	(tdbio_update_version_record): New function to update version
	record values during a trustdb check or update.
	(tdbio_dump_record): Show trust model in dump.

	* trustdb.c (validate_keys): Call tdbio_update_version_record on
	success so that the correct options are stored in the trustdb.

	* options.h: rearrange trust models so that CLASSIC is 0 and
	OPENPGP is 1.

	* options.h, g10.c (main), encode.c (write_pubkey_enc_from_list),
	pkclist.c (algo_available), revoke.c (gen_revoke): Add --pgp8
	mode.  This is basically identical to --pgp7 in all ways except
	that signing subkeys, v4 data sigs (including expiration), and SK
	comments are allowed.

	* getkey.c (finish_lookup): Comment.

	* main.h, keylist.c (reorder_keyblock), keyedit.c (keyedit_menu):
	Reorder user ID display in the --edit-key menu to match that of
	the --list-keys display.

	* g10.c (add_notation_data): Fix initialization.

2002-12-01  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_expire): Don't lose key flags when changing the
	expiration date of a subkey.  This is not the most optimal
	solution, but it is minimal change on the stable branch.

	* main.h, keygen.c (do_copy_key_flags): New function to copy key
	flags, if any, from one sig to another.
	(do_add_key_expire): New function to add key expiration to a sig.
	(keygen_copy_flags_add_expire): New version of
	keygen_add_key_expire that also copies key flags.
	(keygen_add_key_flags_and_expire): Use do_add_key_expire.

	* import.c (fix_hkp_corruption): Comment.

2002-11-25  Stefan Bellon  <sbellon@sbellon.de>

	* plaintext.c (handle_plaintext) [__riscos__]: If nooutput is set,
	no filetype is needed obviously.

2002-11-24  David Shaw  <dshaw@jabberwocky.com>

	* main.h, misc.c (default_cipher_algo, default_compress_algo):
	New.  Return the default algorithm by trying
	--cipher-algo/--compress-algo, then the first item in the pref
	list, then s2k-cipher-algo or ZIP.

	* sign.c (sign_file, sign_symencrypt_file), encode.c
	(encode_simple, encode_crypt): Call default_cipher_algo and
	default_compress_algo to get algorithms.

	* g10.c (main): Allow pref selection for compress algo with
	--openpgp.

	* mainproc.c (proc_encrypted): Use --s2k-digest-algo for
	passphrase mangling rather than --digest-algo.

	* sign.c (hash_for): If --digest-algo is not set, but
	--personal-digest-preferences is, then use the first hash
	algorithm in the personal list.  If the signing algorithm is DSA,
	then use the first 160-bit hash algorithm in the personal list.
	If --pgp2 is set and it's a v3 RSA key, use MD5.

	* g10.c (main), keydb.c (keydb_add_resource,
	keydb_locate_writable): Rename --default-keyring as
	--primary-keyring.  Stefan wins the naming contest.

2002-11-23  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (add_notation_data): Disallow notation names that do not
	contain a '@', unless --expert is set.  This is to help prevent
	people from polluting the (as yet unused) IETF namespace.

	* main.h: Comments about default algorithms.

	* photoid.c (image_type_to_string): Comments about 3-letter file
	extensions.

	* encode.c (encode_simple), passphrase.c (passphrase_to_dek),
	sign.c (sign_symencrypt_file): Use --s2k-digest-algo for
	passphrase mangling rather than --digest-algo.

2002-11-21  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (keygen_set_std_prefs): Properly handle an empty
	preference string.

	* misc.c (string_to_compress_algo): "none" is a bad choice since
	it conflicts with the "none" in setpref.

2002-11-14  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Allow compression algorithm names as the argument
	to --compress-algo.  The old algorithm names still work for
	backwards compatibility.

	* misc.c (string_to_compress_algo): Allow "none" as an alias for
	"uncompressed".

2002-11-13  Stefan Bellon  <sbellon@sbellon.de>

	* getkey.c (get_pubkey_byfprint_fast): Fixed type incompatibility,
	was unsigned char instead of byte.

2002-11-13  David Shaw  <dshaw@jabberwocky.com>

	* encode.c (encode_simple): Make sure that files larger than about
	4G use partial length encoding.  This is required because OpenPGP
	allows only for 32 bit length fields.  From Werner on stable
	branch.

	* getkey.c (get_pubkey_direct): Renamed to...
	(get_pubkey_fast): this and made extern.
	(get_pubkey_byfprint_fast): New.  From Werner on stable branch.

	* keydb.h, import.c (import_one): Use get_pubkey_fast instead of
	get_pubkey.  We don't need a merged key and actually this might
	lead to recursions.
	(revocation_present): Likewise for search by fingerprint.  From
	Werner on stable branch.

	* g10.c (main): Try to create the trustdb even for non-colon-mode
	list-key operations.  This is required because getkey needs to
	know whether a a key is ultimately trusted.  From Werner on stable
	branch.

	* exec.c [__CYGWIN32__]: Keep cygwin separate from Mingw32;
	we don't need it here as it behaves more like a Posix system.
	From Werner on stable branch.

	* passphrase.c (agent_get_passphrase): Ditto.  From Werner on
	stable branch.

	* tdbio.c (MY_O_BINARY): Need binary mode with Cygwin.  From
	Werner on stable branch.

	* g10.c, gpgv.c (main) [__CYGWIN32__]: Don't get the homedir from
	the registry.  From Werner on stable branch.

	* keyedit.c (show_key_with_all_names_colon): Make --with-colons
	--edit display match the validity and trust of --with-colons
	--list-keys.

	* passphrase.c (agent_send_all_options): Fix compile warning.

	* keylist.c (list_keyblock_colon): Validity for subkeys should
	match that of the primary key, and not that of the last user ID.

	* getkey.c (merge_selfsigs): Revoked/expired/invalid primary keys
	carry these facts onto all their subkeys, but only after the
	subkey has a chance to be marked valid.  This is to fix an
	incorrect "invalid public key" error verifying a signature made by
	a revoked signing subkey, with a valid unrevoked primary key.

2002-11-09  Werner Koch  <wk@gnupg.org>

	* passphrase.c (agent_send_all_options): Use tty_get_ttyname to
	get the default ttyname.

2002-11-07  David Shaw  <dshaw@jabberwocky.com>

	* keyring.h, keyring.c (keyring_register_filename): Return the
	pointer if a given keyring is registered twice.

	* keydb.h, keydb.c (keydb_add_resource): Use flags to indicate a
	default keyring.
	(keydb_locate_writable): Prefer the default keyring if possible.

	* g10.c (main): Add --default-keyring option.

2002-11-06  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), trustdb.c (ask_ownertrust): Add
	--force-ownertrust option for debugging purposes.  This allows
	setting a whole keyring to a given trust during an
	--update-trustdb.  Not for normal use - it's just easier than
	hitting "4" all the time to test a large trustdb.

	* pubkey-enc.c (get_session_key): With hidden recipients or try a
	given passphrase against all secret keys rather than trying all
	secret keys in turn.  Don't if --try-all-secrets or --status-fd is
	enabled.

	* passphrase.c (passphrase_to_dek): Mode 1 means do a regular
	passphrase query, but don't prompt with the key info.

	* seckey-cert.c (do_check, check_secret_key): A negative ask count
	means to enable passphrase mode 1.

	* keydb.h, getkey.c (enum_secret_keys): Add flag to include
	secret-parts-missing keys (or not) in the list.

2002-11-05  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_search_prompt): When --with-colons is
	enabled, don't try and fit the search output to the screen size -
	just dump the whole list.

2002-11-04  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_search_prompt): When --with-colons is
	enabled, just dump the raw keyserver protocol to stdout and don't
	print the menu.

	* keyserver.c (show_prompt): Don't show a prompt when command-fd
	is being used.

	* trustdb.c (trust_model_string, check_trustdb, update_trustdb,
	validate_one_keyblock): It's not clear what a trustdb rebuild or
	check means with a trust model other than "classic" or "openpgp",
	so disallow this.

2002-11-03  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main): Add --trust-model option.  Current
	models are "openpgp" which is classic+trustsigs, "classic" which
	is classic only, and "always" which is the same as the current
	option --always-trust (which still works).  Default is "openpgp".

	* trustdb.c (validate_one_keyblock): Use "openpgp" trust model to
	enable trust sigs.

	* gpgv.c (main), mainproc.c (check_sig_and_print), pkclist.c
	(do_we_trust, do_we_trust_pre, check_signatures_trust): Use new
	--trust-model option in place of --always-trust.

	* keyedit.c (sign_mk_attrib, trustsig_prompt, sign_uids,
	keyedit_menu): Prompt for and create a trust signature with
	"tsign".  This is functional, but needs better UI text.

	* build-packet.c (build_sig_subpkt): Able to build trust and
	regexp subpackets.

	* pkclist.c (do_edit_ownertrust): Comment.

2002-11-02  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (set_one_pref, keygen_set_std_prefs): Allow using the
	full algorithm name (CAST5, SHA1) rather than the short form (S3,
	H2).

	* main.h, keygen.c (keygen_get_std_prefs), keyedit.c
	(keyedit_menu): Return and use a fake uid packet rather than a
	string since we already have a nice parser/printer in
	keyedit.c:show_prefs.

	* main.h, misc.c (string_to_compress_algo): New.

2002-11-01  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Add --no-throw-keyid.

	* keydb.h, encode.c (write_pubkey_enc_from_list), g10.c (main),
	pkclist.c (build_pk_list): Add --hidden-recipient (-R) and
	--hidden-encrypt-to, which do a single-user variation on
	--throw-keyid.  The "hide this key" flag is carried in bit 0 of
	the pk_list flags field.

	* keyserver.c (parse_keyrec): Fix shadowing warning.

2002-10-31  Stefan Bellon  <sbellon@sbellon.de>

	* compress.c (init_compress) [__riscos__]: Use
	riscos_load_module() to load ZLib module.

	* g10.c (main) [__riscos__]: Renames due to changes in riscos.c
	(e.g. prefixes all RISC OS specific functions with riscos_*).
	* photoid.c (show_photos) [__riscos__]: Likewise.
	* signal.c (got_fatal_signal) [__riscos__]: Likewise.

	* trustdb.c (check_regexp) [__riscos__]: Branch to RISC OS RegEx
	handling.

2002-10-31  David Shaw  <dshaw@jabberwocky.com>

	* build-packet.c (do_plaintext), encode.c (encode_sesskey,
	encode_simple, encode_crypt), sign.c (write_plaintext_packet): Use
	wipememory() instead of memset() to wipe sensitive memory as the
	memset() might be optimized away.

2002-10-30  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (check_regexp): Modern regexps require REG_EXTENDED.

2002-10-29  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, trustdb.h, trustdb.c (trust_string): New.  Return a
	string like "fully trusted", "marginally trusted", etc.
	(get_min_ownertrust): New.  Return minimum ownertrust.
	(update_min_ownertrust): New.  Set minimum ownertrust.
	(check_regexp): New.  Check a regular epression against a user ID.
	(ask_ownertrust): Allow specifying a minimum value.
	(get_ownertrust_info): Follow the minimum ownertrust when
	returning a letter.
	(clear_validity): Remove minimum ownertrust when a key becomes
	invalid.
	(release_key_items): Release regexp along with the rest of the
	info.
	(validate_one_keyblock, validate_keys): Build a trust sig chain
	while validating.  Call check_regexp for regexps.  Use the minimum
	ownertrust if the user does not specify a genuine ownertrust.

	* pkclist.c (do_edit_ownertrust): Only allow user to select a
	trust level greater than the minimum value.

	* parse-packet.c (can_handle_critical): Can handle critical trust
	and regexp subpackets.

	* trustdb.h, trustdb.c (clear_ownertrusts), delkey.c
	(do_delete_key), import.c (import_one): Rename clear_ownertrust to
	clear_ownertrusts and have it clear the min_ownertrust value as
	well.

	* keylist.c (list_keyblock_print): Indent uid to match pub and
	sig.

	* keyedit.c (print_and_check_one_sig, show_key_and_fingerprint,
	menu_addrevoker), keylist.c (list_keyblock_print,
	print_fingerprint): Show "T" or the trust depth for trust
	signatures, and add spaces to some strings to make room for it.

	* packet.h, parse-packet.c (dump_sig_subpkt, parse_one_sig_subpkt,
	parse_signature): Parse trust signature values.

	* tdbio.h, tdbio.c (tdbio_read_record, tdbio_write_record):
	Reserve a byte for the minimum ownertrust value (for use with
	trust signatures).

2002-10-29  Stefan Bellon  <sbellon@sbellon.de>

	* build-packet.c (calc_plaintext, do_plaintext): Removed RISC OS
	specific filetype parts (it's now done in make_basename()).

	* plaintext.c (handle_plaintext): Tidied up RISC OS specific
	filetype parts.

	* encode.c (encode_simple, encode_crypt): Added argument to
	make_basename() call.

	* sign.c (write_plaintext_packet): Added argument to
	make_basename() call.

2002-10-28  Stefan Bellon  <sbellon@sbellon.de>

	* build-packet.c (calc_plaintext, do_plaintext): Added filetype
	handling for RISC OS' file types.

	* plaintext.c (handle_plaintext) [__riscos__]: Added filetype
	handling for RISC OS' file types.

2002-10-23  David Shaw  <dshaw@jabberwocky.com>

	* main.h, import.c (sec_to_pub_keyblock, import_secret_one,
	parse_import_options), g10.c (main): New import-option
	"convert-sk-to-pk" to convert a secret key into a public key
	during import.  It is on by default.

2002-10-23  Werner Koch  <wk@gnupg.org>

	* pubkey-enc.c (get_it): Fix segv, test for revoked only when PK
	has been assigned.

2002-10-18  Timo Schulz  <ts@winpt.org>

	* keylist.c: (print_pubkey_info): New.
	(print_seckey_info): New.
	* main.h: Prototypes for the new functions.
	* delkey.c (do_delete_key): Use it here.
	* revoke.c (gen_desig_revoke): Ditto.

2002-10-17  Werner Koch  <wk@gnupg.org>

	* pkclist.c (do_edit_ownertrust): Show all user IDs.  This should
	be enhanced to also show the current trust level.  Suggested by
	Florian Weimer.

2002-10-17  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Handle --strict and --no-strict from the command
	line before the options file is loaded.

2002-10-15  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Disable --textmode when encrypting (symmetric or
	pk) in --pgp2 mode as PGP 2 can't handle the unknown length
	literal packet.  Reported by Michael Richardson.

2002-10-14  David Shaw  <dshaw@jabberwocky.com>

	* keyserver-internal.h, keyserver.c (print_keyrec, parse_keyrec,
	show_prompt, keyserver_search_prompt, keyserver_spawn): Go to
	version 1 of the keyserver protocol.  This is a better design,
	similar to --with-colons, that allows for keys with multiple user
	IDs rather than using multiple keys.  It also matches the machine
	readable pksd format.  Also use a prettier --search-keys listing
	format that can fill different size windows (currently set at 24
	lines).

2002-10-12  Werner Koch  <wk@gnupg.org>

	* keygen.c (print_status_key_created): New.
	(do_generate_keypair): Use it to print the fingerprint.
	(generate_subkeypair): Likewise.

2002-10-11  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_addrevoker): Properly back out if the signature
	fails.  Also, do not allow appointing the same revoker twice, and
	report ALREADY_SIGNED if the user tries it.

2002-10-07  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_keys_internal): Missed one s/inp/inp2/.

	* keylist.c (print_capabilities): Properly indicate per-key
	capabilities of sign&encrypt primary keys that have
	secret-parts-missing (i.e. no capabilities at all)

	* mainproc.c (symkey_decrypt_sesskey): Fix compiler warning.

2002-10-04  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (get_pubkey_direct): Don't cache keys retrieved via
	this function as they may not have all their fields filled in.

	* sig-check.c (signature_check2): Use new is_primary flag to check
	rather than comparing main_keyid with keyid as this still works in
	the case of a not fully filled in pk.

2002-10-04  Werner Koch  <wk@gnupg.org>

	* import.c (import_keys_internal): s/inp/inp2/ to avoid shadowing
	warning.

	* passphrase.c (agent_get_passphrase): Fixed signed/unsigned char
	problem in %-escaping.  Noted by Ingo Klöcker.

2002-10-03  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main): Add --strict and --no-strict to switch
	the log_warning severity level from info to error.

	* keylist.c (print_capabilities): Secret-parts-missing keys should
	show that fact in the capabilities, and only primary signing keys
	can certify other keys.

	* packet.h, parse_packet.c (parse_key): Add is_primary flag for
	public keys (it already exists for secret keys).

2002-10-02  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_secret_one): Check for an illegal (>110)
	protection cipher when importing a secret key.

	* keylist.c (list_keyblock_print): Show a '#' for a
	secret-parts-missing key.

	* parse_packet.c (parse_key): Some comments.

	* revoke.c (gen_revoke): Remove some debugging code.

	* trustdb.c (verify_own_keys): Make trusted-key a non-deprecated
	option again.

	* seckey-cert.c (do_check): Don't give the IDEA warning unless the
	cipher in question is in fact IDEA.

2002-10-01  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_one): Make sure that a newly imported key
	starts with a clean ownertrust.

2002-10-01  Werner Koch  <wk@gnupg.org>

	* getkey.c (get_pubkey_direct): New.
	(merge_selfsigs_main): Use it here to look for an ultimately
	trusted key.  Using the full get_pubkey might lead to an
	infinitive recursion.

2002-09-29  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (parse_keyserver_uri): Force the keyserver URI
	scheme to lowercase to be case-insensitive.

2002-09-28  David Shaw  <dshaw@jabberwocky.com>

	* export.c (do_export_stream): Comment.

	* sig-check.c (check_key_signature2): Properly handle a
	non-designated revocation import.

2002-09-26  Werner Koch  <wk@gnupg.org>

	* g10.c (set_homedir): New. Changed all direct assignments to use
	this.
	* gpgv.c (set_homedir): Ditto.

2002-09-25  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am: Link gpg with EGDLIBS (i.e. NETLIBS) as EGD uses
	sockets.  Remove the old NETLIBS variable since the keyserver
	stuff is no longer internal.

2002-09-24  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_keys_stream): Fix compiler type warning.

	* keyring.c (keyring_rebuild_cache), sig-check.c
	(check_key_signature2), import.c (import, chk_self_sigs): Minor
	language cleanups.

2002-09-23  Stefan Bellon  <sbellon@sbellon.de>

	* main.h: Introduced fast-import as import option. Removed
	fast as separate option from prototypes.
	* import.c (parse_import_options): Added fast-import option.
	(import_*): Removed fast as separate option.
	* g10.c (main): Added option fast-import, removed old fast
	as separate argument.
	* keyserver.c (keyserver_spawn): Removed old fast as separate
	argument.

2002-09-22  Stefan Bellon  <sbellon@sbellon.de>

	* import.c (import_keys, import_keys_stream,
	import_keys_internal): Added trustdb update/check to key import if
	not fast-import and interactive set/no-auto-check-trustdb unset.
	Avoided function clone by introducing import_keys_internal.

2002-09-19  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Properly handle line truncation.
	Don't leak memory (~10-20 bytes) on searches.
	(keyserver_search_prompt): Cleanup.

	* keylist.c (list_keyblock_colon): Show 1F direct key signatures
	in --with-colons listing.

2002-09-16  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_addrevoker): The direct key signature for
	revocation keys must be at least v4 to carry the revocation key
	subpacket.  Add a PGP 2.x warning for revocation keys.

2002-09-14  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (check_permissions): Rearrange strings to make translating
	easier (don't incorporate string parts).

	* keyedit.c (sign_uids): Make strings translatable.

	* sig-check.c (check_key_signature2): Make string translatable.

2002-09-13  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (check_revocation_keys): Move....
	* main.h, sig-check.c (check_revocation_keys): to here.  Also
	return the signature_check error code rather than 0/1 and cache
	the sig result.

	* sig-check.c (check_key_signature2): Divert to
	check_revocation_keys if a revocation sig is made by someone other
	than the pk owner.

	* getkey.c (merge_selfsigs_main): Tidy.

2002-09-13  Werner Koch  <wk@gnupg.org>

	* g10.c (main) [__MINGW32__]: Activate oLoadExtension.

2002-09-12  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am, hkp.c, hkp.h, keyserver.c (keyserver_work): Remove
	internal HKP support.

	* keyserver.c (keyserver_spawn): Remove whitespace after keyserver
	commands.

2002-09-10  David Shaw  <dshaw@jabberwocky.com>

	* exec.c (expand_args): Remove loop left over from earlier
	implementation.
	(exec_write): Missed one tick.

2002-09-10  Werner Koch  <wk@gnupg.org>

	* g10.c, options.h: Removed option --emulate-checksum-bug.
	* misc.c (checksum_u16_nobug): Removed.
	(checksum_u16): Removed the bug emulation.
	(checksum_mpi): Ditto.
	(checksum_mpi_counted_nbits): Removed and replaced all calls
	with checksum_mpi.

	* parse-packet.c (read_protected_v3_mpi): New.
	(parse_key): Use it here to store it as an opaque MPI.
	* seckey-cert.c (do_check): Changed the v3 unprotection to the new
	why to store these keys.
	(protect_secret_key): Likewise.
	* build-packet.c (do_secret_key): And changed the writing.

	* tdbio.c (tdbio_set_dbname, open_db): Use new macro MY_O_BINARY
	to avoid silly ifdefs.
	(open_db): Fallback to RDONLY so that gpg may be used from a
	RO-medium.

	* encode.c (encode_simple): Make sure we don't use an ESK packet
	when we don't have a salt in the S2K.

	* misc.c (pct_expando) <case f>: Make sure that LEN is initialized.

	* exec.c (exec_finish): Use ticks to denote filenames in messages.
	(make_tempdir, exec_write): Changed format of messages.

	* keyserver.c (print_keyinfo): Release USERID in on error.
	(keyserver_work) [!DISABLE_KEYSERVER_HELPERS]: Exclude the unused
	code.

2002-09-09  Werner Koch  <wk@gnupg.org>

	* parse-packet.c (make_attribute_uidname): Add new ar MAX_NAMELEN
	for sanity checks.  Changed both callers. Limit the size of an %s.

	* options.skel: Comment lock-once out, so that this file does not
	change anything when copied to a new home directory.
	* openfile.c (try_make_homedir): Don't exit after copying the
	option skeleton.

	* options.h: Don't use a comma when declaring variables over more
	than one line.

	* mainproc.c (symkey_decrypt_sesskey): Check length of the session
	key.

	* hkp.c (dehtmlize): Use ascii_tolower to protect against weird
	locales.  Cast the argument for isspace for the sake of broken
	HP/UXes.
	(parse_hkp_index): s/ascii_memcasecmp/ascii_strncasecmp/.

	* g10.c: Removed option --emulate-3des-s2k-bug.

	* passphrase.c (hash_passphrase): Was used here.

	* export.c (parse_export_options)
	* keyserver.c (parse_keyserver_options)
	* import.c (parse_import_options)
	* g10.c (check_permissions): s/ascii_memcasecmp/ascii_strncasecmp/.

2002-09-09  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (add_group): Use '=' to separate group name from group
	members.  Use a better error message for when no = is found.

	* hkp.c (hkp_export): Use CRLF in headers.

2002-09-03  David Shaw  <dshaw@jabberwocky.com>

	* mainproc.c (print_pkenc_list): Don't increment the error counter
	when printing the list of keys a message was encrypted to.  This
	would make gpg give a non-zero exit code even for completely valid
	messages if the message was encrypted to more than one key that
	the user owned.

2002-09-02  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Try to set a default character set.  Print the
	used one in verbosity level 3.
	* gpgv.c (main): Try to set a default character set.

	* status.c, status.h (STATUS_IMPORT_OK): New.
	* import.c (import_one,import_secret_one): Print new status.

2002-08-30  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (build_pk_list): Add new status code to indicate an
	untrusted user.  This (or a disabled key) fail with "unavailable
	pubkey" (G10ERR_UNU_PUBKEY).

	* pkclist.c (build_pk_list): Fail if any recipient keys are
	unusable.

	* options.skel: The PGP LDAP keyserver is back.  Use MIT keyserver
	as a sample rather than cryptnet as cryptnet does not support
	searching yet.

	* keyedit.c (show_key_with_all_names): Fix error message
	(preferences are userid/selfsig and not key specific).

2002-08-30  Werner Koch  <wk@gnupg.org>

	* pkclist.c (do_we_trust_pre): Changed the wording of a warning.

	* encode.c (encode_simple,encode_crypt): Use new style CTB for
	compressssed packets when using MDC.  We need to do this so that
	concatenated messages are properly decrypted.  Old style
	compression assumes that it is the last packet; given that we
	can't determine the length in advance, the uncompressor does not
	know where to start.  Actually we should use the new CTB always
	but this would break PGP 2 compatibility.

	* parse-packet.c (parse): Special treatment for new style CTB
	compressed packets.

	* build-packet.c (do_mdc): Removed. Was not used.
	(do_encrypted_mdc): Count in the version number and the MDC packet.

2002-08-28  David Shaw  <dshaw@jabberwocky.com>

	* sig-check.c (do_check_messages, do_check): Show keyid in error
	messages.

	* keyserver.c (print_keyinfo): More readable key listings for
	--search-keys responses.

2002-08-26  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index, dehtmlize): Move HTML functionality into
	new "dehtmlize" function.  Remove HTML before trying to parse each
	line from the keyserver.  If the keyserver provides key type
	information in the listing, use it.

2002-08-23  David Shaw  <dshaw@jabberwocky.com>

	* sig-check.c (do_check, do_check_messages): Emit the usual sig
	warnings even for cached sigs.  This also serves to protect
	against missing a sig expiring while cached.

	* getkey.c (merge_selfsigs_main): Don't check UID self-sigs twice.

2002-08-22  David Shaw  <dshaw@jabberwocky.com>

	* import.c (clean_subkeys, chk_self_sigs): Merge clean_subkeys
	into chk_self_sigs.  This improves efficiency as the same
	signatures are not checked multiple times.  Clarify when a subkey
	is revoked (any revocation signature, even if it is dated before
	the binding signature).

	* getkey.c (merge_selfsigs_subkey): Subkey revocation comments.

	* keylist.c (list_one): Stats are only for public key listings.

	* g10.c (main), options.skel: Default should be include-revoked
	for keyserver operations.

2002-08-21  Werner Koch  <wk@gnupg.org>

	* import.c (import_print_stats): Print new non_imported counter
	which is currently not used because we terminate on errors.

2002-08-20  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: Document no-include-attributes for
	keyserver-options.

	* keylist.c, keyedit.c, keyserver.c, sign.c: Some TODOs and
	comments.

	* export.c (do_export_stream): Fix noop bug in exporting sensitive
	revocation keys.

	* pkclist.c (do_edit_ownertrust): Comment out the option for
	showing trust paths until it can be implemented.

2002-08-19  Werner Koch  <wk@gnupg.org>

	* getkey.c (get_user_id_native): Renamed to ..
	(get_user_id_printable): this.  Filter out all dangerous
	characters.  Checked all usages.
	(get_user_id_string_native): Renamed to..
	(get_user_id_string_printable): this.  Filter out all dangerous
	characters.  Checked all usages.
	* keyedit.c (show_basic_key_info): New.
	* keylist.c (print_fingerprint): New mode 3.
	* import.c (import_one): Use new function to display the user ID.

2002-08-16  Timo Schulz  <ts@winpt.org>

	* g10.c (main): Enable opt.interactive.

	* import.c (import_one): Ask the user if the key shall be
	imported when the interactive mode is used. Useful to extract
	selected keys from a file.

2002-08-16  Werner Koch  <wk@gnupg.org>

	* seckey-cert.c: Workaround to allow decryption of v3 keys created
	with a bug in the mpi_get_secure_buffer.

2002-08-14  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index): Properly handle really large keys
	(5 digit key length) in HKP searches.

2002-08-13  David Shaw  <dshaw@jabberwocky.com>

	* encode.c (encode_simple): Fix problem with using compression
	algo 2 and symmetric compressed files.

	* encode.c (encode_simple, encode_crypt): If we are not using a
	MDC, compress even if a file is already compressed.  This is to
	help against the chosen ciphertext attack.

	* pkclist.c (select_algo_from_prefs): Fix requested algorithm bug
	so the request succeeds even if the requested algorithm is not the
	first found.

	* cipher.c (write_header), encode.c (use_mdc, encode_simple,
	encode_crypt, encrypt_filter), g10.c (main): Be more eager to use
	a MDC.  We use a MDC if the keys directly support it, if the keys
	list AES (any) or TWOFISH anywhere in the prefs, or if the cipher
	chosen does not have a 64 bit blocksize.

2002-08-08  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: Some language tweaks, and remove the
	load-extension section for random gatherers.

	* keyring.c (create_tmp_file, rename_tmp_file): Create tmp files
	with user-only permissions, but restore the original permissions
	if the user has something special set.

	* openfile.c (copy_options_file): Create new options file
	(gpg.conf) with user-only permissions.

	* keydb.c (keydb_add_resource): Create new keyrings with user-only
	permissions.

	* tdbio.c (tdbio_set_dbname): Create new trustdbs with user-only
	permissions.

2002-08-07  David Shaw  <dshaw@jabberwocky.com>

	* sig-check.c (signature_check2): Sanity check that the md has a
	context for the hash that the sig is expecting.  This can happen
	if a onepass sig header does not match the actual sig, and also if
	the clearsign "Hash:" header is missing or does not match the
	actual sig.

	* keyedit.c (menu_revsig): Properly show a uid is revoked without
	restarting gpg.  This is Debian bug 124219, though their supplied
	patch will not do the right thing.

	* main.h, tdbio.c (tdbio_set_dbname), misc.c (removed
	check_permissions), keydb.c (keydb_add_resource), g10.c (main,
	check_permissions): Significant reworking of the permission check
	mechanism.  The new behavior is to check everything in the homedir
	by checking the homedir itself.  If the user wants to put
	(possibly shared) keyrings outside the homedir, they are not
	checked.  The options file and any extension files are checked
	wherever they are, as well as their enclosing directories.  This
	is Debian bug 147760.

2002-08-06  Stefan Bellon  <sbellon@sbellon.de>

	* g10.c (main): Use of EXTSEP_S in new gpg.conf string.
	* openfile.c (copy_options_file): Ditto.

2002-08-06  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), mainproc.c (proc_encrypted):
	--ignore-mdc-error option to turn a MDC check error into a
	warning.

	* encode.c (encode_crypt), g10.c (main), sign.c (sign_file,
	clearsign_file): Use the same --pgpX warning string everywhere to
	ease translations.

	* encode.c (write_pubkey_enc_from_list): Warn when using
	--throw-keyid with --pgpX.  Noted by Vedaal Nistar.

	* revoke.c (export_minimal_pk, gen_desig_revoke, gen_revoke):
	Export a minimal pk along with the revocation cert when in --pgpX
	mode so that PGP can import it.

2002-08-06  Werner Koch  <wk@gnupg.org>

	* options.skel: Changed comments.

	* g10.c (main): Try to use "gpg.conf" as default option file.
	* openfile.c (copy_options_file): Changed name of created file.

2002-08-02  Werner Koch  <wk@gnupg.org>

	* Makefile.am (LDFLAGS): Removed DYNLINK_LDFLAGS.

2002-07-30  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), mainproc.c (proc_encrypted): Return a
	decryption failed error if a MDC does not verify.  Warn if a MDC
	is not present (can disable via --no-mdc-warning).

	* exec.c (exec_write), g10.c (main), keyserver.c
	(keyserver_spawn): Use new DISABLE_KEYSERVER_PATH rather than
	FIXED_EXEC_PATH.

2002-07-28  David Shaw  <dshaw@jabberwocky.com>

	* sig-check.c (do_check): Properly validate v4 sigs with no hashed
	section at all.

2002-07-25  Werner Koch  <wk@gnupg.org>

	* delkey.c (do_delete_key): Always allow to delete a key in batch mode
	when specified by fingerprint.  Suggested by Enzo Michelangeli.

2002-07-25  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_revsig): Change "revsig" to honor selected uids
	so the user can revoke sigs from particular uids only.

	* keylist.c (list_keyblock_print): Don't display expired uids in
	--list-keys unless -v and not --list-sigs (just like revoked
	uids).

	* exec.c, export.c, import.c, keyedit.c, keyserver.c, misc.c:
	"Warning" -> "WARNING"

2002-07-24  David Shaw  <dshaw@jabberwocky.com>

	* main.h, import.c (parse_import_options, fix_hkp_corruption,
	import_one, delete_inv_parts), g10.c (main): New import-option
	"repair-hkp-subkey-bug", which repairs as much as possible the HKP
	mangling multiple subkeys bug.  It is on by default for keyserver
	receives, and off by default for regular --import.

	* main.h, import.c (import, import_one, delete_inv_parts), hkp.c
	(hkp_ask_import), keyserver.c (keyserver_spawn): Use keyserver
	import options when doing keyserver receives.

	* options.h, exec.h, exec.c (set_exec_path, exec_write), g10.c
	(main), keyserver.c (keyserver_spawn): If the user does not use
	"exec-path", completely replace $PATH with GNUPG_LIBEXECDIR before
	calling the keyserver helper.  If the user does use "exec-path",
	append GNUPG_LIBEXECDIR after the specified path.

2002-07-23  David Shaw  <dshaw@jabberwocky.com>

	* import.c (parse_import_options), export.c
	(parse_export_options): Fix offset problem with reversed ("no-")
	meanings.

	* import.c (delete_inv_parts): Discard subkey signatures (0x18 and
	0x28) if found in the userid section of the key.

	* sig-check.c (signature_check2): Signatures made by invalid
	subkeys (bad/missing binding sig) are also invalid.

	* keylist.c (print_fingerprint): Show the primary as well as the
	secondary key fingerprint in modes 1 & 2.

2002-07-22  David Shaw  <dshaw@jabberwocky.com>

	* options.h, main.h, g10.c (main), import.c
	(parse_import_options, delete_inv_parts), keyserver.c
	(parse_keyserver_options): add new --import-options option.  The
	only current flag is "allow-local-sigs".

	* g10.c (main): Don't disable MDC in pgp7 mode.

	* options.h, g10.c (main), keyserver.c (parse_keyserver_options):
	Remove old keyserver-option include-attributes now that there is
	an export-option for the same thing.

	* options.h, main.h, export.c (parse_export_options,
	do_export_stream), g10.c (main): add new --export-options option.
	Current flags are "include-non-rfc", "include-local-sigs",
	"include-attributes", and "include-sensitive-revkeys".

	* options.h, hkp.c (hkp_export), keyserver.c
	(parse_keyserver_options, keyserver_spawn): try passing unknown
	keyserver options to export options, and if successful, use them
	when doing a keyserver --send-key.

	* build-packet.c (build_sig_subpkt): We do not generate
	SIGSUBPKT_PRIV_VERIFY_CACHE anymore.

	* revoke.c (gen_desig_revoke): Lots more comments about including
	sensitive revkeys along with the revocation sig itself.

	* keyserver.c (parse_keyserver_options): Simpler implementation
	that can skip one pass over the options.

2002-07-18  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (keyedit_menu, menu_addrevoker): Allow specifying
	"sensitive" as an argument to an addrevoker command.  This sets
	the 0x40 sensitive revoker flag.

	* revoke.c (gen_desig_revoke): When generating a designated
	revocation, include the direct key sig that contains the
	designated revoker subpacket.  This allows sensitive designated
	revocation subpackets to be exported.  Also indicate which
	revokers are sensitive in the first place.

2002-07-17  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (show_key_with_all_names_colon): The 0x40 class bit in
	a designated revoker means "sensitive", not "local".  It's
	exportable under the right circumstances.

	* main.h, options.h, export.c (do_export_stream), g10.c (main),
	hkp.c (hkp_export), keyserver.c (keyserver_spawn: Add a flag to
	skip attribute packets and their signatures while exporting.  This
	is to accomodate keyservers (pksd again) that choke on attributes.
	Use keyserver-option "include-attributes" to control it.  This
	defaults to ON (i.e. don't skip).

2002-07-09  David Shaw  <dshaw@jabberwocky.com>

	* options.h, keyserver.c (parse_keyserver_uri, keyserver_spawn,
	keyserver_work), hkp.c (hkp_ask_import, hkp_export, hkp_search):
	Use a much more strict reading of RFC-2396 for the keyserver URIs.
	Specifically, don't try and be smart about checking the value of
	":port" so long as it is all digits, and properly handle opaque
	data (those scheme specific parts that do not start with "//").

2002-07-04  David Shaw  <dshaw@jabberwocky.com>

	* photoid.c (get_default_photo_command, show_photos): Honor
	FIXED_PHOTO_VIEWER and DISABLE_PHOTO_VIEWER.

	* mainproc.c (check_sig_and_print): Use --show-photos to show
	photos when verifying a sig made by a key with a photo.

	* keyserver.c (parse_keyserver_uri): Properly parse a URI with no
	:port section and an empty file path, but with a terminating '/'.
	(keyserver_work): Honor DISABLE_KEYSERVER_HELPERS.

	* hkp.c (hkp_ask_import): Display keyserver URI as a URI, but only
	if verbose.

	* exec.c, g10.c: USE_EXEC_PATH -> FIXED_EXEC_PATH

2002-07-03  David Shaw  <dshaw@jabberwocky.com>

	* exec.h, exec.c (set_exec_path, exec_write), g10.c (main): If
	USE_EXEC_PATH is defined at compile time, use it to lock the
	exec-path and not allow the user to change it.

2002-07-02  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), keyserver.c (keyserver_refresh):
	Maintain and use the original keyserver URI for cosmetics rather
	than trying to recreate it when needed.

	* mainproc.c (check_sig_and_print): Properly disregard expired
	uids.  Make sure that the first uid listed is a real uid and not
	an attribute (attributes should only be listed in the "aka"
	section).  When there are no valid textual userids, try for an
	invalid textual userid before using any attribute uid.

2002-07-01  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: Fix a few typos, clarify "group", and remove
	sample photo viewers for Win32 since they are the defaults now.

	* parse-packet.c (make_attribute_uidname), keylist.c
	(dump_attribs): Fix two typecast warnings.

	* packet.h, build-packet.c (build_attribute_subpkt), exec.c
	(expand_args), mkdtemp.c (mkdtemp), photoid.c
	(parse_image_header): Fix some signedness compiler warnings.

2002-07-01  Werner Koch  <wk@gnupg.org>

	* photoid.c (get_default_photo_command): Also use __MINGW32__
	instead of HAVE_DOSISH_SYSTEM.

	* encode.c (encode_symmetric): Do not use the new encryption code.

2002-06-30  Werner Koch  <wk@gnupg.org>

	* photoid.c: Use __MINGW32__ to include windows because
	HAVE_DOSISH_SYSTEM is also set for OS/2 and plain DOS.  Provide
	constant missing in older mingw installations.

2002-06-21  Stefan Bellon  <sbellon@sbellon.de>

	* g10.c [__riscos__]: Moved RISC OS specific stuff to util/riscos.c
	and include/util.h.

	* gpgv.c [__riscos__]: Likewise.

2002-06-20  David Shaw  <dshaw@jabberwocky.com>

	* keydb.h, pkclist.c (select_algo_from_prefs): Allow passing a
	suggested algorithm which will be used if available.

	* encode.c (encode_crypt, encrypt_filter), sign.c (sign_file): Use
	new select_algo_from_prefs feature to check if forcing an
	algorithm would violate the recipient preferences.

	* photoid.c (get_default_photo_command, show_photos): Use
	different default viewers on different platforms.  Currently we
	have Win 9x, Win NT (2k, xp), Mac OSX, RISC OS, and "everybody
	else".  These are #ifdefs as much as possible to avoid clutter.

	* g10.c (strusage, build_list), keyedit.c (show_prefs), main.h,
	misc.c (compress_algo_to_string, check_compress_algo), pkclist.c
	(algo_available), keygen.c (keygen_set_std_prefs): New
	algo_to_string and check functions for compress algorithms.

2002-06-20  Werner Koch  <wk@gnupg.org>

	* misc.c (setsysinfo): Removed a #warning for Alpha's uniligedn
	trap disabling - it is quite possible that this is a debug relict.

2002-06-20  Stefan Bellon  <sbellon@sbellon.de>

	* g10.c [__riscos__]: Added image file system feature.

	* gpgv.c [__riscos__]: Added image file system feature.

	* photoid.c (show_photos) [__riscos__]: Set RISC OS filetype of
	photo id according to MIME type.

2002-06-19  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index): Don't leak memory when failing out of a
	bad HKP keyserver.

	* g10.c (add_notation_data): Relax slightly the rules as to what
	can go into a notation name - 2440 allows "@", for example.

2002-06-17  David Shaw  <dshaw@jabberwocky.com>

	* import.c (clean_subkeys, import_one): Only allow at most 1
	binding sig and at most 1 revocation sig on a subkey, as per
	2440:11.1.

	* hkp.c (parse_hkp_index, hkp_search): Error if the keyserver
	returns an unparseable HKP response.

2002-06-15  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (show_key_with_all_names), keylist.c
	(list_keyblock_print): Show "[expired]" before expired uids.

	* keyedit.c (show_key_with_all_names_colon), mainproc.c
	(list_node), keylist.c (list_keyblock_colon): Show flag 'e' for
	expired user ids.  Use "uat" for user attribute packets instead of
	"uid".  Also use '<count> <length>' rather than the fake user id
	string on attributes.

	* keygen.c (keygen_add_revkey): Remove unused code.

	* misc.c (check_permissions): Check directory permissions
	properly - they are not special files.

	* pkclist.c (expand_id, expand_group, build_pk_list): When
	expanding groups before building a pk list, inherit flags from the
	original pre-expanded string.

	* pubkey-enc.c (is_algo_in_prefs): Don't use prefs from expired
	uids.

2002-06-14  David Shaw  <dshaw@jabberwocky.com>

	* free-packet.c (copy_signature): Properly copy a signature that
	carries a revocation key on it.

	* pkclist.c (expand_id, expand_group, build_pk_list): Groups now
	work properly when used in the "Enter the user ID" prompt.

2002-06-14  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (show_key_with_all_names): Display warning if a user
	tries to show prefs on a v3 key with a v3 selfsig.

	* kbnode.c (dump_kbnode): Show if a uid is expired.

	* import.c (merge_blocks, import_revoke_cert): Show user ID
	receiving a revocation certificate.

	* free-packet.c (cmp_user_ids): Properly compare attribute ids.

	* pkclist.c (expand_groups): Maintain the strlist flags while
	expanding.  Members of an expansion inherit their flags from the
	expansion key.

	* options.h, cipher.c (write_header), g10.c (main), keygen.c
	(keygen_set_std_prefs): remove the personal_mdc flag.  It no
	longer serves a purpose now that the personal preference lists are
	split into cipher/digest/zip.

2002-06-14  Timo Schulz  <ts@winpt.org>

	* skclist.c (is_insecure): Implemented.

2002-06-12  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Properly handle PROGRAM responses
	when they have a CRLF ending.  Noted by Keith Ray.

	* keyserver.c (keyserver_spawn): Handle CRLF endings from
	keyserver helpers.  Also don't leak the last line worth of memory
	from the keyserver response.

	* main.h, misc.c (deprecated_warning): New function to warn about
	deprecated options and commands.

	* g10.c (main), keyserver-internal.h, keyserver.c
	(parse_keyserver_uri): Use new deprecated function to warn about
	honor-http-proxy, auto-key-retrieve, and x-broken-hkp.

2002-06-11  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am: link gpg with NETLIBS for the built-in HKP access.

2002-06-10  David Shaw  <dshaw@jabberwocky.com>

	* options.h, keyserver.c (keyserver_opts), g10.c (main): New
	keyserver option "include-subkeys".  This feature already existed,
	but now can be turned off.  It defaults to on.

	* options.h, keyserver.c (parse_keyserver_options,
	keyserver_spawn): There are now enough options to justify making a
	structure for the keyserver options rather than a page of
	if-then-else-if-then-etc.

	* getkey.c (merge_keys_and_selfsig, merge_selfsigs_main): Fix bug
	in calculating key expiration dates.

2002-06-09  David Shaw  <dshaw@jabberwocky.com>

	* keydb.h, getkey.c (get_user_id_native), import.c (import_one):
	Display user ID while importing a key.  Note this applies to both
	--import and keyserver --recv-keys.

	* exec.c (exec_finish): Log unnatural exit (core dump, killed
	manually, etc) for fork/exec/pipe child processes.

2002-06-08  Timo Schulz  <ts@winpt.org>

	* encode.c (encode_symmetric): Disable the compat flag
	when the expert mode is enabled.

2002-06-07  David Shaw  <dshaw@jabberwocky.com>

	* options.skel, options.h, main.h, keydb.h, pkclist.c
	(build_pk_list, expand_groups), g10.c (main, add_group): Add new
	"group" command to allow one name to expand into multiple keys.
	For simplicity, and to avoid potential loops, we only expand once
	- you can't make an alias that points to an alias.

	* main.h, g10.c (main), keygen.c (build_personal_digest_list):
	Simplify the default digest list - there is really no need for the
	other hashes since they will never be used after SHA-1 in the
	list.

	* options.skel, options.h, g10.c (main), hkp.c (hkp_ask_import,
	hkp_export, hkp_search), keyserver.c (parse_keyserver_options,
	parse_keyserver_uri, keyserver_work, keyserver_refresh): Make the
	"x-broken-hkp" keyserver scheme into keyserver-option
	"broken-http-proxy".  Move honor_http_proxy into
	keyserver_options.  Canonicalize the three variations of "hkp",
	"x-hkp", and "x-broken-hkp" into "hkp".

2002-06-07  Stefan Bellon  <sbellon@sbellon.de>

	* g10.c [__riscos__]: Added --attribute-file to do the same as
	--attribute-fd, but with a filename not a fd as argument.
	Added magic symbol for RISC OS to use different memory management.

	* gpgv.c [__riscos__]: Added magic symbol for RISC OS to use
	different memory management.

2002-06-06  David Shaw  <dshaw@jabberwocky.com>

	* main.h, g10.c (main), keygen.c (build_personal_digest_list): Put
	in a default digest preference list consisting of SHA-1, followed
	by every other installed digest except MD5.  Note this is the same
	as having no digest preference at all except for SHA-1 being
	favored.

	* options.h, g10.c (main), keygen.c (keygen_set_std_prefs),
	pkclist.c (select_algo_from_prefs): Split
	--personal-preference-list into three:
	--personal-{cipher|digest|compress}-preferences.  This allows a
	user to set one without affecting another (i.e. setting only a
	digest pref doesn't imply an empty cipher pref).

	* exec.c (exec_read): This is a safer way of guessing the return
	value of system().  Noted by Stefan Bellon.

2002-06-05  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index): Be more robust with keyservers
	returning very unparseable responses.

	* exec.c (exec_read): Catch and display an error when the remote
	process exits unnaturally (i.e. segfault) so the user knows what
	happened.  Also fix exec_write stub which has a different number
	of arguments now.

2002-06-05  Timo Schulz  <ts@winpt.org>

	* encode.c (encode_simple): Ignore the new mode for RFC1991.
	* mainproc.c (symkey_decrypt_sesskey): Better check for weird
	keysizes.

2002-06-05  Timo Schulz  <ts@winpt.org>

	* encode.c (encode_sesskey): New.
	(encode_simple): Use it here. But by default we use the compat
	mode which supress to generate encrypted session keys.

2002-06-05  Timo Schulz  <ts@winpt.org>

	* mainproc.c (symkey_decrypt_sesskey): New.
	(proc_symkey_enc): Support for encrypted session keys.

2002-06-04  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (hash_for, sign_file): When encrypting and signing at the
	same time, consult the various hash prefs to pick a hash algorithm
	to use.  Pass in a 160-bit hint if any of the signing keys are
	DSA.

	* keydb.h, pkclist.c (select_algo_from_prefs, algo_available):
	Pass a "hints" opaque pointer in to let the caller give hints as
	to what algorithms would be acceptable.  The only current hint is
	for PREFTYPE_HASH to require a 160-bit hash for DSA.  Change all
	callers in encode.c (encode_crypt, encrypt_filter) and sign.c
	(sign_file).  If we settle on MD5 as the best algorithm based
	solely on recepient keys and SHA1 is also a possibility, use SHA1
	unless the user intentionally chose MD5.  This is as per 2440:13.

	* exec.c (make_tempdir): Fix duplicated filename problem.

2002-06-03  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, parse-packet.c (enum_sig_subpkt): Report back from
	enum_sig_subpkt when a subpacket is critical and change all
	callers in keylist.c (show_policy_url, show_notation), mainproc.c
	(print_notation_data), and pkclist.c (do_show_revocation_reason).

	* keylist.c (show_policy_url, show_notation): Display if the
	policy or notation is critical.

2002-06-03  David Shaw  <dshaw@jabberwocky.com>

	* main.h, g10.c (main), keylist.c (dump_attribs, set_attrib_fd,
	list_keyblock_print, list_keyblock_colon), status.h, status.c
	(get_status_string): New --attribute-fd feature to dump the
	contents of attribute subpackets for frontends.  If --status-fd is
	also used, then a new status tag ATTRIBUTE is provided for each
	subpacket.

	* packet.h, getkey.c (fixup_uidnode, merge_selfsigs_main,
	merge_selfsigs_subkey), parse-packet.c (setup_user_id): Keep track
	of the expiration time of a user ID, and while we're at it, use
	the expired flag from the selfsig rather than reparsing the
	SIG_EXPIRE subpacket.

	* photoid.c (generate_photo_id): When adding a new photo ID,
	showing the photo for confirmation is not safe when noninteractive
	since the "user" may not be able to dismiss a viewer window.
	Noted by Timo Schulz.

2002-06-03  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: Sample photo viewers for Win32.

	* misc.c (pct_expando): Use the seckey for %k/%K if the pubkey is
	not available.

	* photoid.h, photoid.c (show_photos): Include the seckey in case a
	user tries to view a photo on a secret key, and change all callers
	in keyedit.c (menu_showphoto), keylist.c (list_keyblock_print),
	and photoid.c (generate_photo_id).

2002-06-02  David Shaw  <dshaw@jabberwocky.com>

	* photoid.c (show_photos): Work properly when not called with a
	public key.

2002-05-31  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (mk_notation_and_policy): Free unneeded buffer.

	* hkp.c (parse_hkp_index): Properly handle the '&' character
	(i.e. "&amp;") in HKP responses.

	* getkey.c (merge_selfsigs_main): Fix reversed expiration time
	check with self-sigs.

	* keyedit.c (sign_uids): When making a new self-sig on a v3 key,
	make a v3 self-sig unless it is currently a v3 self-sig being
	promoted to v4.

2002-05-31  Timo Schulz  <ts@winpt.org>

	* pkclist.c (do_show_revocation_reason): Don't use capital
	letters for non-interactive output.
	(show_revocation_reason): Now it is global.
	* pubkey-enc.c (get_it): Show if the key has been revoked.

2002-05-30  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (write_signature_packets, sign_file, clearsign_file,
	sign_symencrypt_file): Make a v4 signature if a policy URL or
	notation is set, unless v3 sigs are forced via rfc1991 or
	force-v3-sigs.  Also remove some doubled code and clarify an error
	message (we don't sign in PGP2 mode - just detach-sign).

	* parse-packet.c (parse_one_sig_subpkt): Add KS_FLAGS to the "any
	size" section.

2002-05-29  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (keygen_set_std_prefs, add_feature_mdc): Use "mdc" and
	"no-mdc" in the prefs string to allow switching on and off the MDC
	feature.  This is needed to properly export a key from GnuPG for
	use on PGP which does not support MDC - without this, MDC-capable
	implementations will still try and generate MDCs which will break
	PGP.

	* keygen.c (keygen_get_std_prefs): Show "[mdc]" in prefs string if
	it is enabled.

	* options.h, g10.c (main), cipher.c (write_header), keygen.c
	(keygen_set_std_prefs): For consistency, allow the user to specify
	mdc/no-mdc in the --personal-preference-list.  If disabled, it
	acts just like --disable-mdc.

2002-05-29  David Shaw  <dshaw@jabberwocky.com>

	* options.h, exec.c: Add some debugging info, using the 1024 debug
	flag.

	* exec.c (win_system): New system()-like function for win32 that
	does not return until the child process terminates.  Of course,
	this doesn't help if the process itself exits before it is
	finished.

2002-05-29  Werner Koch  <wk@gnupg.org>

	* encode.c (encode_simple): Intialize PKT when --no-literal is used.

	* keyedit.c (show_key_with_all_names_colon): Renamed the record
	for revocation keys to "rvk".

2002-05-27  Werner Koch  <wk@gnupg.org>

	* keyedit.c (show_key_with_all_names_colon): New.
	(show_key_with_all_names): Divert to new function when required.
	Sanitize printing of revoker name.

2002-05-27  David Shaw  <dshaw@jabberwocky.com>

	* build-packet.c (build_sig_subpkt): Handle setting sig flags for
	certain subpacket types (notation, policy url, exportable,
	revocable).  keyedit.c (sign_mk_attrib): Flags no longer need to
	be set here.

	* packet.h, parse-packet.c (parse_one_sig_subpkt), build-packet.c
	(build_sig_subpkt): Call parse_one_sig_subpkt to sanity check
	buffer lengths before building a sig subpacket.

2002-05-26  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (mk_notation_and_policy): Include secret key to enable %s
	expandos, and pass notations through pct_expando as well.

	* main.h, misc.c (pct_expando): Add %s and %S expandos for
	signer's keyid.

2002-05-25  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (strusage, build_list): Add compress algorithms to
	--version list.  Show algorithm numbers when --verbose --version
	is done.

2002-05-22  David Shaw  <dshaw@jabberwocky.com>

	* options.h, main.h, keygen.c (keygen_set_set_prefs,
	keygen_get_std_prefs, keygen_upd_std_prefs), keyedit.c
	(keyedit_menu), g10.c (main), pkclist.c (select_algo_from_prefs):
	Add --personal-preference-list which allows the user to factor in
	their own preferred algorithms when the preference lists are
	consulted.  Obviously, this does not let the user violate a
	recepient's preferences (and the RFC) - this only influences the
	ranking of the agreed-on (and available) algorithms from the
	recepients.  Suggested by David Hollenberg.

	* options.h, keygen.c (keygen_set_std_prefs), g10.c (main): Rename
	--preference-list to --default-preference-list (as that is what it
	really is), and make it a true default in that if the user selects
	"default" they get this list and not the compiled-in list.

2002-05-22  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Add missing LF in a info printout and made it
	translatable.  Noted by Michael Tokarev.

2002-05-21  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Removed the undef of USE_SHM_COPROCESSING which
	was erroneously introduced on 2002-01-09.

	* signal.c (got_fatal_signal): Don't write the Nul to stderr.
	Reported by David Hollenberg.

2002-05-18  David Shaw  <dshaw@jabberwocky.com>

	* main.h, g10.c (main), revoke.c (gen_desig_revoke): Generate a
	designated revocation via --desig-revoke

	* keyedit.c (keyedit_menu, menu_addrevoker): New "addrevoker"
	command to add a designated revoker to a key.

2002-05-17  David Shaw  <dshaw@jabberwocky.com>

	* gpgv.c: Add stub for get_ownertrust().

	* g10.c (main): --allow-freeform-uid should be implied by
	OpenPGP.  Add --no-allow-freeform-uid.

	* keyedit.c (sign_uids): Issue a warning when signing a
	non-selfsigned uid.

	* getkey.c (merge_selfsigs_main): If a key has no selfsigs, and
	allow-non-selfsigned-uid is not set, still try and make the key
	valid by checking all uids for a signature from an ultimately
	trusted key.

2002-05-16  David Shaw  <dshaw@jabberwocky.com>

	* main.h, keygen.c (keygen_add_revkey): Add revocation key
	subpackets to a signature (callable by
	make_keysig_packet). (write_direct_sig): Write a 1F direct key
	signature. (parse_revocation_key): Parse a string in
	algo:fpr:sensitive format into a revocation
	key. (get_parameter_revkey, do_generate_keypair): Call above
	functions when prompted from a batch key generation file.

	* build-packet.c (build_sig_subpkt): Allow multiple revocation key
	subpackets in a single sig.

	* keydb.h, getkey.c (get_seckey_byfprint): Same as
	get_pubkey_byfprint, except for secret keys.  We only know the
	fingerprint of a revocation key, so this is needed to retrieve the
	secret key needed to issue a revokation.

	* packet.h, parse-packet.c (parse_signature, parse_revkeys): Split
	revkey parsing off into a new function that can be used to reparse
	after manipulating the revkey list.

	* sign.c (make_keysig_packet): Ability to make 1F direct key
	signatures.

2002-05-15  David Shaw  <dshaw@jabberwocky.com>

	* options.skel: keyserver.pgp.com is gone, so list pgp.surfnet.nl
	as a sample LDAP server instead.

	* getkey.c (merge_selfsigs_main): Properly handle multiple
	revocation keys in a single packet.  Properly handle revocation
	keys that are in out-of-order packets.  Remove duplicates in
	revocation key list.

2002-05-14  Timo Schulz   <ts@winpt.org>

	* exec.c (make_tempdir) [MINGW32]: Added missing '\'.

2002-05-14  Stefan Bellon  <sbellon@sbellon.de>

	* exec.c (make_tempdir): Make use of EXTSEP_S instead of hardcoded
	dot as extension separator.

2002-05-13  David Shaw  <dshaw@jabberwocky.com>

	* photoid.c (show_photos): Use the long keyid as the filename for
	the photo.  Use the short keyid as the filename on 8.3 systems.

	* exec.h, exec.c (make_tempdir, exec_write, exec_finish): Allow
	caller to specify filename.  This should make things easier on
	windows and macs where the file extension is required, but a whole
	filename is even better.

	* keyedit.c (show_key_with_all_names, show_prefs): Show proper
	prefs for a v4 key uid with no selfsig at all.

	* misc.c (check_permissions): Don't check permissions on
	non-normal files (pipes, character devices, etc.)

2002-05-11  Werner Koch  <wk@gnupg.org>

	* mainproc.c (proc_symkey_enc): Avoid segv in case the parser
	encountered an invalid packet.

	* keyserver.c (keyserver_export): Get confirmation before sending
	all keys.

2002-05-10  Stefan Bellon  <sbellon@sbellon.de>

	* g10.c, hkp.c, keyedit.c, keyserver.c: Replaced all occurrances
	of strcasecmp with ascii_strcasecmp and all occurrances of
	strncasecmp with ascii_memcasecmp.

2002-05-10  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, getkey.c (fixup_uidnode), keyedit.c (show_prefs): Show
	assumed prefs for hash and compression as well as the cipher pref.
	Show assumed prefs if there are no prefs at all on a v4
	self-signed key.

	* options.h, g10.c (main), sign.c (make_keysig_packet): New
	--cert-digest-algo function to override the default key signing
	hash algorithm.

2002-05-09  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (merge_selfsigs_main): Make sure the revocation key
	list starts clean as this function may be called more than once
	(e.g. from functions in --edit).

	* g10.c, encode.c (encode_crypt), sign.c (sign_file,
	sign_symencrypt_file): Make --compress-algo work like the
	documentation says.  It should be like --cipher-algo and
	--digest-algo in that it can override the preferences calculation
	and impose the setting the user wants.  No --compress-algo setting
	allows the usual preferences calculation to take place.

	* main.h, compress.c (compress_filter): use new
	DEFAULT_COMPRESS_ALGO define, and add a sanity check for compress
	algo value.

2002-05-08  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (select_algo_from_prefs): There is an assumed
	compression preference for uncompressed data.

2002-05-07  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), getkey.c (finish_lookup), pkclist.c
	(algo_available): --pgp7, identical to --pgp6 except that it
	permits a few algorithms that PGP 7 added: AES128, AES192, AES256,
	and TWOFISH.  Any more of these --pgpX flags, and it'll be time to
	start looking at a generic --emulate-pgp X option.

	* export.c (do_export_stream): Warn the user when exporting a
	secret key if it or any of its secret subkeys are protected with
	SHA1 while simple_sk_checksum is set.

	* parse-packet.c (parse_key): Show when the SHA1 protection is
	used in --list-packets.

	* options.h, build-packet.c (do_comment), g10.c (main): Rename
	--no-comment as --sk-comments/--no-sk-comments (--no-comment still
	works) and make the default be --no-sk-comments.

2002-05-07  Werner Koch  <wk@gnupg.org>

	* keygen.c (get_parameter_algo): Never allow generation of the
	deprecated RSA-E or RSA-S flavors of PGP RSA.
	(ask_algo): Allow generation of RSA sign and encrypt in expert
	mode.  Don't allow ElGamal S+E unless in expert mode.
	* helptext.c: Added entry keygen.algo.rsa_se.

2002-05-07  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (sign_uids): If --expert is set, allow re-signing a
	uid to promote a v3 self-sig to a v4 one.  This essentially
	deletes the old v3 self-sig and replaces it with a v4 one.

	* packet.h, parse-packet.c (parse_key), getkey.c
	(merge_keys_and_selfsig, merge_selfsigs_main): a v3 key with a v4
	self-sig must never let the v4 self-sig express a key expiration
	time that extends beyond the original v3 expiration time.

2002-05-06  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (sign_uids): When making a self-signature via "sign"
	don't ask about sig level or expiration, and include the usual
	preferences and such for v4 self-sigs.  (menu_set_preferences):
	Convert uids from UTF8 to native before printing.

	* keyedit.c (sign_uids): Convert uids from UTF8 to native before
	printing.  (menu_set_primary_uid): Show error if the user tries to
	make a uid with a v3 self-sig primary.

2002-05-05  David Shaw  <dshaw@jabberwocky.com>

	* import.c (import_one): When merging with a key we already have,
	don't let a key conflict (same keyid but different key) stop the
	import: just skip the bad key and continue.

	* exec.c (make_tempdir): Under Win32, don't try environment
	variables for temp directories - GetTempDir tries environment
	variables internally, and it's better not to second-guess it in
	case MS adds some sort of temp dir handling to Windows at some
	point.

2002-05-05  Timo Schulz  <ts@winpt.org>

	* mainproc.c (proc_symkey_enc): Don't ask for a passphrase
        in the list only mode.

2002-05-05  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_refresh): --refresh-keys implies
	--merge-only so as not to import keys with keyids that match the
	ones being refreshed.  Noted by Florian Weimer.

2002-05-04  Stefan Bellon  <sbellon@sbellon.de>

	* free-packet.c (copy_public_key): Don't call m_alloc(0), therefore
	added consistency check for revkey and numrefkeys.

	* getkey.c (check_revocation_keys): Added consistency check for
	revkey and numrefkeys.

	* keyedit.c (show_key_with_all_names): Likewise.

2002-05-03  David Shaw  <dshaw@jabberwocky.com>

	* photoid.c: Provide default image viewer for Win32.

	* misc.c (pct_expando): %t means extension, not name ("jpg", not
	"jpeg").

	* keyserver.c (keyserver_spawn), photoid.c (show_photos), exec.h,
	exec.c: Allow the caller to determine the temp file extension when
	starting an exec_write and change all callers.

	* keyedit.c (sign_uids): Nonrevocable key signatures cause an
	automatic promotion to v4.

	* exec.c: Provide stubs for exec_ functions when NO_EXEC is
	defined.

2002-05-02  David Shaw  <dshaw@jabberwocky.com>

	* photoid.h, photoid.c (parse_image_header, image_type_to_string):
	Useful functions to return data about an image.

	* packet.h, parse-packet.c (make_attribute_uidname,
	parse_attribute_subpkts, parse_attribute), photoid.h, photoid.c
	(show_photos): Handle multiple images in a single attribute
	packet.

	* main.h, misc.c (pct_expando), sign.c (mk_notation_and_policy),
	photoid.c (show_photos): Simpler expando code that does not
	require using compile-time string sizes.  Call
	image_type_to_string to get image strings (i.e. "jpg",
	"image/jpeg").  Change all callers.

	* keyedit.c (menu_showphoto), keylist.c (list_keyblock_print):
	Allow viewing multiple images within a single attribute packet.

	* gpgv.c: Various stubs for link happiness.

2002-05-02  David Shaw  <dshaw@jabberwocky.com>

	* build-packet.c (build_sig_subpkt), keyedit.c (sign_uids),
	options.h, sign.c (mk_notation_and_policy), g10.c (main,
	add_notation_data, add_policy_url (new), check_policy_url
	(removed)): Allow multiple policy URLs on a given signature.
	Split "--notation-data" into "--cert-notation" and
	"--sig-notation" so the user can set different policies for key
	and data signing.  For backwards compatibility, "--notation-data"
	sets both, as before.

2002-05-02  Werner Koch  <wk@gnupg.org>

	* options.skel: Removed the comment on trusted-keys because this
	option is now deprecated.

2002-05-01  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_adduid): 2440bis04 says that multiple attribute
	packets on a given key are legal.

	* keyserver.c (keyserver_refresh): the fake v3 keyid hack applies
	to "mailto" URLs as well since they are also served by pksd.

2002-04-29  Werner Koch  <wk@gnupg.org>

	Added a copyright year for files changed this year.

2002-04-25  Werner Koch  <wk@gnupg.org>

	* g10.c, options.h: New options --display, --ttyname, --ttytype,
	--lc-ctype, --lc-messages to be used with future versions of the
	gpg-agent.
	* passphrase.c (agent_send_option,agent_send_all_options): New.
	(agent_open): Send options to the agent.

	* trustdb.c (update_ownertrust, clear_ownertrust): Do an explicit
	do_sync because revalidation_mark does it only if when the
	timestamp actually changes.

2002-04-23  David Shaw  <dshaw@jabberwocky.com>

	* main.h, keygen.c (do_generate_keypair), keylist.c
	(print_signature_stats, list_all, list_one, list_keyblock,
	list_keyblock_print, list_keyblock_colon): After generating a new
	key, show the key information (name, keyid, fingerprint, etc.)
	Also do not print uncheckable signatures (missing key..) in
	--check-sigs.  Print statistics (N missing keys, etc.) after
	--check-sigs.

	* keyedit.c (sign_uids): When signing a key with an expiration
	date on it, the "Do you want your signature to expire at the same
	time?" question should default to YES.

2002-04-22  David Shaw  <dshaw@jabberwocky.com>

	* parse-packet.c (parse_plaintext), packet.h, plaintext.c
	(handle_plaintext): Fix bug in handling literal packets with
	zero-length data (no data was being confused with partial body
	length).

	* misc.c (pct_expando), options.skel: %t means extension ("jpg").
	%T means MIME type ("image/jpeg").

	* import.c (import_one): Only trigger trust update if the keyring
	is actually changed.

	* export.c (do_export_stream): Missing a m_free.

2002-04-22  Stefan Bellon  <sbellon@sbellon.de>

	* keyid.c (expirestr_from_sk, expirestr_from_sig): Added _() to
	string constant.

	* exec.c (make_tempdir) [__riscos__]: Better placement of
	temporary file.

2002-04-20  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (generate_subkeypair): 2440bis04 adds that creating
	subkeys on v3 keys is a MUST NOT.

	* getkey.c (finish_lookup): The --pgp6 "use the primary key"
	behavior should only apply while data signing and not encryption.
	Noted by Roger Sondermann.

2002-04-19  Werner Koch  <wk@gnupg.org>

	* keygen.c (keygen_set_std_prefs): Put back 3DES because the RFC
	says it is good form to do so.

2002-04-19  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_deluid): Only cause a trust update if we delete
	a non-revoked user id.

	* hkp.c (hkp_ask_import), keyserver.c (parse_keyserver_options,
	keyserver_spawn), options.h: Remove fast-import keyserver option
	(no longer meaningful).

	* g10.c (main), keyedit.c (sign_uids), options.h: Change
	--default-check-level to --default-cert-check-level as it makes
	clear what it operates on.

	* g10.c (main): --pgp6 also implies --no-ask-sig-expire.

	* delkey.c (do_delete_key): Comment.

	* keyedit.c (sign_uids, keyedit_menu, menu_deluid, menu_delsig,
	menu_expire, menu_revsig, menu_revkey): Only force a trustdb check
	if we did something that changes it.

	* g10.c: add "--auto-check-trustdb" to override a
	"--no-auto-check-trustdb"

2002-04-19  Werner Koch  <wk@gnupg.org>

	* tdbio.c (tdbio_write_nextcheck): Return a status whether the
	stamp was actually changed.
	* trustdb.c (revalidation_mark): Sync the changes.  Removed the
	sync operation done by its callers.
	(get_validity): Add logic for maintaining a pending_check flag.
	(clear_ownertrust): New.

	* keyedit.c (sign_uids): Don't call revalidation_mark depending on
	primary_pk.
	(keyedit_menu): Call revalidation_mark after "trust".
	(show_key_with_all_names): Print a warning on the wrong listed key
	validity.

	* delkey.c (do_delete_key): Clear the owenertrust information when
	deleting a public key.

2002-04-18  Werner Koch  <wk@gnupg.org>

	* seskey.c (encode_md_value): Print an error message if a wrong
	digest algorithm is used with DSA.  Changed all callers to cope
	with a NULL return.  Problem noted by Imad R. Faiad.

2002-04-18  David Shaw  <dshaw@jabberwocky.com>

	* trustdb.c (mark_usable_uid_certs): Properly handle nonrevocable
	signatures that can expire.  In short, the only thing that can
	override an unexpired nonrevocable signature is another unexpired
	nonrevocable signature.

	* getkey.c (finish_lookup): Always use primary signing key for
	signatures when --pgp6 is on since pgp6 and 7 do not understand
	signatures made by signing subkeys.

2002-04-18  Werner Koch  <wk@gnupg.org>

	* trustdb.c (validate_keys): Never schedule a nextcheck into the
	past.
	(validate_key_list): New arg curtime use it to set next_expire.
	(validate_one_keyblock): Take the current time from the caller.
	(clear_validity, reset_unconnected_keys): New.
	(validate_keys): Reset all unconnected keys.

	* getkey.c (premerge_public_with_secret): Fixed 0x12345678! syntax
	for use with secret keys.
	(lookup): Advance the searchmode after a search FIRST.

	* seckey-cert.c (do_check): Always calculate the old checksum for
	use after unprotection.

	* g10.c, options.skel: New option --no-escape-from.  Made
	--escape-from and --force-v3-sigs the default and removed them
	from the options skeleton.

2002-04-16  Werner Koch  <wk@gnupg.org>

	* parse-packet.c (parse_key): Support a SHA1 checksum as per
	draft-rfc2440-bis04.
	* packet.h (PKT_secret_key): Add field sha1chk.
	* seckey-cert.c (do_check): Check the SHA1 checksum
	(protect_secret_key): And create it.
	* build-packet.c (do_secret_key): Mark it as sha-1 protected.
	* g10.c, options.h: New option --simple-sk-checksum.

2002-04-13  David Shaw  <dshaw@jabberwocky.com>

	* parse-packet.c (parse_signature): Minor fix - signatures should
	expire at their expiration time and not one second later.

	* keygen.c (proc_parameter_file): Allow specifying preferences
	string (i.e. "s5 s2 z1 z2", etc) in a batchmode key generation
	file.

	* keyedit.c (keyedit_menu): Print standard error message when
	signing a revoked key (no new translation).

	* getkey.c (merge_selfsigs): Get the default set of key prefs from
	the real (not attribute) primary uid.

2002-04-12  David Shaw  <dshaw@jabberwocky.com>

	* pkclist.c (build_pk_list): Fix bug that allowed a key to be
	selected twice in batch mode if one instance was the default
	recipient and the other was an encrypt-to.  Noted by Stefan
	Bellon.

	* parse-packet.c (dump_sig_subpkt): Show data in trust and regexp
	sig subpackets.

	* keyedit.c (keyedit_menu): Use new function real_uids_left to
	prevent deleting the last real (i.e. non-attribute) uid.  Again,
	according to the attribute draft. (menu_showphoto): Make another
	string translatable.

2002-04-11  David Shaw  <dshaw@jabberwocky.com>

	* build-packet.c (build_sig_subpkt): Delete subpackets from both
	hashed and unhashed area on update.  (find_subpkt): No longer
	needed.

	* keyedit.c (sign_uids): With --pgp2 on, refuse to sign a v3 key
	with a v4 signature.  As usual, --expert overrides.  Try to tweak
	some strings to a closer match so they can all be translated in
	one place.  Use different helptext keys to allow different help
	text for different questions.

	* keygen.c (keygen_upd_std_prefs): Remove preferences from both
	hashed and unhashed areas if they are not going to be used.

2002-04-10  David Shaw  <dshaw@jabberwocky.com>

	* misc.c (pct_expando), options.skel: Use %t to indicate type of a
	photo ID (in this version, it's always "jpeg").  Also tweak string
	expansion loop to minimize reallocs.

	* mainproc.c (do_check_sig): Variable type fix.

	* keyedit.c (menu_set_primary_uid): Differentiate between true
	user IDs and attribute user IDs when making one of them primary.
	That is, if we are making a user ID primary, we alter user IDs.
	If we are making an attribute packet primary, we alter attribute
	packets.  This matches the language in the latest attribute packet
	draft.

	* keyedit.c (sign_uids): No need for the empty string hack.

	* getkey.c (fixup_uidnode): Only accept preferences from the
	hashed segment of the self-sig.

2002-04-10  Werner Koch  <wk@gnupg.org>

	* tdbio.c (migrate_from_v2): Fixed the offset to read the old
	ownertrust value and only add entries to the table if we really
	have a value.

2002-04-08  David Shaw  <dshaw@jabberwocky.com>

	* status.h, status.c (get_status_string): Add KEYEXPIRED, EXPSIG,
	and EXPKEYSIG.  Add "deprecated-use-keyexpired-instead" to
	SIGEXPIRED.

	* sig-check.c (do_check): Start transition from SIGEXPIRED to
	KEYEXPIRED, since the actual event is signature verification by an
	expired key and not an expired signature. (do_signature_check,
	packet.h): Rename as signature_check2, make public, and change all
	callers.

	* mainproc.c (check_sig_and_print, do_check_sig): Use status
	EXPSIG for an expired, but good, signature.  Add the expiration
	time (or 0) to the VALIDSIG status line.  Use status KEYEXPSIG for
	a good signature from an expired key.

	* g10.c (main): remove checks for no arguments now that argparse
	does it.

2002-04-06  Werner Koch  <wk@gnupg.org>

	* keyring.c (keyring_get_keyblock): Disable the keylist mode here.

	* encode.c (encode_simple, encode_crypt): Only test on compressed
	files if a compress level was not explicity set.

	* keygen.c (keygen_set_std_prefs): Removed Blowfish and Twofish
	from the list of default preferences, swapped the preferences of
	RMD160 and SHA1.  Don't include a preference to 3DES unless the
	IDEA kludge gets used.

	* free-packet.c (free_packet): call free_encrypted also for
	PKT_ENCRYPTED_MDC.

	* compress.c (release_context): New.
	(handle_compressed): Allocate the context and setup a closure to
	release the context.  This is required because there is no
	guarantee that the filter gets popped from the chain at the end
	of the function.  Problem noted by Timo and probably also the
	cause for a couple of other reports.
	(compress_filter): Use the release function if set.

	* tdbio.c [__CYGWIN32__]: Don't rename ftruncate.  Noted by
	Disastry.

	* parse-packet.c (parse_signature): Put parens around a bit test.

	* exec.c (make_tempdir): Double backslash for TMP directory
	creation under Windows.  Better strlen the DIRSEP_S constants for
	allocation measurements.

	* decrypt.c (decrypt_messages): Release the passphrase aquired
	by get_last_passphrase.

2002-04-02  Werner Koch  <wk@gnupg.org>

	* Makefile.am (EXTRA_DIST): Removed OPTIONS an pubring.asc - they
	are no longer of any use.

2002-04-03  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (parse_keyserver_options): fix auto-key-retrieve to
	actually work as a keyserver-option (noted by Roger Sondermann).

	* keylist.c (reorder_keyblock): do not reorder the primary
	attribute packet - the first user ID must be a genuine one.

2002-03-31  David Shaw  <dshaw@jabberwocky.com>

	* keylist.c (list_keyblock_colon): Fix ownertrust display with
	--with-colons.

	* keygen.c (generate_user_id), photoid.c (generate_photo_id):
	Properly initialize the user ID refcount.  A few more "y/n" ->
	"y/N" in photoid.c.

	* keyedit.c (ask_revoke_sig): Warn the user if they are about to
	revoke an expired sig (not a problem, but they should know).  Also
	tweak a few prompts to change "y/n" to "y/N", which is how most
	other prompts are written.

	* keyserver.c (keyserver_search_prompt): Control-d escapes the
	keyserver search prompt.

	* pkclist.c (show_revocation_reason & callers): If a subkey is
	considered revoked solely because the parent key is revoked, print
	the revocation reason from the parent key.

	* trustdb.c (get_validity): Allow revocation/expiration to apply
	to a uid/key with no entry in the trustdb.

2002-03-29  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (printunquoted): unquote backslashes from keyserver
	searches

	* hkp.c (write_quoted): quote backslashes from keyserver searches

2002-03-26  Werner Koch  <wk@gnupg.org>

	* keygen.c (ask_keysize): Removed the warning for key sizes > 1536.

2002-03-25  Werner Koch  <wk@gnupg.org>

	* keyedit.c (sign_uids): Use 2 strings and not a %s so that
	translations can be done the right way.
	* helptext.c: Fixed small typo.

2002-03-23  David Shaw  <dshaw@jabberwocky.com>

	* import.c (append_uid, merge_sigs): it is okay to import
	completely non-signed uids now (with --allow-non-selfsigned-uid).

	* getkey.c (get_primary_uid, merge_selfsigs_main): do not choose
	an attribute packet (i.e. photo) as primary uid.  This prevents
	oddities like "Good signature from [image of size 2671]".  This is
	still not perfect (one can still select an attribute packet as
	primary in --edit), but is closer to the way the draft is going.

	* g10.c (build_list): algorithms should include 110.

	* g10.c (main): --pgp2 implies --no-ask-sig-expire and
	--no-ask-cert-expire as those would cause a v4 sig/cert.

	* armor.c (is_armor_header): be more lenient in what constitutes a
	valid armor header (i.e. -----BEGIN blah blah-----) as some
	Windows programs seem to add spaces at the end.  --openpgp makes
	it strict again.

2002-03-18  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_search_prompt): Properly handle a "no
	keys found" case from the internal HKP code (external HKP is ok).
	Also, make a COUNT -1 (i.e. streamed) keyserver response a little
	more efficient.

	* g10.c (main): Add --no-allow-non-selfsigned-uid

2002-03-17  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): --openpgp implies --allow-non-selfsigned-uid.

	* getkey.c (merge_selfsigs_main): If none of the uids are primary
	(because none are valid) then pick the first to be primary (but
	still invalid).  This is for cosmetics in case some display needs
	to print a user ID from a non-selfsigned key.  Also use
	--allow-non-selfsigned-uid to make such a key valid and not
	--always-trust.  The key is *not* automatically trusted via
	--allow-non-selfsigned-uid.

	* mainproc.c (check_sig_and_print): Make sure non-selfsigned uids
	print [uncertain] on verification even though one is primary now.

	* getkey.c (merge_selfsigs): If the main key is not valid, then
	neither are the subkeys.

	* import.c (import_one): Allow --allow-non-selfsigned-uid to work
	on completely unsigned keys.  Print the uids in UTF8.  Remove
	mark_non_selfsigned_uids_valid().

	* keyedit.c (show_key_with_all_names): Show revocation key as
	UTF8.

	* sign.c (clearsign_file): Allow --not-dash-escaped to work with
	v3 keys.

2002-03-14  Werner Koch  <wk@gnupg.org>

	* main.h: Changed the default algorithms to CAST5 and SHA1.

2002-03-13  David Shaw  <dshaw@jabberwocky.com>

	* import.c (chk_self_sigs): Show which user ID a bad self-sig
	(invald sig or unsupported public key algorithm) resides on.

	* import.c (chk_self_sigs): any valid self-sig should mark a user
	ID or subkey as valid - otherwise, an attacker could DoS the user
	by inventing a bogus invalid self-signature.

2002-03-07  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): make a few more strings translatable.

	* options.h, options.skel, g10.c (main), gpgv.c, mainproc.c
	(check_sig_and_print), keyserver.c (parse_keyserver_options):
	--auto-key-retrieve should really be a keyserver-option variable.

	* import.c (revocation_present): new function to print a warning
	if a key is imported that has been revoked by designated revoker,
	but the designated revoker is not present to verify the
	revocation.  If keyserver-options auto-key-retrieve is set, try
	and fetch the designated revoker from the keyserver.

	* import.c (import_one): call revocation_present after importing a
	new key.  Note that this applies to --import, --recv-keys, and
	--search-keys.

	* keyserver-internal.h, keyserver.c (keyserver_import_fprint):
	import via fingerprint (for revocation keys).

	* keyserver.c (keyserver_import_keyid): much simpler
	implementation now that we're using KEYDB_SEARCH_DESC internally.

2002-03-04  David Shaw  <dshaw@jabberwocky.com>

	* revoke.c (gen_revoke): do not prompt for revocation reason for
	v3 revocations (unless force-v4-certs is on) since they wouldn't
	be used anyway.

	* keyedit.c (menu_revsig): show the status of the sigs
	(exportable? revocable?) to the user before prompting for which
	sig to revoke.  Also, make sure that local signatures get local
	revocations.

	* keyedit.c (ask_revoke_sig): remind the user which sigs are
	local.

	* g10.c (main): Add "exec-path" variable to override PATH for
	execing programs.

	* export.c (do_export_stream): properly check return code from
	classify_user_id to catch unclassifiable keys.

2002-03-03  David Shaw  <dshaw@jabberwocky.com>

	* parse-packet.c (parse_signature): variable type tweak for RISC
	OS (from Stefan)

2002-02-28  David Shaw  <dshaw@jabberwocky.com>

	* getkey.c (check_revocation_keys): New function to check a
	revocation against a list of potential revocation keys.  Note the
	loop-breaking code here.  This is to prevent blowing up if A is
	B's revocation key, while B is also A's.  Note also that this is
	written so that a revoked revoker can still issue revocations:
	i.e. If A revokes B, but A is revoked, B is still revoked.  I'm
	not completely convinced this is the proper behavior, but it
	matches how PGP does it.  It does at least have the advantage of
	much simpler code - my first version of this had lots of loop
	maintaining code so you could chain revokers many levels deep and
	if D was revoked, C was not, which meant that B was, and so on.
	It was sort of scary, actually.

	* getkey.c (merge_selfsigs_main): Add any revocation keys onto the
	pk.  This is particularly interesting since we normally only get
	data from the most recent 1F signature, but you need multiple 1F
	sigs to properly handle revocation keys (PGP does it this way, and
	a revocation key could be marked "sensitive" and hence in a
	different signature).  Also, if a pk has a revocation key set,
	check for revocation sigs that were not made by us - if made by a
	valid revocation key, mark the pk revoked.

	* packet.h, getkey.c (cache_public_key): do not cache key if
	"dont_cache" is set.  This allows the revocation key code to look
	up a key and return information that may be inaccurate to prevent
	loops without caching the fake data.

	* packet.h, sig-check.c (do_signature_check): Record if a
	signature was made by a revoked pk.

	* packet.h, parse-packet.c (parse_one_sig_subpkt,
	can_handle_critical, parse_signature): Get revocation key
	information out of direct sigs.

	* keylist.c (list_keyblock_print): don't assume that the presence
	of a 0x20 signature means the key is revoked.  With revocation
	keys, this may not be true if the revocation key is not around to
	verify it or if verification failed.  Also, 0x1F should get listed
	as "sig", and not "unexpected signature class".

	* keyedit.c (show_key_with_all_names): Add a flag for printing
	revoker information and change all callers.

	* import.c (merge_blocks): merge in any new direct key (0x1F)
	sigs.

	* import.c (import_revoke_cert): don't keep processing after a
	revocation is rejected.

	* import.c (delete_inv_parts): Allow importing a revocation
	signature even if it was not issued by the key.  This allows a
	revocation key to issue it.  Of course, the sig still needs to be
	checked before we trust it.

	* free-packet.c (copy_public_key): Include a new copy of the
	revocation keys when duping a pk.

	* free-packet.c (free_seckey_enc, release_public_key_parts): Free
	any revocation keys that are attached to a sig or pk.

	* export.c (do_export_stream): Do not export signatures with
	"sensitive" revocation keys in them.

2002-02-27  David Shaw  <dshaw@jabberwocky.com>

	* export.c (do_export_stream): Do not include v3 keys in a
	--export-secret-subkeys export.

	* getkey.c (merge_selfsigs_main): If a key isn't valid (say,
	because of no self-signature), allow --always-trust to force it
	valid so it can be trusted.

2002-02-25  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (hkp_ask_import), hkp.h, keyserver.c (all): treat key
	lists internally as fingerprints when possible.  All this is via
	KEYDB_SEARCH_DESC - no point in reinventing the wheel. This allows
	the helper program to search the keyserver by fingerprint if
	desired (and the keyserver supports it).  Note that automatic
	fingerprint promotion during refresh only applies to v4 keys as a
	v4 fingerprint can be easily changed into a long or short key id,
	and a v3 cannot.

	* pubkey-enc.c, getkey.c, misc.c, main.h: Take two copies of
	hextobyte() from pubkey-enc.c and getkey.c and make them into one
	copy in misc.c.

2002-02-22  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_search_prompt): Detect a "no keys found"
	case even if the helper program does not explicitly say how many
	keys were found.

	* hkp.c (parse_hkp_index): Bug fix - don't report non-revoked keys
	as revoked in HKP key searches.

2002-02-19  Werner Koch  <wk@gnupg.org>

	* parse-packet.c (parse_trust): Made parsing more robust.

2002-02-19  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index): Catch corruption in HKP index lines
	(can be caused by broken or malicious keyservers).

	* keyserver.c (keyserver_work): Add KEYSERVER_NOT_SUPPORTED for
	unsupported actions (say, a keyserver that has no way to search,
	or a readonly keyserver that has no way to add).  Also add a
	USE_EXTERNAL_HKP define to disable the internal HKP keyserver
	code.

2002-02-14  Werner Koch  <wk@gnupg.org>

	* g10.c: New option --no-use-agent.

	* pkclist.c (check_signatures_trust): Always print the warning for
	unknown and undefined trust.  Removed the did_add cruft.  Reported
	by Janusz A. Urbanowicz.

2002-02-11  David Shaw  <dshaw@jabberwocky.com>

	* hkp.c (parse_hkp_index): Bug fix - properly handle user IDs with
	colons (":") in them while HKP searching.

2002-02-09  David Shaw  <dshaw@jabberwocky.com>

	* misc.c (pct_expando): More comments.

	* keydb.h, sign.c (mk_notation_and_policy): Clarify what is a sig
	and what is a cert.  A sig has sigclass 0x00, 0x01, 0x02, or 0x40,
	and everything else is a cert.

	* g10.c (main), keyedit.c (keyedit_menu): Add a "nrlsign" for
	nonrevocable and local key signatures.

	* g10.c (main): Add a --no-force-mdc to undo --force-mdc.

	* options.h, g10.c (main), cipher.c (write_header): Add a knob to
	--disable-mdc/--no-disable-mdc.  Off by default, of course, but is
	used in --pgp2 and --pgp6 modes.

	* pkclist.c (build_pk_list): Allow specifying multiple users in
	the "Enter the user ID" loop.  Enter a blank line to stop.  Show
	each key+id as it is added.

	* keylist.c (show_policy_url), mainproc.c (print_notation_data):
	It is not illegal (though possibly silly) to have multiple policy
	URLs in a given signature, so print all that are present.

	* hkp.c (hkp_search): More efficient implementation of URL-ifying
	code.

2002-02-04  David Shaw  <dshaw@jabberwocky.com>

	* main.h, misc.c (pct_expando): New function to generalize
	%-expando processing in any arbitrary string.

	* photoid.c (show_photo): Call the new pct_expando function rather
	than expand strings internally.

	* sign.c (mk_notation_and_policy): Show policy URLs and notations
	when making a signature if show-policy/show-notation is on.
	%-expand policy URLs during generation.  This lets the user have
	policy URLs of the form "http://notary.jabberwocky.com/keysign/%K"
	which will generate a per-signature policy URL.

	* main.h, keylist.c (show_policy_url, show_notation): Add amount
	to indent so the same function can be used in key listings as well
	as during sig generation.  Change all callers.

2002-02-04  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c, options.h (parse_keyserver_options, keyidlist):
	Workaround for the pksd and OKS keyserver bug that calculates v4
	RSA keyids as if they were v3.  The workaround/hack is to fetch
	both the v4 (e.g. 99242560) and v3 (e.g. 68FDDBC7) keyids.  This
	only happens for key refresh while using the HKP scheme and the
	refresh-add-fake-v3-keyids keyserver option must be set.  This
	should stay off by default.

2002-02-03  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Bug fix - do not append keys to
	each other when --sending more than one.

2002-02-02  David Shaw  <dshaw@jabberwocky.com>

	* options.h, g10.c (main), keyedit.c (sign_uids), sign.c
	(mk_notation_and_policy): Split "--set-policy-url" into
	"--cert-policy-url" and "--sig-policy-url" so the user can set
	different policies for key and data signing.  For backwards
	compatibility, "--set-policy-url" sets both, as before.

2002-01-30  Werner Koch  <wk@gnupg.org>

	* g10.c (main): --gen-random --armor does now output a base64
	encoded string.

2002-01-28  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main), options.h, pkclist.c (algo_available): --pgp6
	flag.  This is not nearly as involved as --pgp2.  In short, it
	turns off force_mdc, turns on no_comment, escape_from, and
	force_v3_sigs, and sets compression to 1.  It also restricts the
	user to IDEA (if present), 3DES, CAST5, MD5, SHA1, and RIPEMD160.
	See the comments above algo_available() for lots of discussion on
	why you would want to do this.

2002-01-27  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (keygen_set_std_prefs): Comment

	* keyedit.c (sign_uids): Bug fix - when signing with multiple
	secret keys at the same time, make sure each key gets the sigclass
	prompt.

	* exec.c (exec_finish): Close the iobuf and FILE before trying to
	waitpid, so the remote process will get a SIGPIPE and exit.  This
	is only a factor when using a pipe to communicate.

	* exec.c (exec_write): Disable cache-on-close of the fd iobuf (is
	this right?  Why is a fd iobuf cached at all?)

2002-01-26  Werner Koch  <wk@gnupg.org>

	* g10.c, options.h: New option --gpg-agent-info
	* passphrase.c (agent_open): Let it override the environment info.
	* seckey-cert.c (check_secret_key): Always try 3 times when the
	agent is enabled.
	* options.skel: Describe --use-agent.

2002-01-24  David Shaw  <dshaw@jabberwocky.com>

	* pubkey-enc.c (is_algo_in_prefs, get_it): Only check preferences
	against keys with v4 self sigs - there is really little point in
	warning for every single non-IDEA message encrypted to an old key.

	* pkclist.c (select_algo_from_prefs): Only put in the fake IDEA
	preference if --pgp2 is on.

	* mainproc.c (check_sig_and_print): Print "Expired" for expired
	but good signatures (this still prints "BAD" for expired but bad
	signatures).

2002-01-23  David Shaw  <dshaw@jabberwocky.com>

	* keygen.c (ask_keysize): Cosmetic: don't present a RSA signing
	key as a "keypair" which can be 768 bits long (as RSA minimum is
	1024).

	* pubkey-enc.c (is_algo_in_prefs): Allow IDEA as a fake preference
	for v3 keys with v3 selfsigs.

2002-01-22  David Shaw  <dshaw@jabberwocky.com>

	* packet.h, getkey.c (merge_selfsigs_main), pkclist.c
	(select_algo_from_prefs): Implement the fake IDEA preference as
	per RFC2440:12.1.  This doesn't mean that IDEA will be used (the
	plugin may not be present), but it does mean that a v3 key with a
	v3 selfsig has an implicit IDEA preference instead of 3DES.  v3
	keys with v4 selfsigs use preferences as normal.

	* encode.c (encode_crypt): if select_algo_from_prefs fails, this
	means that we could not find a cipher that both keys like.  Since
	all v4 keys have an implicit 3DES preference, this means there is
	a v3 key with a v3 selfsig in the list.  Use 3DES in this case as
	it is the safest option (we know the v4 key can handle it, and
	we'll just hope the v3 key is being used in an implementation that
	can handle it).  If --pgp2 is on, warn the user what we're doing
	since it'll probably break PGP2 compatibility.

	* g10.c (main): Do not force using IDEA for encrypted files in
	--pgp2 mode - let the fake IDEA preference choose this for us for
	better compatibility when encrypting to multiple keys, only some
	of which are v3.

	* keygen.c (keygen_set_std_prefs): Put 3DES on the end of the
	default cipher pref list (RFC2440: "...it is good form to place it
	there explicitly.").  If the user has the IDEA plugin installed,
	put a preference for IDEA *after* 3DES to effectively disable its
	use for everything except encrypting along with v3 keys.

	* encode.c, g10.c, sign.c: Change the PGP2 warning line from
	"... will not be usable ..." to "... may not be usable ..." as the
	user could be using one of the enhanced PGP2 variations.

	* helptext.c: Revise the sign_uid.class help text as suggested by
	Stefan.

2002-01-20  Werner Koch  <wk@gnupg.org>

	* passphrase.c (passphrase_to_dek): Add tryagain_text arg to be
	used with the agent.  Changed all callers.
	(agent_get_passphrase): Likewise and send it to the agent
	* seckey-cert.c (do_check): New arg tryagain_text.
	(check_secret_key): Pass the string to do_check.
	* keygen.c (ask_passphrase): Set the error text is required.
	* keyedit.c (change_passphrase): Ditto.

	* passphrase.c (agent_open): Disable opt.use_agent in case of a
	problem with the agent.
	(agent_get_passphrase): Ditto.
	(passphrase_clear_cache): Ditto.

2002-01-19  Werner Koch  <wk@gnupg.org>

	* passphrase.c (agent_open): Add support for the new Assuan based
	gpg-agent.  New arg to return the used protocol version.
	(agent_get_passphrase): Implemented new protocol here.
	(passphrase_clear_cache): Ditto.
	(readline): New.

2002-01-15  Timo Schulz  <ts@winpt.org>

	* encode.c (encode_crypt_files): Fail if --output is used.

	* g10.c: New command --decrypt-files.

	* decrypt.c (decrypt_messages): New.

2002-01-09  David Shaw  <dshaw@jabberwocky.com>

	* g10.c, misc.c, gpgv.c: move idea_cipher_warn to misc.c so gpgv.c
	doesn't need a stub for it any longer.

	* g10.c (get_temp_dir), main.h: no longer used (it's in exec.c now)

	* g10.c (main), delkey.c (delete_keys), main.h : Allow
	--delete-key (now --delete-keys, though --delete-key still works,
	of course) to delete multiple keys in one go.  This applies to
	--delete-secret-key(s) and --delete-secret-and-public-key(s) as
	well.

2002-01-09  Timo Schulz  <ts@winpt.org>

	* encode.c (encode_crypt_files): Now it behaves like verify_files.

	* g10.c (main): We don't need to check argc for encode_crypt_files
	any longer.

2002-01-09  Timo Schulz  <ts@winpt.org>

	* exec.c: Include windows.h for dosish systems.

2002-01-08  Timo Schulz  <ts@winpt.org>

	* g10.c (main): New description for --encrypt-files.

2002-01-08  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Must register the secring for encryption because
	it is needed to figure out the default recipient.  Reported by
	Roger Sondermann.

2002-01-05  David Shaw  <dshaw@jabberwocky.com>

	* keyedit.c (menu_adduid): Require --expert before adding a photo
	ID to a v3 key, and before adding a second photo ID to any key.

	* keyedit.c (keyedit_menu): Don't allow adding photo IDs in
	rfc1991 or pgp2 mode.

	* getkey.c (merge_selfsigs_subkey): Permit v3 subkeys.  Believe it
	or not, this is allowed by rfc 2440, and both PGP 6 and PGP 7 work
	fine with them.

	* g10.c, options.h, keyedit.c, sign.c: Move the "ask for
	expiration" switch off of --expert, which was getting quite
	overloaded, and onto ask-sig-expire and ask-cert-expire.  Both
	default to off.

	* g10.c (main): Change the default compression algo to 1, to be
	more OpenPGP compliant (PGP also uses this, so it'll help with
	interoperability problems as well).

	* encode.c (encode_crypt): Handle compression algo 2, since the
	default is now 1.

	* build-packet.c (build_attribute_subpkt): Fix off-by-one error.

2002-01-05  Werner Koch  <wk@gnupg.org>

	* g10.c (main): Do not register the secret keyrings for certain
	commands.

	* keydb.c (keydb_add_resource): Use access to test for keyring
	existence.  This avoids cached opened files which are bad under
	RISC OS.

2002-01-04  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (sign_file, sign_symencrypt_file): always use one-pass
	packets unless rfc1991 is enabled.  This allows a signature made
	with a v3 key to work in PGP 6 and 7.  Signatures made with v4
	keys are unchanged.

	* g10.c (main): Disallow non-detached signatures in PGP2 mode.
	Move the "you must use files and not pipes" PGP2 warning up so all
	the PGP2 stuff is together.

	* encode.c (encode_simple): Use the actual filesize instead of
	partial length packets in the internal literal packet from a
	symmetric message.  This breaks PGP5(?), but fixes PGP2, 6, and 7.
	It's a decent tradeoff.  Note there was only an issue with
	old-style RFC1991 symmetric messages.  2440-style messages in 6
	and 7 work with or without partial length packets.

2002-01-03  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Removed --no-default-check-level option, as it is
	not consistent with other "default" options.  Plus, it is the same
	as saying --default-check-level 0.

	* exec.c (exec_read): Disallow caching tempfile from child
	process, as this keeps the file handle open and can cause unlink
	problems on some platforms.

	* keyserver.c (keyserver_search_prompt): Minor tweak - don't
	bother to transform keyids into textual form if they're just going
	to be transformed back to numbers.

2002-01-03  Timo Schulz <ts@winpt.org>

	* g10.c: New command --encrypt-files.

	* verify.c (print_file_status): Removed the static because
	encode_crypt_files also uses this function.

	* main.h (print_files_status): New.
	(encode_crypt_files): New.

	* encode.c (encode_crypt_files): New.

2002-01-02  Stefan Bellon  <sbellon@sbellon.de>

	* keyserver.c: Moved util.h include down in order to avoid
	redefinition problems on RISC OS.

	* keyring.c (keyring_lock): Only lock keyrings that are writable.

	* keyring.c (keyring_update_keyblock): Close unused iobuf.

	* hkp.c (parse_hkp_index, hkp_search) [__riscos__]: Changed
	unsigned char* to char* because of compiler issues.

	* exec.c (exec_finish) [__riscos__]: Invalidate close cache so
	that file can be unlinked.

2001-12-28  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (main): Use a different strlist to check extensions since
	they need to be handled seperately now.

	* misc.c,main.h (check_permissions): Properly handle permission
	and ownership checks on files in the lib directory
	(e.g. /usr/local/lib/gnupg), which are owned by root and are
	world-readable, and change all callers to specify extension or
	per-user file.

	* photoid.c (show_photo), keyserver.c (keyserver_spawn): Bug fix -
	don't call exec_finish if exec_write fails.

	* keyserver.c (keyserver_spawn): Look for OPTIONS from the
	keyserver helper - specifically, a "OUTOFBAND" option for the
	email keyserver.

	* mainproc.c (list_node), keylist.c (list_keyblock_colon),
	import.c (delete_inv_parts), export.c (do_export_stream): Use
	signature flags for exportability check rather than re-parsing the
	subpacket.

	* keyid.c, keydb.h (get_lsign_letter): No longer needed.

2001-12-27  David Shaw  <dshaw@jabberwocky.com>

	* exec.c (exec_finish): Show errors when temp files cannot be
	deleted for whatever reason.

	* exec.c (exec_read): Don't rely on WEXITSTATUS being present.

	* exec.c (make_tempdir): Add temp file creator for win32.  Don't
	create an incoming temp file if the exec is write-only.

	* keyserver.c (keyserver_spawn): Clean up error handling, for when
	the spawn fails.

	* photoid.c (show_photo): Clean up error handling.

	* misc.c (check_permissions): Neaten.

2001-12-25  David Shaw  <dshaw@jabberwocky.com>

	* mkdtemp.c (mkdtemp): Add copyleft info and tweak the 'X' counter
	to be a bit simpler.

	* keyserver.c, photoid.c: Remove unused headers left over from
	when the exec functions lived there.

2001-12-23  Timo Schulz <ts@winpt.org>

	* misc.c (check_permissions): Do not use it for W32 systems.

	* tdbio.c (migrate_from_v2): Define ftruncate as chsize() for W32.

	* mkdtemp.c: W32 support.

	* photoid.c: Ditto.

	* exec.c: Ditto.

2001-12-22  David Shaw  <dshaw@jabberwocky.com>

	* exec.c (make_tempdir): avoid compiler warning with const

	* mkdtemp.c (mkdtemp): catch the empty ("") string case in case
	someone repurposes mkdtemp at some point.

	* photoid.c (generate_photo_id, show_photo): some type changes
	from Stefan Bellon.

	* exec.c (make_tempdir): handle Win32 systems, suggested by Timo
	Schulz.

2001-12-22  Werner Koch  <wk@gnupg.org>

	* encode.c (encode_simple, encode_crypt): i18n 2 strings.

2001-12-22  Timo Schulz <ts@winpt.org>

	* encode.c (encode_simple, encode_crypt): Use is_file_compressed
	to avoid to compress compressed files.

2001-12-22  Werner Koch  <wk@gnupg.org>

	* keyserver.c (keyserver_spawn): Removed some variables
	declaration due to shadowing warnings.

	* build-packet.c (build_attribute_subpkt): s/index/idx/ to avoid
	compiler warnig due to index(3).

	* getkey.c (get_ctx_handle): Use KEYDB_HANDLE as return value.
	* keylist.c (list_one): Made resname const.

	* keyedit.c (keyedit_menu): Allow "addphoto" only when --openpgp is
	not used.

	* options.skel: Changed one example photo viewer to qiv.

2001-12-21  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am: add exec.c, exec.h, photoid.c, and photoid.h

	* build-packet.c (build_attribute_subpkt): new function to build
	the raw attribute subpacket.  Note that attribute subpackets have
	the same format as signature subpackets.

	* exec.c: new file with generic exec-a-program functionality.
	Used by both photo IDs and keyserver helpers.  This is pretty much
	the same code that used to be keyserver specific, with some
	changes to be usable generically.

	* free-packet.c (free_attributes (new)): function to free an
	attribute packet.

	* gpgv.c: added stub show_photo

	* keyedit.c (keyedit_menu, menu_adduid, menu_showphoto): can add a
	photo (calls generate_photo_id), or display a photo (calls
	show_photo) from the --edit menu.  New commands are "addphoto",
	and "delphoto" (same as "deluid").

	* keylist.c (list_keyblock_print): show photos during key list if
	--show-photos enabled.

	* keyserver.c (keyserver_spawn): use the generic exec_xxx
	functions to call keyserver helper.

	* g10.c, options.h: three new options - --{no-}show-photos, and
	--photo-viewer to give the command line to display a picture.

	* options.skel: instructions for the photo viewer

	* parse-packet.c (parse_user_id, setup_user_id (new)): common code
	for both user IDs and attribute IDs moved to setup_user_id.

	* parse-packet.c (make_attribute_uidname (new)): constructs a fake
	"name" for attribute packets (e.g. "[image of size ...]")

	* parse-packet.c (parse_attribute (replaces parse_photo_id),
	parse_attribute_subpkts): Builds an array of individual
	attributes.  Currently only handles attribute image / type jpeg
	subpackets.

	* sign.c (hash_uid): Fix bug in signing attribute (formerly
	photo_id) packets.

	* packet.h, and callers: globally change "photo_id" to "attribute"
	and add structures for attributes.  The packet format is generic
	attributes, even though the only attribute type thus far defined
	is jpeg.

2001-12-21  David Shaw  <dshaw@jabberwocky.com>

	* parse-packet.c (can_handle_critical): Can handle critical
	revocation subpackets now.

	* trustdb.c (mark_usable_uid_certs): Disregard revocations for
	nonrevocable sigs.  Note that this allows a newer revocable
	signature to override an older nonrevocable signature.

	* sign.c (make_keysig_packet): add a duration field and change all
	callers.  This makes make_keysig_packet closer to
	write_signature_packets and removes some duplicated expiration
	code.

	* keyedit.c (keyedit_menu, menu_revsig, sign_uids,
	sign_mk_attrib): Add nrsign command, don't allow revoking a
	nonrevocable signature,

	* g10.c (main): Add --nrsign option to nonrevocably sign a key
	from the command line.

	* build-packet.c (build_sig_subpkt_from_sig): Comment to explain
	the use of CRITICAL.

2001-12-21  Werner Koch  <wk@gnupg.org>

	* g10.c. options.h : New option --show-keyring
	* getkey.c (get_ctx_handle): New.
	* keylist.c (list_one): Implement option here.  By David Champion.

2001-12-20  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (keyserver_spawn): Use mkdtemp() to make temp
	directory.

	* mkdtemp.c: replacement function for those platforms that don't
	have mkdtemp (make a temp directory securely).

2001-12-19  David Shaw  <dshaw@jabberwocky.com>

	* misc.c (check_permissions): New function to stat() and ensure
	the permissions of GNUPGHOME and the files have safe permissions.

	* keydb.c (keydb_add_resource): Check keyring permissions.

	* tdbio.c (tdbio_set_dbname): Check permissions of trustdb.gpg

	* keyserver.c (keyserver_spawn): Disable keyserver schemes that
	involve running external programs if the options file has unsafe
	permissions or ownership.

	* g10.c, options.h: New option --no-permission-warning to disable
	the permission warning message(s).  This also permits use of the
	keyserver if it had been disabled (see above).  Also check the
	permissions/ownership of random_seed.

	* keyserver.c (keyserver_spawn): The new glibc prints a warning
	when using mktemp() (the code was already secure, but the warning
	was bound to cause confusion).  Use a different implementation
	based on get_random_bits() instead.  Also try a few times to get
	the temp dir before giving up.

2001-12-19  Werner Koch  <wk@gnupg.org>

	* g10.c, passphrase.c [CYGWIN32]: Allow this as an alias for MINGW32.

2001-12-18  David Shaw  <dshaw@jabberwocky.com>

	* g10.c (idea_cipher_warn): Add a flag to show the warning always
	or once per session and change all callers (show always except for
	the secret key protection and unknown cipher from an encrypted
	message errors).  Also make the strings translatable.

	* pubkey-enc.c (get_it): Add the IDEA cipher warning if the user
	tries to decrypt an IDEA encrypted message without the IDEA
	plugin.

	* keyserver.c (parse_keyserver_uri): More strict checking of the
	keyserver URI.  Specifically, fail if the ":port" section is
	anything except a number between 1 and 65535.

2001-12-17  David Shaw  <dshaw@jabberwocky.com>

	* keyserver.c (print_keyinfo): No need to check for
	control/illegal characters, as utf8_to_native does this for us.

	* mainproc.c (proc_encrypted): Use generic IDEA warning.

	* gpgv.c: add stub for idea_cipher_warn

	* g10.c, hkp.c, keyserver.c: Fix capitalization and plural issues.

	* encode.c (encode_crypt), sign.c (sign_file, clearsign_file):
	disable pgp2 mode after the message is no longer pgp2 compatible.

	* g10.c (main): Tweak the PGP2.x IDEA warning to use the generic
	warning, and not merely fail if the IDEA plugin isn't there.

	* g10.c (main, idea_cipher_warn), keygen.c (set_one_pref),
	seckey-cert.c (do_check): Add a generic IDEA warning for when the
	IDEA plugin is not present.  This pops up when the user uses
	"--cipher-algo idea", when setpref is used to set a "S1"
	preference, and when a secret key protected with IDEA is used.

2001-12-15  Werner Koch  <wk@gnupg.org>

	* keyserver.c (keyserver_spawn): Assert that we have dropped privs.

2001-12-13  Werner Koch  <wk@gnupg.org>

	* pubkey-enc.c (get_session_key): Check that the public key
	algorithm is indeed usable for en/decryption.  This avoid a
	strange error message from pubkey_decrypt if for some reasons a
	bad algorithm indentifier is passed.

2001-12-12  David Shaw  <dshaw@jabberwocky.com>

	* Fixed some types for portability.  Noted by Stefan Bellon.

2001-12-11  Werner Koch  <wk@gnupg.org>

	* hkp.c (hkp_export): Do not print possible control characters
	from a keyserver response.
	(parse_hkp_index): Made uid an unsigned char* because it is passed to
	isspace().
	(hkp_search): Ditto for the char* vars.

	* g10.c (main): Print the IDEA warning also for -c and -se.

	* g10.c (get_temp_dir): Assert that we have dropped privs

	* encode.c (encode_crypt): Include the first key into the --pgp2
	check.

2001-12-07  David Shaw  <dshaw@jabberwocky.com>

	* g10.c, options.h: New option --pgp2.  This is identical to
	"--rfc1991 --cipher-algo idea --compress-algo 1 --digest-algo md5
	--force_v3_sigs" with the addition of an warning to advise the
	user not to use a pipe (which would break pgp2 compatibility).

	* encode.c (encode_crypt): warn if the user tries to encrypt to
	any key that is not RSA and <= 2048 bits when the --pgp2 option is
	used.

	* sign.c (sign_file, clearsign_file): When using --pgp2, make a v3
	sig, and warn if the signature is made with a non-v3 key.

2001-12-05  David Shaw  <dshaw@jabberwocky.com>

	* sign.c (sign_file, clearsign_file, sign_symencrypt_file): Prompt
